﻿using Microsoft.AspNet.SignalR;
using SYS_Core.aControl;
using System;
using System.Data;
using Oracle.ManagedDataAccess.Client;
using Newtonsoft.Json;
using System.Security.Claims;
using System.Security.Principal;

namespace SYSCore.SignalR
{
    public class HubData : Hub
    {

        private static DBOracle oOracledb = new DBOracle();
        private static IHubContext hubContext = GlobalHost.ConnectionManager.GetHubContext<HubData>();


        public void GetNoPick()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-100);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "N";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.nopick(ds);
        }
        public static void GetNoPickStatic()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-100);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "N";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.nopick(ds);
        }


        public void GetPicking()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-100);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "L";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.picking(ds);
        }
        public static void GetPickingStatic()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-100);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "L";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.picking(ds);
        }


        public void GetPicked()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-100);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "P";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.picked(ds);
        }

        public static void GetPickedStatic()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-100);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "P";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.picked(ds);
        }

        //------------------------------------//

        public void GetNoPickCust()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-10);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "N";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.nopickcust(ds);
        }
        public static void GetNoPickCustStatic()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-10);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "N";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.nopickcust(ds);
        }


        public void GetPickingCust()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-10);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "L";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.pickingcust(ds);
        }
        public static void GetPickingStaticCust()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-10);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "L";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.pickingcust(ds);
        }


        public void GetPickedCust()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-10);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "P";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.pickedcust(ds);
        }

        public static void GetPickedStaticCust()
        {
            DataSet ds = new DataSet();

            DateTime startDate = DateTime.Now.AddDays(-10);
            DateTime endDate = DateTime.Now;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = startDate;
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = endDate;
            cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "P";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.pickedcust(ds);
        }


      

        public static void GetDataPickTickerStatic()
        {

            hubContext.Clients.All.pickticker("DONE");
        }

        public static void GetDataCheckTickerStatic()
        {

            hubContext.Clients.All.checkticker("DONE");
        }

        public static void GetDataInvoiceTickerStatic()
        {

            hubContext.Clients.All.invoiceticker("DONE");
        }

        public void GetDataPick(string param)
        {
            dynamic json = JsonConvert.DeserializeObject(param);
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_DATA_PICK";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = "";//json.PICKING_LIST_NO;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.getdatapick(ds);
        }

        public void GetDataCheck(string param)
        {
            dynamic json = JsonConvert.DeserializeObject(param);
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_DATA_CHECK";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = json.PICKING_LIST_NO;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.getdatacheck(ds);
        }

        public void GetDataInvoice(string param)
        {
            dynamic json = JsonConvert.DeserializeObject(param);
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR016_GET_DATA_INVOICE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = json.PICKING_LIST_NO;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.getdatainvoice(ds);
        }

        public void GetReceiveLocal()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR009_RECEIVE_MONITOR_LOCAL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.receivelocal(ds);
        }


        public void GetReceiveImport()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR009_RECEIVE_MONITOR_IMPORT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.receiveimport(ds);
        }

        public static void GetReceiveLocalStatic()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR009_RECEIVE_MONITOR_LOCAL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.receivelocal(ds);
        }


        public static void GetReceiveImportStatic()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR009_RECEIVE_MONITOR_IMPORT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = "01";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            hubContext.Clients.All.receiveimport(ds);
        }

    }
}