﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Security.Claims;
using System.Web;

namespace SYS_Core.aControl
{
    public class DBManager
    {
        public DataTable SqlQuery(String pSQL, String DBName)
        {

            DataTable dt = new DataTable();
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + DBName
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];

            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    SqlCommand cmd = new SqlCommand(pSQL, conn);
                    conn.Open();
                    cmd.CommandTimeout = 0;
                    SqlDataReader rdr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                    dt.Load(rdr);
                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, pSQL);
                    throw (ex);

                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, pSQL);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return dt;
            }
        }

        public DataTable SqlEQuery(String pSQL, String DBName)
        {

            DataTable dt = new DataTable();
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBEServer"]
                            + ";database=" + DBName
                            + ";UID=" + ConfigurationManager.AppSettings["DBEUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBEPassword"];

            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    SqlCommand cmd = new SqlCommand(pSQL, conn);
                    conn.Open();
                    cmd.CommandTimeout = 0;
                    SqlDataReader rdr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                    dt.Load(rdr);
                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, pSQL);
                    throw (ex);

                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, pSQL);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return dt;
            }
        }

        public DataSet SqlQueryDS(String pSQL, String DBName)
        {
            DataSet ds = new DataSet();
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + DBName
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];

            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    SqlCommand cmd = new SqlCommand(pSQL, conn);
                    conn.Open();
                    cmd.CommandTimeout = 0;
                    // var command = new SqlCommand(InitializeQuery(), conn);
                    var adapter = new SqlDataAdapter(cmd);

                    adapter.Fill(ds);
                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, pSQL);
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, pSQL);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return ds;
            }
        }

        public DataSet SqlQueryDS(SqlCommand command, String DBName)
        {
            DataSet ds = new DataSet();
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + DBName
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];

            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    command.Connection = conn;
                    command.CommandTimeout = 0;

                    command.Connection.Open();
                    var adapter = new SqlDataAdapter(command);
                    adapter.Fill(ds);
                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, command.CommandText);
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, command.CommandText);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return ds;
            }
        }

        public int SqlExecute(String pSQL, String DBName)
        {
            int rowEffect = 0;
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + DBName // ConfigurationManager.AppSettings["DBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    SqlCommand command = new SqlCommand(pSQL, conn);
                    command.Connection.Open();
                    command.CommandTimeout = 0;
                    command.ExecuteNonQuery();
                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, pSQL);
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, pSQL);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return rowEffect;
            }
        }

        public int SqlExecute(SqlCommand command, String DBName)
        {
            int rowEffect = 0;
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + DBName // ConfigurationManager.AppSettings["DBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    command.Connection = conn;
                    command.Connection.Open();
                    command.CommandTimeout = 0;
                    command.ExecuteNonQuery();
                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, command.CommandText);
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, command.CommandText);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return rowEffect;
            }
        }

        public int WriteLog(String pType, String pMsg, String pEvd)
        {
            int rowEffect = 0;
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + ConfigurationManager.AppSettings["SysDBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    string gSQL;
                    string gUserID;

                    if (HttpContext.Current.User.Identity.IsAuthenticated == false)
                    {
                        gUserID = "null";
                    } else
                    {
                        gUserID = DataService.GetIdentity(HttpContext.Current.User, Cons.SS_USER_ID);
                    }

                    pType = pType.Replace("'", "''");
                    pMsg = pMsg.Replace("'", "''");
                    pEvd = pEvd.Replace("'", "''");

                    gSQL = "EXEC sp_SYS_Write_Log '{0}','{1}','{2}',{3}";
                    gSQL = String.Format(gSQL, pType, pMsg, pEvd, gUserID);



                    SqlCommand command = new SqlCommand(gSQL, conn);
                    command.Connection.Open();
                    command.CommandTimeout = 0;
                    command.ExecuteNonQuery();
                }
                catch (SqlException ex)
                {
                    // handle error
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return rowEffect;
            }
        }
        
        public int WriteMenuLog(String pFormID, String pUserName)
        {
            int rowEffect = 0;
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + ConfigurationManager.AppSettings["SysDBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    string gSQL;

                    string gUserID = DataService.GetIdentity(HttpContext.Current.User, Cons.SS_USER_ID);

                    gSQL = "EXEC sp_Menu_Log '{0}','{1}'";
                    gSQL = String.Format(gSQL, pFormID, pUserName);

                    SqlCommand command = new SqlCommand(gSQL, conn);
                    command.Connection.Open();
                    command.CommandTimeout = 0;
                    command.ExecuteNonQuery();
                }
                catch (SqlException ex)
                {
                    // handle error
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return rowEffect;
            }
        }

        public Boolean CheckToken (string Username, string Token, string RefreshToken)
        {
            string mDBConnection;
            bool result = false;
            DataTable dt = new DataTable();

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + ConfigurationManager.AppSettings["SysDBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    string gSQL;

                    gSQL = "EXEC sp_User_Token_Check '{0}',{1},{2}";
                    gSQL = String.Format(gSQL,
                                        Username,
                                        Token == null ? "null" : $"'{Token}'",
                                        RefreshToken == null ? "null" : $"'{RefreshToken}'");

                    SqlCommand cmd = new SqlCommand(gSQL, conn);
                    conn.Open();
                    cmd.CommandTimeout = 0;
                    SqlDataReader rdr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                    dt.Load(rdr);

                    result = dt.Rows[0]["RESULT"].ToString() == "VALID";
                }
                catch (SqlException ex)
                {
                    // handle error
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
            }

            return result;


        }

        public Boolean EnissanCheckToken (string Username, string Token, string RefreshToken)
        {
            string mDBConnection;
            bool result = false;
            DataTable dt = new DataTable();

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBEServer"]
                            + ";database=" + ConfigurationManager.AppSettings["SysDBEName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBEUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBEPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    string gSQL;

                    gSQL = "EXEC sp_User_Enissan_Token_Check '{0}',{1},{2}";
                    gSQL = String.Format(gSQL,
                                        Username,
                                        Token == null ? "null" : $"'{Token}'",
                                        RefreshToken == null ? "null" : $"'{RefreshToken}'");

                    SqlCommand cmd = new SqlCommand(gSQL, conn);
                    conn.Open();
                    cmd.CommandTimeout = 0;
                    SqlDataReader rdr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                    dt.Load(rdr);

                    result = dt.Rows[0]["RESULT"].ToString() == "VALID";
                }
                catch (SqlException ex)
                {
                    // handle error
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
            }

            return result;


        }

       
        public string RegisterToken (string Username, string Token, string RefreshToken, string NewToken, string NewRefreshToken, int? duration = null)
        {
            string mDBConnection;
            string result;
            DataTable dt = new DataTable();

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + ConfigurationManager.AppSettings["SysDBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    string gSQL;
                    int iDuration = duration ?? int.Parse(ConfigurationManager.AppSettings["TOKEN_DURATION"]) + int.Parse(ConfigurationManager.AppSettings["TOKEN_OFFSET"]);

                    gSQL = "EXEC sp_User_Token_Register '{0}',{1},{2},{3},{4},{5}";
                    gSQL = String.Format(gSQL, 
                                        Username,
                                        Token == null ? "null" : $"'{Token}'",
                                        RefreshToken == null ? "null" : $"'{RefreshToken}'",
                                        NewToken == null ? "null" : $"'{NewToken}'",
                                        NewRefreshToken == null ? "null" : $"'{NewRefreshToken}'",
                                        iDuration.ToString());

                    SqlCommand cmd = new SqlCommand(gSQL, conn);
                    conn.Open();
                    cmd.CommandTimeout = 0;
                    SqlDataReader rdr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                    dt.Load(rdr);

                    result = dt.Rows[0]["RESULT"].ToString();
                }
                catch (SqlException ex)
                {
                    // handle error
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
            }

            return result;

        }
        public DataTable SqlQuery_CMD(SqlCommand cmd, String DBConnection)
        {
            DataTable dt = new DataTable();

            using (SqlConnection conn = new SqlConnection(DBConnection))
            {
                try
                {
                    cmd.Connection = conn;
                    conn.Open();

                    cmd.CommandTimeout = 0;
                    SqlDataReader rdr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                    dt.Load(rdr);
                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, cmd.CommandText);
                    throw (ex);

                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, cmd.CommandText);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return dt;
            }
        }
    }
}