
using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using Oracle.ManagedDataAccess.Client;
using System.Web;

namespace SYS_Core.aControl
{
    public class DBOracle
    {
        private int attemptCount = 0;

        //private string oraConnectionString = "Data Source=(DESCRIPTION ="
        //        + "(ADDRESS = (PROTOCOL = TCP)(HOST = "
        //        + ConfigurationManager.AppSettings["ORCServer"] + ")(PORT = 1521))"
        //        + "(CONNECT_DATA =" + "(SERVER = DEDICATED)"
        //        + "(SERVICE_NAME = " + ConfigurationManager.AppSettings["ORCService"] + ")));"
        //        + "User Id=" + ConfigurationManager.AppSettings["ORCUser"] + ";"
        //        + "Password=" + ConfigurationManager.AppSettings["ORCPassword"] + ";";



        private string oraConnectionString = String.Format("DATA SOURCE={0};PERSIST SECURITY INFO=True;USER ID={1};PASSWORD={2};"
                                , ConfigurationManager.AppSettings["ORCConnection"]
                                , ConfigurationManager.AppSettings["ORCUser"]
                                , ConfigurationManager.AppSettings["ORCPassword"]);


        public DataTable SqlQuery(String pSQL)
        {

            DataTable dt = new DataTable();

            string oradb = oraConnectionString;


            // string connStr = oradb;

            using (OracleConnection objConn = new OracleConnection(oradb))
            {
                OracleCommand cmd = new OracleCommand();
                cmd.Connection = objConn;
                cmd.CommandText = pSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                //cmd.Parameters.Add("cIn", System.Data.OracleClient.OracleType.Int32).Value = 3; // Input id
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                try
                {
                    objConn.Open();
                    cmd.ExecuteNonQuery();
                    OracleDataAdapter da = new OracleDataAdapter(cmd);
                    da.Fill(dt);

                }
                catch (Exception ex)
                {
                    System.Console.WriteLine("Exception: {0}", ex.ToString());
                    WriteLog("SqlException", ex.Message, pSQL);
                }
                objConn.Close();
            }
            return dt;
        }


        public DataTable SqlGetShot(String pSQL)
        {
            DataTable dt = new DataTable();

            string oradb = oraConnectionString;


            // string connStr = oradb;

            using (OracleConnection objConn = new OracleConnection(oradb))
            {
                OracleCommand cmd = new OracleCommand();
                cmd.Connection = objConn;
                cmd.CommandText = pSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("c_Return", OracleDbType.Varchar2).Direction = ParameterDirection.Output;
                try
                {
                    objConn.Open();
                    cmd.ExecuteNonQuery();
                    OracleDataAdapter da = new OracleDataAdapter(cmd);

                    da.Fill(dt);

                }
                catch (Exception ex)
                {
                    System.Console.WriteLine("Exception: {0}", ex.ToString());
                    WriteLog("SqlException", ex.Message, pSQL);
                }
                objConn.Close();
            }
            return dt;
        }



        public DataSet SqlQueryDS(String pSQL)
        {
            DataSet ds = new DataSet();

            string oradb = oraConnectionString;


            // string connStr = oradb;

            using (OracleConnection objConn = new OracleConnection(oradb))
            {
                OracleCommand cmd = new OracleCommand();
                cmd.Connection = objConn;
                cmd.CommandText = pSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                //cmd.Parameters.Add("cIn", System.Data.OracleClient.OracleType.Int32).Value = 3; // Input id
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                try
                {
                    objConn.Open();
                    cmd.ExecuteNonQuery();
                    OracleDataAdapter da = new OracleDataAdapter(cmd);
                    da.Fill(ds);

                }
                catch (Exception ex)
                {
                    System.Console.WriteLine("Exception: {0}", ex.ToString());
                    WriteLog("SqlException", ex.Message, pSQL);

                }
                objConn.Close();
            }
            return ds;
        }


        public int SqlExecute(String pSQL)
        {
            int rowEffect = 0;
            // string mDBConnection;

            string oradb = oraConnectionString;


            using (OracleConnection conn = new OracleConnection(oradb))
            {
                try
                {
                    OracleCommand command = new OracleCommand(pSQL, conn);
                    command.Connection.Open();
                    command.CommandTimeout = 0;
                    command.ExecuteNonQuery();

                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, pSQL);
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, pSQL);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                    conn.Dispose();
                }
                return rowEffect;
            }
        }


        public int WriteLog(String pType, String pMsg, String pEvd)
        {
            int rowEffect = 0;
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + ConfigurationManager.AppSettings["SysDBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    string gSQL;

                    string gUserID = "";
                    if (HttpContext.Current == null || HttpContext.Current.User.Identity.IsAuthenticated == false)
                    {
                        gUserID = "null";
                    }
                    else
                    {
                        gUserID = DataService.GetIdentity(HttpContext.Current.User, Cons.SS_USER_ID);
                    }
                        //(ctx..Session[Cons.SS_USER_ID] != null) ? ctx.Session[Cons.SS_USER_ID].ToString() : "null";

                    pType = pType.Replace("'", "''");
                    pMsg = pMsg.Replace("'", "''");
                    pEvd = pEvd.Replace("'", "''");

                    gSQL = "EXEC sp_SYS_Write_Log '{0}','{1}','{2}','{3}'";
                    gSQL = String.Format(gSQL, pType, pMsg, pEvd, gUserID);



                    SqlCommand command = new SqlCommand(gSQL, conn);
                    command.Connection.Open();
                    command.CommandTimeout = 0;
                    command.ExecuteNonQuery();
                }
                catch (SqlException ex)
                {
                    // handle error
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return rowEffect;
            }
        }
        #region Sql with oracle command parameter

        public DataSet SqlQueryDS_CMD(OracleCommand cmd)
        {
            attemptCount++;

            //This method only receive parameter as OracleCommand.
            //Return parameter is required.

            DataSet ds = new DataSet();

            string oradb = oraConnectionString;

            using (OracleConnection objConn = new OracleConnection(oradb))
            {
                cmd.Connection = objConn;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.CommandTimeout = 1800;

                try
                {
                    objConn.Open();
                    //cmd.ExecuteNonQuery();
                    OracleDataAdapter da = new OracleDataAdapter(cmd);
                    da.Fill(ds);

                }
                catch (OracleException ex)
                {
                    //attempt to connect if error Package stage discard
                    if(ex.Number == 4068 && attemptCount <= 3)
                    {
                        objConn.Close();
                        return SqlQueryDS_CMD(cmd);
                    }

                    throw (ex);
                }
                catch (Exception ex)
                {
                    System.Console.WriteLine("Exception: s{0}", ex.ToString());
                    WriteLog("SqlException", ex.Message, "");

                    objConn.Close();
                    throw (ex);
                }
                objConn.Close();
            }
            return ds;
        }


        public OracleCommand SqlQueryReturnValue(OracleCommand cmd)
        {
            //This method only receive parameter as OracleCommand.
            //Return parameter is required.

            DataSet ds = new DataSet();

            string oradb = oraConnectionString;

            using (OracleConnection objConn = new OracleConnection(oradb))
            {
                cmd.Connection = objConn;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.CommandTimeout = 1800;

                try
                {
                    objConn.Open();
                    cmd.ExecuteNonQuery();
                    //OracleDataAdapter da = new OracleDataAdapter(cmd);
                    //da.Fill(ds);
                    objConn.Close();
                    return cmd;
                }
                catch (Exception ex)
                {
                    System.Console.WriteLine("Exception: s{0}", ex.ToString());
                    WriteLog("SqlException", ex.Message, "");
                    objConn.Close();
                    throw (ex);
                }
                objConn.Close();
            }
            return cmd;
        }

        public OracleCommand SqlExecute_CMD(OracleCommand cmd)
        {
            //This method only receive parameter as OracleCommand.
            //Return parameter is required.

            DataSet ds = new DataSet();

            string oradb = oraConnectionString;

            using (OracleConnection objConn = new OracleConnection(oradb))
            {
                cmd.Connection = objConn;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.CommandTimeout = 0;

                try
                {
                    objConn.Open();
                    cmd.ExecuteNonQuery();
                    objConn.Close();
                    return cmd;
                }
                catch (Exception ex)
                {
                    System.Console.WriteLine("Exception: s{0}", ex.ToString());
                    WriteLog("SqlException", ex.Message, "");
                    objConn.Close();
                    throw (ex);
                }
            }
            return cmd;
        }

        public DataTable SqlQueryText(OracleCommand cmd)
        {

            DataSet ds = new DataSet();
            DataTable dt;

            string oradb = oraConnectionString;

            using (OracleConnection objConn = new OracleConnection(oradb))
            {
                cmd.Connection = objConn;
                cmd.CommandType = CommandType.Text;
                cmd.CommandTimeout = 1800;

                try
                {
                    objConn.Open();
                    OracleDataAdapter da = new OracleDataAdapter(cmd);
                    da.Fill(ds);

                    dt = ds.Tables[0];
                }
                catch (Exception ex)
                {
                    System.Console.WriteLine("Exception: s{0}", ex.ToString());
                    WriteLog("SqlException", ex.Message, "");
                    objConn.Close();
                    throw (ex);
                }
                objConn.Close();
            }
            return dt;
        }

        public int InsertDataTable(DataTable dt,string sql)
        {
            string oradb = oraConnectionString;
            int rowCount = 0;
            using (OracleConnection objConn = new OracleConnection(oradb))
            {
                try
                {
                    objConn.Open();
                    using (OracleCommand cmd = new OracleCommand(sql, objConn))
                    {
                        cmd.CommandTimeout = 0;
                        using (OracleDataAdapter adapter = new OracleDataAdapter(cmd))
                        {
                            using (OracleCommandBuilder builder = new OracleCommandBuilder(adapter))
                            {
                                adapter.InsertCommand = builder.GetInsertCommand();
                                rowCount = adapter.Update(dt);
                            }
                        }
                    }
                }
                catch(Exception ex)
                {
                    System.Console.WriteLine("Exception: s{0}", ex.ToString());
                    WriteLog("SqlException", ex.Message, "");
                    objConn.Close();
                    throw (ex);
                }
                objConn.Close();
            }
            return rowCount;
        }

        public bool CheckBatchRunning()
        {
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_CHECK_BATCH_RUNNING";
            cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 10).Direction = ParameterDirection.Output;

            cmd = SqlQueryReturnValue(cmd);

            return cmd.Parameters["R_STATUS"].Value.ToString() == "Y";
        }

        public string GetErrorMessage(OracleException ex)
        {
            int firstColon = ex.Message.IndexOf(":") + 1;
            int firstNewLine = ex.Message.IndexOf("\n");
            string errString = ex.Message.Substring(firstColon, firstNewLine - firstColon);

            return errString.Trim();
        }
        #endregion
    }
}
