using Oracle.ManagedDataAccess.Client;
using SYS_Core.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.Cors;
using System.Collections;
using System.Web;
using System.Net.Sockets;
using System.Threading.Tasks;
using System.IO;
using System.Text;
using SYS_Core.aBiz;
using System.Globalization;
using SYSCore.aControl;
using SYSCore.ReportingService;
using RandomSolutions;
using System.Net.Http.Headers;
using Newtonsoft.Json;
using SYSCore.Attributes;
using ClosedXML.Excel;

namespace SYS_Core.Controllers
{
    [EnableCors("*", "*", "*")]
    [RoutePrefix("api/IC")]
    public class InventoryControlApiController : ApiController
    {
        private DBManager odb = new DBManager();
        private DBOracle oOracledb = new DBOracle();
        private String gSQL = "";
        private DataModel DataModel = new DataModel();
        private String mDBName = ConfigurationManager.AppSettings["SYSDBName"];


        //private String mDBName = ConfigurationManager.AppSettings["SYSDBName"];
        #region SNPP206

        [HttpPost, Route("SNPP206_GetData")]
        [Authorize]
        public IHttpActionResult SNPP206_GetData([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE;
            cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN5", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN6", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP206_GetPOConfirmOnDue")]
        [Authorize]
        public IHttpActionResult SNPP206_GetPOConfirmOnDue([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_PO_CONFIRM_ON_DUE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE_SEARCH;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE_SEARCH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP206_GetPOConfirmOverDue")]
        [Authorize]
        public IHttpActionResult SNPP206_GetPOConfirmOverDue([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_PO_CONFIRM_OVER_DUE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE_SEARCH;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE_SEARCH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP206_GetPONotConfirm")]
        [Authorize]
        public IHttpActionResult SNPP206_GetPONotConfirm([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_PO_NOT_CONFIRM";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE_SEARCH;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE_SEARCH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP206_GetETDConfirmOnDue")]
        [Authorize]
        public IHttpActionResult SNPP206_GetETDConfirmOnDue([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_ETD_CONFIRM_ON_DUE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE_SEARCH;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE_SEARCH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP206_GetETDConfirmOverDue")]
        [Authorize]
        public IHttpActionResult SNPP206_GetETDConfirmOverDue([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_ETD_CONFIRM_OVER_DUE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE_SEARCH;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE_SEARCH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP206_GetETDNotConfirm")]
        [Authorize]
        public IHttpActionResult SNPP206_GetETDNotConfirm([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_ETD_NOT_CONFIRM";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE_SEARCH;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE_SEARCH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP206_GetOverDueNotice")]
        [Authorize]
        public IHttpActionResult SNPP206_GetOverDueNotice([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_OVERDUE_NOTICE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP206_GetOverDueNoticeByPO")]
        [Authorize]
        public IHttpActionResult SNPP206_GetOverDueNoticeByPO([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP206_GET_OVERDUE_NOTICE_BY_PO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = param.PO_NO;
            cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = param.ACCEPT_PART_NO;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE_SEARCH;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE_SEARCH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        


        #endregion

        #region SNPP204
        [HttpPost, Route("SNPP204_GetData")]
        [Authorize]
        public IHttpActionResult SNPP204_GetData([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP204_GET_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = param.VENDOR_TYPE;
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = param.FROM_DATE;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = param.TO_DATE;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNPP204_GetDetail")]
        [Authorize]
        public IHttpActionResult SNPP204_GetDetail([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP204_GET_DETAIL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            DataTable dt = new DataTable();
            gSQL = "EXEC [sp_CONF_Grid_List] '{0}','{1}' ";
            gSQL = String.Format(gSQL, "SNPP204_DETAIL", DataService.GetIdentity(User, Cons.SS_USER_LANG));
            dt = odb.SqlQuery(gSQL, mDBName);
            dt.TableName = "Table3";
            ds.Tables.Add(dt);
            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNPP204_GetDataPart")]
        [Authorize]
        public IHttpActionResult SNPP204_GetDataPart([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP204_GET_DATA_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNPP204_GetDataVendorCode")]
        [Authorize]
        public IHttpActionResult SNPP204_GetDataVendorCode([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP204_GET_DATA_VENDOR_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = param.VENDOR_TYPE;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNPP204_SaveStandard")]
        [Authorize]
        public IHttpActionResult SNPP204_SaveStandard([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            try
            {
                var json = JsonConvert.SerializeObject(param);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPP204_SAVE_STANDARD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DATA", OracleDbType.Varchar2).Value = json;
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                oOracledb.SqlQueryReturnValue(cmd);
                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                return Json(new { STATUS = R_STATUS});
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPP204_SaveStandard");
                return Json(new { STATUS = "FAIL" });
            }
        }
        [HttpPost, Route("SNPP204_Download")]
        [Authorize]
        public HttpResponseMessage SNPP204_Download([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP204_GET_DATA_DOWNLOAD";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            HttpResponseMessage response = new HttpResponseMessage();
            try
            {
                string fileName = "SNPP204.xlsx";
                string gLocation = "~/tempFile/" + "SNPP204" + "/";
                string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);
                FileInfo filePath = new FileInfo(gWriteLocation);
                filePath.Directory.Create();
                string gFileLocation = Path.Combine(gWriteLocation, fileName);
                using (XLWorkbook wb = new XLWorkbook())
                {
                    var workbook = wb.Worksheets.Add(dt, "sheet1");
                    workbook.Table("sheet1").ShowAutoFilter = false;
                    workbook.Table("sheet1").Theme = XLTableTheme.None;
                    using (MemoryStream stream = new MemoryStream())
                    {
                        wb.SaveAs(stream);
                        File.WriteAllBytes(gFileLocation, stream.ToArray());
                    }
                }
                string mimeType = MimeMapping.GetMimeMapping(fileName);
                StreamContent x = new StreamContent(new FileStream(gFileLocation, FileMode.Open, FileAccess.Read));
                response.Content = x;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue(mimeType);
                response.Content.Headers.ContentDisposition = new ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = fileName;
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPP204_Download");
                return Request.CreateResponse(HttpStatusCode.BadRequest, ex);
            }
            return response;
        }
        #endregion
        #region SNPP203
        [HttpPost, Route("SNPP203_GetData")]
        [Authorize]
        public IHttpActionResult SNPP203_GetData([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP203_GET_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = param.VENDOR_CODE;
            cmd.Parameters.Add("P_PIC", OracleDbType.Varchar2).Value = param.PIC;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP203_CreatePO")]
        [Authorize]
        public IHttpActionResult SNPP203_CreatePO(List<DataModel.SNPP203_CREATE_PO> param)
        {
            DataSet ds = new DataSet();
            string fromPO = "", toPO = "";
            try
            {
                var json = JsonConvert.SerializeObject(param);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPP203_CREATE_PO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PO_DATA", OracleDbType.Varchar2).Value = json;
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2,50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_FROM_PO", OracleDbType.Varchar2, 6).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_TO_PO", OracleDbType.Varchar2, 6).Direction = ParameterDirection.Output;
                oOracledb.SqlQueryReturnValue(cmd);
                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                if(R_STATUS == "DONE")
                {
                    fromPO = cmd.Parameters["R_FROM_PO"].Value.ToString();
                    toPO = cmd.Parameters["R_TO_PO"].Value.ToString();
                }

                return Json(new { STATUS = R_STATUS ,FROM_PO = fromPO,TO_PO = toPO});
            }
            catch(Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPP203_CreatePO");
                return Json(new { STATUS = "FAIL" });
            }

        }

        #endregion SNPP203
        #region SNM144P
        [HttpPost, Route("SNM144P_UploadExcel")]
        [Authorize]
        public async Task<IHttpActionResult> SNM144P_UploadExcel(HttpRequestMessage request)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                oOracledb.WriteLog("ErrorHandle", "UnsupportedMediaType", "SNM144P_UploadExcel");
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                var reqParts = await request.Content.ReadAsMultipartAsync();
                byte[] buffer = null;
                foreach (var file in reqParts.Contents)
                {
                    buffer = file.ReadAsByteArrayAsync().Result;
                }
                MemoryStream stream = new MemoryStream(buffer);
                SystemApiController sys = new SystemApiController();
                dt = SNM144P_Validate(stream);
                return Json(DTFM.convertToList(dt));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM144P_UploadExcel");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
            throw new Exception("Something wrong");
        }
        public DataTable SNM144P_Validate(MemoryStream filestream)
        {
            DataTable dt = new DataTable();
            SystemApiController sys = new SystemApiController();
            dt = sys.ReadDataExcel(filestream);
            dt.Columns.Add("SEQ");
            dt.Columns.Add("MSG");
            dt.Columns.Add("ERR_MSG_TARIFF");
            dt.Columns.Add("ERR_MSG_DUTY");
            dt.Columns.Add("ERR_MSG_WEIGHT");
            dt.Columns.Add("ERR_FLAG");
            dt.Columns.Add("ERR_FLAG_INVOICE");
            dt.Columns.Add("ERR_FLAG_TARIFF");
            dt.Columns.Add("ERR_FLAG_DUTY");
            dt.Columns.Add("ERR_FLAG_WEIGHT");
            dt.Columns.Add("ERR_FLAG_PART");
            dt.Columns.Add("ERR_MSG_PART");
            int iCount = 0;
            Hashtable hTable = new Hashtable();
            Hashtable hTableTariff = new Hashtable();
            Hashtable hTableDuty = new Hashtable();
            Hashtable hTableInvoice = new Hashtable();
            OracleCommand cmd = new OracleCommand();
            foreach (DataRow d in dt.Rows)
            {
                if (!string.IsNullOrEmpty(d["PART_NO"].ToString()))
                {
                    iCount++;
                    try
                    {
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNM144P_VALIDATE";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = d["INVOICE_NO"].ToString().Trim(); ;
                        cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"];
                        cmd.Parameters.Add("P_TARIFF_CODE", OracleDbType.Varchar2).Value = d["TARIFF_CODE"];
                        cmd.Parameters.Add("P_DUTY_RATE", OracleDbType.Varchar2).Value = d["DUTY_RATE"];
                        cmd.Parameters.Add("P_NET_WEIGHT", OracleDbType.Varchar2).Value = d["NET_WEIGHT"];
                        cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Varchar2).Value = d["ACCEPT_QTY"];
                        cmd.Parameters.Add("R_ERR_FLAG", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_FLAG_INVOICE", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_FLAG_TARIFF", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_FLAG_DUTY", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_FLAG_WEIGHT", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_FLAG_PART", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_MESSAGE", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_MSG_TARIFF", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_MSG_DUTY", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_MSG_WEIGHT", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERR_MSG_PART", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd = oOracledb.SqlQueryReturnValue(cmd);
                        string ERROR_FLAG = cmd.Parameters["R_ERR_FLAG"].Value.ToString();
                        string ERROR_FLAG_INVOICE = cmd.Parameters["R_ERR_FLAG_INVOICE"].Value.ToString();
                        string ERROR_FLAG_TARIFF = cmd.Parameters["R_ERR_FLAG_TARIFF"].Value.ToString();
                        string ERROR_FLAG_DUTY = cmd.Parameters["R_ERR_FLAG_DUTY"].Value.ToString();
                        string ERROR_FLAG_WEIGHT = cmd.Parameters["R_ERR_FLAG_WEIGHT"].Value.ToString();
                        string ERROR_FLAG_PART = cmd.Parameters["R_ERR_FLAG_PART"].Value.ToString();
                        string MSG = cmd.Parameters["R_ERR_MESSAGE"].Value.ToString() == "null" ? (string)null : cmd.Parameters["R_ERR_MESSAGE"].Value.ToString();
                        string ERROR_MSG_TARIFF = cmd.Parameters["R_ERR_MSG_TARIFF"].Value.ToString() == "null" ? (string)null : cmd.Parameters["R_ERR_MSG_TARIFF"].Value.ToString();
                        string ERROR_MSG_DUTY = cmd.Parameters["R_ERR_MSG_DUTY"].Value.ToString() == "null" ? (string)null : cmd.Parameters["R_ERR_MSG_DUTY"].Value.ToString();
                        string ERROR_MSG_WEIGHT = cmd.Parameters["R_ERR_MSG_WEIGHT"].Value.ToString() == "null" ? (string)null : cmd.Parameters["R_ERR_MSG_WEIGHT"].Value.ToString();
                        string ERROR_MSG_PART = cmd.Parameters["R_ERR_MSG_PART"].Value.ToString() == "null" ? (string)null : cmd.Parameters["R_ERR_MSG_PART"].Value.ToString();
                        d["SEQ"] = iCount;
                        d["ERR_FLAG"] = ERROR_FLAG;
                        d["ERR_FLAG_INVOICE"] = ERROR_FLAG_INVOICE;
                        d["ERR_FLAG_TARIFF"] = ERROR_FLAG_TARIFF;
                        d["ERR_FLAG_DUTY"] = ERROR_FLAG_DUTY;
                        d["ERR_FLAG_WEIGHT"] = ERROR_FLAG_WEIGHT;
                        d["ERR_FLAG_PART"] = ERROR_FLAG_PART;
                        d["MSG"] = MSG;
                        d["ERR_MSG_TARIFF"] = ERROR_MSG_TARIFF;
                        d["ERR_MSG_DUTY"] = ERROR_MSG_DUTY;
                        d["ERR_MSG_WEIGHT"] = ERROR_MSG_WEIGHT;
                        d["ERR_MSG_PART"] = ERROR_MSG_PART;
                        
                        if (hTable.Contains(d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString().Trim()))
                        {
                            var duty1 = hTableDuty[d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString().Trim()].ToString();
                            var duty2 = d["DUTY_RATE"].ToString();
                            var tariff1 = hTableTariff[d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString().Trim()].ToString();
                            var tariff2 = d["TARIFF_CODE"].ToString();
                            if (duty1 != duty2)
                            {
                                d["MSG"] = "Duty rate not eqaul at Seq " + hTable[d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString()];
                                d["ERR_MSG_DUTY"] = "Duty rate not eqaul at Seq " + hTable[d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString()]; 
                                d["ERR_FLAG_DUTY"] = "Y"; 
                            }
                            else if (tariff1 != tariff2)
                            {
                                d["MSG"] = "Tariff code not eqaul at Seq " + hTable[d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString()];
                                d["ERR_MSG_TARIFF"] = "Tariff code not eqaul at Seq " + hTable[d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString()];
                                d["ERR_FLAG_TARIFF"] = "Y";
                            }
                        }
                        else
                        {
                            hTable.Add(d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString().Trim(), iCount);
                            hTableDuty.Add(d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString().Trim(), d["DUTY_RATE"]);
                            hTableTariff.Add(d["PART_NO"].ToString().Trim() + d["INVOICE_NO"].ToString().Trim(), d["TARIFF_CODE"]);
                        }
                    }
                    catch (Exception ex)
                    {
                        oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM144P_Validate");
                        throw new HttpResponseException(HttpStatusCode.NotAcceptable);
                    }
                }
            }
            return dt;
        }
        [HttpPost, Route("SNM144P_UpdateData")]
        [Authorize]
        public IHttpActionResult SNM144P_UpdateData([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                OracleCommand cmd = new OracleCommand();
                int iCount = 0;
                foreach (dynamic d in data.DETAIL)
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM144P_SAVE_TEMP";
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = d["INVOICE_NO"];
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"];
                    cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Varchar2).Value = d["ACCEPT_QTY"];
                    cmd.Parameters.Add("P_TARIFF_CODE", OracleDbType.Varchar2).Value = d["TARIFF_CODE"];
                    cmd.Parameters.Add("P_DUTY_RATE", OracleDbType.Varchar2).Value = d["DUTY_RATE"];
                    cmd.Parameters.Add("P_NET_WEIGHT", OracleDbType.Varchar2).Value = d["NET_WEIGHT"];
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM144P_UPDATE_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_IS_TARIFF", OracleDbType.Varchar2).Value = data.IS_TARIFF;
                cmd.Parameters.Add("P_IS_DUTY", OracleDbType.Varchar2).Value = data.IS_DUTY;
                cmd.Parameters.Add("P_IS_WEIGHT", OracleDbType.Varchar2).Value = data.IS_WEIGHT;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();
                if (r_status != "DONE")
                {
                    oOracledb.WriteLog("ErrorHandle", r_msg, "SNM144P_UpdateData");
                }
                return Json(new { STATUS = r_status, MESSAGE = r_msg });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM144P_UpdateData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        #endregion
        #region InventoryReport
        [HttpPost, Route("BO_Release_Generate")]
        [Authorize]
        public HttpResponseMessage SNSE064_RunningNo([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "PK_NP_SO_RELEASE_SIMULATE.MAIN_PROCESS";
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlExecute_CMD(cmd);
                response = BO_Release_Download();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "BO_Release_Generate");
                return Request.CreateResponse(HttpStatusCode.BadRequest, ex);
            }
            return response;
        }
        public HttpResponseMessage BO_Release_Download()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "PK_NP_SO_RELEASE_SIMULATE.GET_SIMULATION_RESULT";
            cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("PO_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            foreach(DataColumn col in dt.Columns)
            {
                col.ColumnName = col.ColumnName.Replace("'", string.Empty);
            }
            HttpResponseMessage response = new HttpResponseMessage();
            try
            {
                string fileName = "BO_Release" + DataService.GetIdentity(User, Cons.SS_USER_NAME) + ".xlsx";
                string gLocation = "~/tempFile/" + "BO_RELEASE" + "/";
                string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);
                FileInfo filePath = new FileInfo(gWriteLocation);
                filePath.Directory.Create();
                string gFileLocation = Path.Combine(gWriteLocation, fileName);
                using (XLWorkbook wb = new XLWorkbook())
                {
                    wb.Worksheets.Add(dt, "sheet1");
                    using (MemoryStream stream = new MemoryStream())
                    {
                        wb.SaveAs(stream);
                        File.WriteAllBytes(gFileLocation, stream.ToArray());
                    }
                }
                string mimeType = MimeMapping.GetMimeMapping(fileName);
                StreamContent x = new StreamContent(new FileStream(gFileLocation, FileMode.Open, FileAccess.Read));
                response.Content = x;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue(mimeType);
                response.Content.Headers.ContentDisposition = new ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = fileName;
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "BO_Release_Download");
                return Request.CreateResponse(HttpStatusCode.BadRequest, ex);
            }
            return response;
        }
        #endregion

        #region SNSE064

        [HttpPost, Route("SNSE064_GetDocList/{docno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSE064_GetDocList(string docno, int noofshowrec, [FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            docno = ismoUtil.escapeCharacter(docno);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_GET_DOC";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = docno.ToUpper() == "NULL" ? (object)DBNull.Value : docno;
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = param.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = param.BRANCH_CODE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_GetDocList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNSE064_RunningNo/{running}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSE064_RunningNo(string running, int noofshowrec)
        {
            DataSet ds = new DataSet();

            running = ismoUtil.escapeCharacter(running);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_GET_RUNNING";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RUNNING_NO", OracleDbType.Varchar2).Value = running.ToUpper() == "NULL" ? (object)DBNull.Value : running;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_RunningNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpGet, Route("SNSE064_Customer/{customer}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSE064_Customer(string customer, int noofshowrec)
        {
            DataSet ds = new DataSet();

            customer = ismoUtil.escapeCharacter(customer);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_GET_CUSTOMER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = customer.ToUpper() == "NULL" ? (object)DBNull.Value : customer;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_Customer");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE064_GetBranch/{branch}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSE064_GetBranch(string branch, int noofshowrec, [FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            branch = ismoUtil.escapeCharacter(branch);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_GET_BRANCH";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = param.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = branch.ToUpper() == "NULL" ? (object)DBNull.Value : branch;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_GetBranch");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNSE064_GetPart/{part}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSE064_GetPart(string part, int noofshowrec, [FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            part = ismoUtil.escapeCharacter(part);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_GET_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_TYPE", OracleDbType.Varchar2).Value = param.DOCUMENT_TYPE;
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = param.DOCUMENT_NO;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part.ToUpper() == "NULL" ? (object)DBNull.Value : part;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_GetPart");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE064_GetData")]
        [Authorize]
        public IHttpActionResult SNSE064_GetData([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RUNNING_NO", OracleDbType.Varchar2).Value = param.RUNNING_NO;
                cmd.Parameters.Add("P_DOC_DATE", OracleDbType.Varchar2).Value = param.DOC_DATE;
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = param.CUSTOMER_CODE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNSE064_GetDetail/{running}")]
        [Authorize]
        public IHttpActionResult SNSE064_GetDetail(string running)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RUNNING_NO", OracleDbType.Varchar2).Value = running;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNSE064_GetDefactive")]
        [Authorize]
        public IHttpActionResult SNSE064_GetDefactive()
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_GET_DEFECTIVE";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_GetDefactive");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE064_Save")]
        [Authorize]
        public IHttpActionResult SNSE064_Save([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            int iCount = 0;
            try
            {

                foreach (dynamic d in data.DETAIL)
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNSE064_SAVE_TEMP";
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = d["ITEM_NO"];
                    cmd.Parameters.Add("P_DO_NO", OracleDbType.Varchar2).Value = d["DO_NO"];
                    cmd.Parameters.Add("P_DO_DATE", OracleDbType.Date).Value = d["DO_DATE"];
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"];
                    cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = d["LOCATION_NO"];
                    cmd.Parameters.Add("RT_QTY", OracleDbType.Varchar2).Value = d["RT_QTY"];
                    cmd.Parameters.Add("ATTRIBUTE2", OracleDbType.Varchar2).Value = d["ATTRIBUTE2"];
                    cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 200).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_RUNNING_NO", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();
                string r_running = cmd.Parameters["R_RUNNING_NO"].Value.ToString();

                if (r_status != "DONE")
                {
                    oOracledb.WriteLog("ErrorHandle", r_msg, "SNSE064_Save");
                }

                return Json(new { STATUS = r_status, MESSAGE = r_msg, RUNNING_NO = r_running });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        #endregion
        #region SNPE002
        [HttpGet, Route("SNPE002_GetCPSData/{vendorcode?}")]
        [Authorize]
        public IHttpActionResult SNPE002_GetCPSData(string vendorcode = null)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNPE002_TPM_POST_QUERY";
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode;
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPE002_SaveCPSData")]
        [Authorize]
        public IHttpActionResult SNPE002_SaveCPSData([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "sp_NP_SNPE002_SK_SAVE";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = data["VENDOR_CODE"];
                cmd.Parameters.Add("p_PO_NO", OracleDbType.Varchar2).Value = data["PO_NO"];
                cmd.Parameters.Add("p_PO_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["PO_DATE"]);
                cmd.Parameters.Add("p_SEND_DATA_FLAG", OracleDbType.Varchar2).Value = data["SEND_DATA_FLAG"];
                cmd.Parameters.Add("p_OLD_SENDDATA_FLAG", OracleDbType.Varchar2).Value = data["OLD_SENDDATA_FLAG"];
                cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                {
                    string errString = data["PO_NO"].ToString() + "/\n" + dt.Rows[0]["MESSAGE"].ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }

            }

            return Ok("Done");
        }
        #endregion

        #region SNPJ005_DRG
        [HttpGet, Route("SNPJ005_DRG_GetFilePath")]
        [Authorize]
        public IHttpActionResult SNPJ005_DRG_GetFilePath()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPJ005_DRG_FORM_INSTNCE";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        [HttpPost, Route("SNPJ005_DRG_BeginProcess")]
        [Authorize]
        public IHttpActionResult SNPJ005_DRG_BeginProcess()
        {
            DataSet ds = new DataSet();

            //Check daily process status
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPJ005_DRG_Begin_Proc";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            DataTable dtBeginStatus = ds.Tables[0];

            if (dtBeginStatus.Rows[0]["STATUS"].ToString() == "Reject")
            {
                string errString = dtBeginStatus.Rows[0]["MESSAGE"].ToString();
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            }
            else if (dtBeginStatus.Rows[0]["STATUS"].ToString() == "Ready")
            {
                //Begin process
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPJ005_DRG_Process";
                cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("c_SNPP033_DATA", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("c_SNPP033_FILE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                DataTable dtProcessStatus = ds.Tables[0];

                if (dtProcessStatus.Rows[0]["STATUS"].ToString() == "Done")
                {
                    //Set data table for generate order file
                    DataTable dtSNP033File = ds.Tables[1];
                    DataTable dtSNP033Data = ds.Tables[2];
                    string gFileHeaderName = dtSNP033File.Rows[0]["W_FTPC"].ToString();
                    string gFileDetailName = dtSNP033File.Rows[0]["W_FTPD"].ToString();

                    string gCategory = "SNPJ005_DRG/Out";

                    //Write and get file path.
                    string gHeaderPath = DataService.WriteFile(dtSNP033File, "W_ITEMC", gCategory, gFileHeaderName);
                    string gDetailPath = DataService.WriteFile(dtSNP033Data, "TEXT", gCategory, gFileDetailName);

                    var fileHeader = DataService.GetFileStream(gHeaderPath, gFileHeaderName);
                    var fileDetail = DataService.GetFileStream(gDetailPath, gFileDetailName);

                    return Ok(new { Header = new { filename = gFileHeaderName, file = fileHeader }, Detail = new { filename = gFileDetailName, file = fileDetail } });

                }
                else
                {
                    string errString = dtProcessStatus.Rows[0]["MESSAGE"].ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }
            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, "Something wrong in process."));

        }
        #endregion

        #region SNPJ006_D0

        [HttpGet, Route("SNPJ006_D0_GetFilePath")]
        [Authorize]
        public IHttpActionResult SNPJ006_D0_GetFilePath()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNPJ006_D0_FORM_INSTANT";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpPost, Route("SNPJ006_D0_SaveFile")]
        [Authorize]
        public async Task<IHttpActionResult> SNPJ006_D0_SaveFile(HttpRequestMessage request)
        {
            string gFilesName = "";
            string gRootPath = ConfigurationManager.AppSettings["RootSharedPath"].ToString();
            string gUploadLication = System.IO.Path.Combine(gRootPath, "tempFile/SNPJ006");
            string gBackupLocation = System.IO.Path.Combine(gUploadLication, "Backup");

            OracleCommand cmd = new OracleCommand();

            //Check multipart content
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }

            var reqParts = await request.Content.ReadAsMultipartAsync();

            //Write file to shared path
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPJ006_D0_CLEAR_TEMP";

                oOracledb.SqlQueryReturnValue(cmd);

                foreach (var file in reqParts.Contents)
                {

                    var buffer = await file.ReadAsByteArrayAsync();

                    string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                    string gFileLocation = System.IO.Path.Combine(gUploadLication, gFileName);

                    DataService.SaveBytesToFileByLocation(buffer
                                                    , gUploadLication
                                                    , gFileLocation);

                    string[] lines = System.IO.File.ReadAllLines(gFileLocation);

                    foreach (string line in lines)
                    {
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNPJ006_D0_SNPP033";
                        cmd.Parameters.Add("P_DATA", OracleDbType.Varchar2).Value = line;
                        cmd.Parameters.Add("P_FNAME", OracleDbType.Varchar2).Value = gFileName;
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                        oOracledb.SqlQueryReturnValue(cmd);
                    }
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPJ006_D0_SaveFile");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            //Begin process backup date to table.

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPJ006_D0_BACKUP_DATA";
            cmd.Parameters.Add("P_FILE_NAME", OracleDbType.Varchar2).Value = gFilesName;
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];

            if (dt.Rows[0]["STATUS"].ToString() == "Done")
            {
                foreach (var file in new DirectoryInfo(gUploadLication).GetFiles())
                {
                    var dateStr = DateTime.Now.ToString("yyyyMMddHHmmss");
                    string fileName = file.Name.Replace(file.Extension, "") + "." + dateStr + file.Extension.Trim('.');
                    file.MoveTo($@"{gBackupLocation}\{fileName}");
                }
            }

            return Ok(dt.Rows[0]["MESSAGE"].ToString());
        }

        #endregion

        #region SNPJ006_D1

        [HttpGet, Route("SNPJ006_D1_GetFilePath")]
        [Authorize]
        public IHttpActionResult SNPJ006_D1_GetFilePath()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNPJ006_D1_FORM_INSTANT";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNPJ006_D1_BeginProcess")]
        [Authorize]
        public IHttpActionResult SNPJ006_D1_BeginProcess()
        {
            DataSet ds = new DataSet();
            string returnMessage;
            string status;
            try
            {

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPJ006_D1_START_JOB";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                DataTable dtProcessStatus = ds.Tables[0];

                returnMessage = dtProcessStatus.Rows[0]["MESSAGE"].ToString();
                status = dtProcessStatus.Rows[0]["STATUS"].ToString();

                if (status == "Fail")
                {
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, returnMessage));
                }
                else if (status == "Done" || status == "CALL_SNPJ006_D2")
                {
                    return Ok(new { status = status, message = returnMessage });
                }
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Ok(new { status = "Fail", message = ex.Message.Replace("ORA-20001: ", "") });
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPJ006_D1_BeginProcess");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, "Something wrong in process."));
        }
        #endregion

        #region SNM112P


        [HttpPost, Route("SNM112P_SEARCH_RESULT")]
        [Authorize]
        public IHttpActionResult SNM112P_SEARCH_RESULT([FromBody] dynamic SRM)
        {
            DataSet ds = new DataSet();

            string gSQL = "SP_NP_SNM112P_PG_SEARCH_RESULT";

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("I_PART_NO", OracleDbType.Varchar2).Value = SRM.PART_NO;
            cmd.Parameters.Add("I_VENDOR_CODE", OracleDbType.Varchar2).Value = SRM.VENDOR_CODE;
            cmd.Parameters.Add("I_COMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
            cmd.Parameters.Add("I_ONLY_EXIST", OracleDbType.Varchar2).Value = SRM.ONLY_EXIST.ToString();


            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        [HttpPost, Route("SNM112P_SavePart")]
        [Authorize]
        public IHttpActionResult SNM112P_SavePart([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string CURRENT_FORM = "SNM112P";
            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "sp_NP_SNM112P_SAVE";
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = data["COMPANY_CODE"].ToString();
                cmd.Parameters.Add("pPART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                cmd.Parameters.Add("pCURRENT_FORM", OracleDbType.Varchar2).Value = CURRENT_FORM;
                cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                {
                    string errString = dt.Rows[0]["MESSAGE"].ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }

            }

            return Ok("Done");
        }


        [HttpPost, Route("SNM112P_DeletePart")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM112P_DeletePart([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "sp_NP_SNM112P_DELETE";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = data["COMPANY_CODE"].ToString();
                cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                {
                    string errString = dt.Rows[0]["MESSAGE"].ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }

            }

            return Ok("Done");
        }

        #endregion



        #region SNM107P
        [HttpPost, Route("SNM107P_Getdata")]
        [Authorize]
        public IHttpActionResult SNM107P_Getdata([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            string gSQL = "SP_NP_SNM107P_GET_DATA";

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pParam.PART_NO.ToString();
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam.VENDOR_CODE.ToString();
            cmd.Parameters.Add("P_ONLY_EXIST", OracleDbType.Varchar2).Value = pParam.ONLY_EXIST.ToString();
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }


        [HttpPost, Route("SNM107P_Save")]
        [Authorize]
        public IHttpActionResult SNM107P_Save([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string CURRENT_FORM = "SNM107P";
            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM107P_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                cmd.Parameters.Add("P_CURRENT_FORM", OracleDbType.Varchar2).Value = CURRENT_FORM;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LEADTIME_ON", OracleDbType.Varchar2).Value = data["PART_LT_ON"].ToString(); ;
                cmd.Parameters.Add("P_LEADTIME_ON", OracleDbType.Varchar2).Value = data["PART_LT_OFF"].ToString(); ;
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                if (dt.Rows[0]["STATUS"].ToString() == "FAIL")
                {
                    string errString = dt.Rows[0]["MESSAGE"].ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }
            }

            return Ok("DONE");
        }

        [HttpPost, Route("SNM107P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM107P_Delete([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM107P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                if (dt.Rows[0]["STATUS"].ToString() == "FAIL")
                {
                    string errString = dt.Rows[0]["MESSAGE"].ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }
            }

            return Ok("DONE");
        }
        #endregion

        #region SNM056S
        [HttpGet, Route("SNM056S_GetCalendar/{PROCESS_YEAR}")]
        [Authorize]
        public IHttpActionResult SNM056S_GetCalendar(string PROCESS_YEAR)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM056S_PG_GET_CALENDAR";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
            cmd.Parameters.Add("pPROCESS_YEAR", OracleDbType.Varchar2).Value = PROCESS_YEAR;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pIP_ADRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM056S_UpdateCalendar")]
        [Authorize]
        public IHttpActionResult SNM056S_UpdateCalendar([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();


            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM056S_UPDATE_CALENDAR";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
            cmd.Parameters.Add("pPROCESS_YEAR", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().PROCESS_YEAR.ToString();
            cmd.Parameters.Add("pPROCESS_MONTH", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().PROCESS_MONTH.ToString();
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pIP_ADRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
            cmd.Parameters.Add("pDATE_STATUS_01", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_01.ToString();
            cmd.Parameters.Add("pDATE_STATUS_02", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_02.ToString();
            cmd.Parameters.Add("pDATE_STATUS_03", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_03.ToString();
            cmd.Parameters.Add("pDATE_STATUS_04", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_04.ToString();
            cmd.Parameters.Add("pDATE_STATUS_05", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_05.ToString();
            cmd.Parameters.Add("pDATE_STATUS_06", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_06.ToString();
            cmd.Parameters.Add("pDATE_STATUS_07", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_07.ToString();
            cmd.Parameters.Add("pDATE_STATUS_08", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_08.ToString();
            cmd.Parameters.Add("pDATE_STATUS_09", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_09.ToString();
            cmd.Parameters.Add("pDATE_STATUS_10", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_10.ToString();
            cmd.Parameters.Add("pDATE_STATUS_11", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_11.ToString();
            cmd.Parameters.Add("pDATE_STATUS_12", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_12.ToString();
            cmd.Parameters.Add("pDATE_STATUS_13", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_13.ToString();
            cmd.Parameters.Add("pDATE_STATUS_14", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_14.ToString();
            cmd.Parameters.Add("pDATE_STATUS_15", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_15.ToString();
            cmd.Parameters.Add("pDATE_STATUS_16", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_16.ToString();
            cmd.Parameters.Add("pDATE_STATUS_17", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_17.ToString();
            cmd.Parameters.Add("pDATE_STATUS_18", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_18.ToString();
            cmd.Parameters.Add("pDATE_STATUS_19", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_19.ToString();
            cmd.Parameters.Add("pDATE_STATUS_20", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_20.ToString();
            cmd.Parameters.Add("pDATE_STATUS_21", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_21.ToString();
            cmd.Parameters.Add("pDATE_STATUS_22", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_22.ToString();
            cmd.Parameters.Add("pDATE_STATUS_23", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_23.ToString();
            cmd.Parameters.Add("pDATE_STATUS_24", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_24.ToString();
            cmd.Parameters.Add("pDATE_STATUS_25", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_25.ToString();
            cmd.Parameters.Add("pDATE_STATUS_26", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_26.ToString();
            cmd.Parameters.Add("pDATE_STATUS_27", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_27.ToString();
            cmd.Parameters.Add("pDATE_STATUS_28", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_28.ToString();
            cmd.Parameters.Add("pDATE_STATUS_29", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_29.ToString();
            cmd.Parameters.Add("pDATE_STATUS_30", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_30.ToString();
            cmd.Parameters.Add("pDATE_STATUS_31", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_31.ToString();
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM056S_FirstUpdate")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM056S_FirstUpdate([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM056S_FIRST_UPDATE";
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
                cmd.Parameters.Add("pPROCESS_YEAR", OracleDbType.Varchar2).Value = data["PROCESS_YEAR"].ToString();
                cmd.Parameters.Add("pPROCESS_MONTH", OracleDbType.Varchar2).Value = data["PROCESS_MONTH"].ToString();
                cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("pIP_ADRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                cmd.Parameters.Add("pDATE_STATUS_01", OracleDbType.Varchar2).Value = data["DATE_STATUS_01"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_02", OracleDbType.Varchar2).Value = data["DATE_STATUS_02"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_03", OracleDbType.Varchar2).Value = data["DATE_STATUS_03"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_04", OracleDbType.Varchar2).Value = data["DATE_STATUS_04"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_05", OracleDbType.Varchar2).Value = data["DATE_STATUS_05"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_06", OracleDbType.Varchar2).Value = data["DATE_STATUS_06"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_07", OracleDbType.Varchar2).Value = data["DATE_STATUS_07"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_08", OracleDbType.Varchar2).Value = data["DATE_STATUS_08"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_09", OracleDbType.Varchar2).Value = data["DATE_STATUS_09"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_10", OracleDbType.Varchar2).Value = data["DATE_STATUS_10"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_11", OracleDbType.Varchar2).Value = data["DATE_STATUS_11"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_12", OracleDbType.Varchar2).Value = data["DATE_STATUS_12"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_13", OracleDbType.Varchar2).Value = data["DATE_STATUS_13"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_14", OracleDbType.Varchar2).Value = data["DATE_STATUS_14"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_15", OracleDbType.Varchar2).Value = data["DATE_STATUS_15"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_16", OracleDbType.Varchar2).Value = data["DATE_STATUS_16"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_17", OracleDbType.Varchar2).Value = data["DATE_STATUS_17"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_18", OracleDbType.Varchar2).Value = data["DATE_STATUS_18"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_19", OracleDbType.Varchar2).Value = data["DATE_STATUS_19"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_20", OracleDbType.Varchar2).Value = data["DATE_STATUS_20"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_21", OracleDbType.Varchar2).Value = data["DATE_STATUS_21"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_22", OracleDbType.Varchar2).Value = data["DATE_STATUS_22"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_23", OracleDbType.Varchar2).Value = data["DATE_STATUS_23"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_24", OracleDbType.Varchar2).Value = data["DATE_STATUS_24"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_25", OracleDbType.Varchar2).Value = data["DATE_STATUS_25"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_26", OracleDbType.Varchar2).Value = data["DATE_STATUS_26"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_27", OracleDbType.Varchar2).Value = data["DATE_STATUS_27"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_28", OracleDbType.Varchar2).Value = data["DATE_STATUS_28"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_29", OracleDbType.Varchar2).Value = data["DATE_STATUS_29"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_30", OracleDbType.Varchar2).Value = data["DATE_STATUS_30"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_31", OracleDbType.Varchar2).Value = data["DATE_STATUS_31"].ToString();
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);


            }
            return Ok("DONE");
        }
        #endregion

        #region SNM056P
        [HttpGet, Route("SNM056P_GetCalendar/{PROCESS_YEAR}")]
        [Authorize]
        public IHttpActionResult SNM056P_GetCalendar(string PROCESS_YEAR)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM056P_PG_GET_CALENDAR";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
            cmd.Parameters.Add("pPROCESS_YEAR", OracleDbType.Varchar2).Value = PROCESS_YEAR;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pIP_ADRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM056P_UpdateCalendar")]
        [Authorize]
        public IHttpActionResult SNM056P_UpdateCalendar([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();


            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM056P_UPDATE_CALENDAR";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
            cmd.Parameters.Add("pPROCESS_YEAR", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().PROCESS_YEAR.ToString();
            cmd.Parameters.Add("pPROCESS_MONTH", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().PROCESS_MONTH.ToString();
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pIP_ADRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
            cmd.Parameters.Add("pDATE_STATUS_01", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_01.ToString();
            cmd.Parameters.Add("pDATE_STATUS_02", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_02.ToString();
            cmd.Parameters.Add("pDATE_STATUS_03", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_03.ToString();
            cmd.Parameters.Add("pDATE_STATUS_04", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_04.ToString();
            cmd.Parameters.Add("pDATE_STATUS_05", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_05.ToString();
            cmd.Parameters.Add("pDATE_STATUS_06", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_06.ToString();
            cmd.Parameters.Add("pDATE_STATUS_07", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_07.ToString();
            cmd.Parameters.Add("pDATE_STATUS_08", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_08.ToString();
            cmd.Parameters.Add("pDATE_STATUS_09", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_09.ToString();
            cmd.Parameters.Add("pDATE_STATUS_10", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_10.ToString();
            cmd.Parameters.Add("pDATE_STATUS_11", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_11.ToString();
            cmd.Parameters.Add("pDATE_STATUS_12", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_12.ToString();
            cmd.Parameters.Add("pDATE_STATUS_13", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_13.ToString();
            cmd.Parameters.Add("pDATE_STATUS_14", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_14.ToString();
            cmd.Parameters.Add("pDATE_STATUS_15", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_15.ToString();
            cmd.Parameters.Add("pDATE_STATUS_16", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_16.ToString();
            cmd.Parameters.Add("pDATE_STATUS_17", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_17.ToString();
            cmd.Parameters.Add("pDATE_STATUS_18", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_18.ToString();
            cmd.Parameters.Add("pDATE_STATUS_19", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_19.ToString();
            cmd.Parameters.Add("pDATE_STATUS_20", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_20.ToString();
            cmd.Parameters.Add("pDATE_STATUS_21", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_21.ToString();
            cmd.Parameters.Add("pDATE_STATUS_22", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_22.ToString();
            cmd.Parameters.Add("pDATE_STATUS_23", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_23.ToString();
            cmd.Parameters.Add("pDATE_STATUS_24", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_24.ToString();
            cmd.Parameters.Add("pDATE_STATUS_25", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_25.ToString();
            cmd.Parameters.Add("pDATE_STATUS_26", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_26.ToString();
            cmd.Parameters.Add("pDATE_STATUS_27", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_27.ToString();
            cmd.Parameters.Add("pDATE_STATUS_28", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_28.ToString();
            cmd.Parameters.Add("pDATE_STATUS_29", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_29.ToString();
            cmd.Parameters.Add("pDATE_STATUS_30", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_30.ToString();
            cmd.Parameters.Add("pDATE_STATUS_31", OracleDbType.Varchar2).Value = pDataList.FirstOrDefault().DATE_STATUS_31.ToString();
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM056P_FirstUpdate")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM056P_FirstUpdate([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM056P_FIRST_UPDATE";
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
                cmd.Parameters.Add("pPROCESS_YEAR", OracleDbType.Varchar2).Value = data["PROCESS_YEAR"].ToString();
                cmd.Parameters.Add("pPROCESS_MONTH", OracleDbType.Varchar2).Value = data["PROCESS_MONTH"].ToString();
                cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("pIP_ADRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                cmd.Parameters.Add("pDATE_STATUS_01", OracleDbType.Varchar2).Value = data["DATE_STATUS_01"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_02", OracleDbType.Varchar2).Value = data["DATE_STATUS_02"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_03", OracleDbType.Varchar2).Value = data["DATE_STATUS_03"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_04", OracleDbType.Varchar2).Value = data["DATE_STATUS_04"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_05", OracleDbType.Varchar2).Value = data["DATE_STATUS_05"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_06", OracleDbType.Varchar2).Value = data["DATE_STATUS_06"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_07", OracleDbType.Varchar2).Value = data["DATE_STATUS_07"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_08", OracleDbType.Varchar2).Value = data["DATE_STATUS_08"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_09", OracleDbType.Varchar2).Value = data["DATE_STATUS_09"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_10", OracleDbType.Varchar2).Value = data["DATE_STATUS_10"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_11", OracleDbType.Varchar2).Value = data["DATE_STATUS_11"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_12", OracleDbType.Varchar2).Value = data["DATE_STATUS_12"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_13", OracleDbType.Varchar2).Value = data["DATE_STATUS_13"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_14", OracleDbType.Varchar2).Value = data["DATE_STATUS_14"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_15", OracleDbType.Varchar2).Value = data["DATE_STATUS_15"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_16", OracleDbType.Varchar2).Value = data["DATE_STATUS_16"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_17", OracleDbType.Varchar2).Value = data["DATE_STATUS_17"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_18", OracleDbType.Varchar2).Value = data["DATE_STATUS_18"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_19", OracleDbType.Varchar2).Value = data["DATE_STATUS_19"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_20", OracleDbType.Varchar2).Value = data["DATE_STATUS_20"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_21", OracleDbType.Varchar2).Value = data["DATE_STATUS_21"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_22", OracleDbType.Varchar2).Value = data["DATE_STATUS_22"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_23", OracleDbType.Varchar2).Value = data["DATE_STATUS_23"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_24", OracleDbType.Varchar2).Value = data["DATE_STATUS_24"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_25", OracleDbType.Varchar2).Value = data["DATE_STATUS_25"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_26", OracleDbType.Varchar2).Value = data["DATE_STATUS_26"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_27", OracleDbType.Varchar2).Value = data["DATE_STATUS_27"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_28", OracleDbType.Varchar2).Value = data["DATE_STATUS_28"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_29", OracleDbType.Varchar2).Value = data["DATE_STATUS_29"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_30", OracleDbType.Varchar2).Value = data["DATE_STATUS_30"].ToString();
                cmd.Parameters.Add("pDATE_STATUS_31", OracleDbType.Varchar2).Value = data["DATE_STATUS_31"].ToString();
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);


            }
            return Ok("DONE");
        }
        #endregion


        #region SNM002P

        [HttpGet, Route("SNM002P_GetMaster")]
        [Authorize]
        public IHttpActionResult SNM002P_GetMaster()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM112P_GET_MASTER";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn5", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM002P_GetVendor/{VENDOR_CODE}")]
        [Authorize]
        public IHttpActionResult SNM002P_GetVendor(string VENDOR_CODE)
        {
            DataSet ds = new DataSet();



            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM002P_PG_GET_VENDOR";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = VENDOR_CODE;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM002P_GetVendorForAc")]
        [Authorize]
        public IHttpActionResult SNM002P_GetVendorForAc([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM002P_GET_VENDOR_AC";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
            cmd.Parameters.Add("pVENDOR_GLOBAL_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_GLOBAL_CODE"];
            cmd.Parameters.Add("pVENDOR_NAME", OracleDbType.Varchar2).Value = pData["VENDOR_NAME_TH"];
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM002P_UpdateVendorMaster")]
        [Authorize]
        public IHttpActionResult SNM002P_UpdateVendorMaster([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();


            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM002P_UPDATE_VENDOR";

            //cmd.Parameters.Add("pVENDOR_TYPE", OracleDbType).Value = archar2, (object)pDataList.VENDOR_TYPE ?? DBNull.Value;

            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE.ToString();
            cmd.Parameters.Add("pVENDOR_TYPE", OracleDbType.Varchar2).Value = pDataList.VENDOR_TYPE.ToString();
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pVENDOR_GLOBAL_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_GLOBAL_CODE.ToString();
            cmd.Parameters.Add("pVENDOR_NAME_EN", OracleDbType.Varchar2).Value = pDataList.VENDOR_NAME_EN.ToString();
            cmd.Parameters.Add("pVENDOR_NAME_TH", OracleDbType.Varchar2).Value = pDataList.VENDOR_NAME_TH.ToString();
            cmd.Parameters.Add("pSK_USER_ID", OracleDbType.Varchar2).Value = pDataList.SK_USER_ID.ToString();
            cmd.Parameters.Add("pGTOP_STATUS", OracleDbType.Varchar2).Value = pDataList.GTOP_STATUS.ToString();
            cmd.Parameters.Add("pGLOBAL_COUNTRY_CODE", OracleDbType.Varchar2).Value = pDataList.GLOBAL_COUNTRY_CODE.ToString();
            cmd.Parameters.Add("pSOURCING_CODE", OracleDbType.Varchar2).Value = pDataList.SOURCING_CODE.ToString();
            cmd.Parameters.Add("pVENDOR_ADDR1", OracleDbType.Varchar2).Value = pDataList.VENDOR_ADDR1.ToString();
            cmd.Parameters.Add("pVENDOR_ADDR2", OracleDbType.Varchar2).Value = pDataList.VENDOR_ADDR2.ToString();
            cmd.Parameters.Add("pVENDOR_ADDR3", OracleDbType.Varchar2).Value = pDataList.VENDOR_ADDR3.ToString();
            cmd.Parameters.Add("pVENDOR_ADDR4", OracleDbType.Varchar2).Value = pDataList.VENDOR_ADDR4.ToString();
            cmd.Parameters.Add("pCOUNTRY_CODE", OracleDbType.Varchar2).Value = pDataList.COUNTRY_CODE.ToString();
            cmd.Parameters.Add("pOVERSEA_FLAG", OracleDbType.Varchar2).Value = pDataList.OVERSEA_FLAG.ToString();
            cmd.Parameters.Add("pPAYMENT_TYPE", OracleDbType.Varchar2).Value = pDataList.PAYMENT_TYPE.ToString();
            cmd.Parameters.Add("pPAYMENT_TERM", OracleDbType.Decimal).Value = pDataList.PAYMENT_TERM;
            cmd.Parameters.Add("pCURRENCY_CODE", OracleDbType.Varchar2).Value = pDataList.CURRENCY_CODE.ToString();
            cmd.Parameters.Add("pPRICE_TERM_CODE", OracleDbType.Varchar2).Value = pDataList.PRICE_TERM_CODE.ToString();
            cmd.Parameters.Add("pAP_VENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.AP_VENDOR_CODE.ToString();
            cmd.Parameters.Add("pAP_SUB_TYPE", OracleDbType.Varchar2).Value = pDataList.AP_SUB_TYPE.ToString();
            cmd.Parameters.Add("pATTRIBUTE3", OracleDbType.Varchar2).Value = pDataList.ATTRIBUTE3.ToString();
            cmd.Parameters.Add("pSAP_PAYMENT_TERM", OracleDbType.Varchar2).Value = pDataList.SAP_PAYMENT_TERM.ToString();
            cmd.Parameters.Add("pCALCULATE_PRICE", OracleDbType.Varchar2).Value = pDataList.CALCULATE_PRICE.ToString();
            cmd.Parameters.Add("pPRINT_PRICE", OracleDbType.Varchar2).Value = pDataList.PRINT_PRICE.ToString();
            cmd.Parameters.Add("pPRINT_PO", OracleDbType.Varchar2).Value = pDataList.PRINT_PO.ToString();
            cmd.Parameters.Add("pPRINT_STICKER", OracleDbType.Varchar2).Value = pDataList.PRINT_STICKER.ToString();
            cmd.Parameters.Add("pADD_STOCK_LEVEL", OracleDbType.Decimal).Value = pDataList.ADD_STOCK_LEVEL;
            cmd.Parameters.Add("pSTD_SAFE_STOCK", OracleDbType.Decimal).Value = pDataList.STD_SAFE_STOCK;
            cmd.Parameters.Add("pLEAD_TIME_ON", OracleDbType.Decimal).Value = pDataList.LEAD_TIME_ON;
            cmd.Parameters.Add("pLEAD_TIME_OFF", OracleDbType.Decimal).Value = pDataList.LEAD_TIME_OFF;
            cmd.Parameters.Add("pORDER_INTERVAL", OracleDbType.Decimal).Value = pDataList.ORDER_INTERVAL;
            cmd.Parameters.Add("pSUGGEST_FLAG", OracleDbType.Varchar2).Value = pDataList.SUGGEST_FLAG.ToString();
            cmd.Parameters.Add("pFQO_FLAG", OracleDbType.Varchar2).Value = pDataList.FQO_FLAG.ToString();
            cmd.Parameters.Add("pTOP_VALUE_ITEMS", OracleDbType.Decimal).Value = pDataList.TOP_VALUE_ITEMS;
            cmd.Parameters.Add("pCPS_FLAG", OracleDbType.Varchar2).Value = pDataList.CPS_FLAG.ToString();

            cmd.Parameters.Add("pMETHOD_PRICE", OracleDbType.Varchar2).Value = pDataList.METHOD_PRICE.ToString();
            cmd.Parameters.Add("pMETHOD_ISC", OracleDbType.Varchar2).Value = pDataList.METHOD_ISC.ToString();
            cmd.Parameters.Add("pVENDOR_MAIN", OracleDbType.Varchar2).Value = pDataList.VENDOR_MAIN.ToString();
            cmd.Parameters.Add("pMAPPING_ATTRIBUTE1", OracleDbType.Varchar2).Value = pDataList.MAPPING_ATTRIBUTE1.ToString();
            cmd.Parameters.Add("pIP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
            cmd.Parameters.Add("pVENDOR_CONTACT", OracleDbType.Varchar2).Value = pDataList.VENDOR_CONTACT.ToString();
            cmd.Parameters.Add("pTAX_ID", OracleDbType.Varchar2).Value = pDataList.TAX_ID;
            cmd.Parameters.Add("P_VENDOR_EMAIL", OracleDbType.Varchar2).Value = pDataList.VENDOR_EMAIL;
            cmd.Parameters.Add("P_ENABLE_FLAG", OracleDbType.Varchar2).Value = pDataList.ENABLED_FLAG;
            cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = pDataList.ORDER_CLASS;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM002P_InsertVendorMaster")]
        [Authorize]
        public IHttpActionResult SNM002P_InsertVendorMaster([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();


            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM002P_INSERT_VENDOR";

            //cmd.Parameters.Add("pVENDOR_TYPE", OracleDbType).Value = archar2, (object)pDataList.VENDOR_TYPE ?? DBNull.Value;

            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE.ToString();
            cmd.Parameters.Add("pVENDOR_TYPE", OracleDbType.Varchar2).Value = pDataList.VENDOR_TYPE.ToString();
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pVENDOR_GLOBAL_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_GLOBAL_CODE.ToString();
            cmd.Parameters.Add("pVENDOR_NAME_EN", OracleDbType.Varchar2).Value = pDataList.VENDOR_NAME_EN.ToString();
            cmd.Parameters.Add("pVENDOR_NAME_TH", OracleDbType.Varchar2).Value = pDataList.VENDOR_NAME_TH.ToString();
            cmd.Parameters.Add("pSK_USER_ID", OracleDbType.Varchar2).Value = pDataList.SK_USER_ID.ToString();
            cmd.Parameters.Add("pGTOP_STATUS", OracleDbType.Varchar2).Value = pDataList.GTOP_STATUS.ToString();
            cmd.Parameters.Add("pGLOBAL_COUNTRY_CODE", OracleDbType.Varchar2).Value = pDataList.GLOBAL_COUNTRY_CODE.ToString();
            cmd.Parameters.Add("pSOURCING_CODE", OracleDbType.Varchar2).Value = pDataList.SOURCING_CODE.ToString();
            cmd.Parameters.Add("pVENDOR_ADDR1", OracleDbType.Varchar2).Value = pDataList.VENDOR_ADDR1.ToString();
            cmd.Parameters.Add("pVENDOR_ADDR2", OracleDbType.Varchar2).Value = pDataList.VENDOR_ADDR2.ToString();
            cmd.Parameters.Add("pVENDOR_ADDR3", OracleDbType.Varchar2).Value = pDataList.VENDOR_ADDR3.ToString();
            cmd.Parameters.Add("pVENDOR_ADDR4", OracleDbType.Varchar2).Value = pDataList.VENDOR_ADDR4.ToString();
            cmd.Parameters.Add("pCOUNTRY_CODE", OracleDbType.Varchar2).Value = pDataList.COUNTRY_CODE.ToString();
            cmd.Parameters.Add("pOVERSEA_FLAG", OracleDbType.Varchar2).Value = pDataList.OVERSEA_FLAG.ToString();
            cmd.Parameters.Add("pPAYMENT_TYPE", OracleDbType.Varchar2).Value = pDataList.PAYMENT_TYPE.ToString();
            cmd.Parameters.Add("pPAYMENT_TERM", OracleDbType.Decimal).Value = pDataList.PAYMENT_TERM;
            cmd.Parameters.Add("pCURRENCY_CODE", OracleDbType.Varchar2).Value = pDataList.CURRENCY_CODE.ToString();
            cmd.Parameters.Add("pPRICE_TERM_CODE", OracleDbType.Varchar2).Value = pDataList.PRICE_TERM_CODE.ToString();
            cmd.Parameters.Add("pAP_VENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.AP_VENDOR_CODE.ToString();
            cmd.Parameters.Add("pAP_SUB_TYPE", OracleDbType.Varchar2).Value = pDataList.AP_SUB_TYPE.ToString();
            cmd.Parameters.Add("pATTRIBUTE3", OracleDbType.Varchar2).Value = pDataList.ATTRIBUTE3.ToString();
            cmd.Parameters.Add("pSAP_PAYMENT_TERM", OracleDbType.Varchar2).Value = pDataList.SAP_PAYMENT_TERM.ToString();
            cmd.Parameters.Add("pCALCULATE_PRICE", OracleDbType.Varchar2).Value = pDataList.CALCULATE_PRICE.ToString();
            cmd.Parameters.Add("pPRINT_PRICE", OracleDbType.Varchar2).Value = pDataList.PRINT_PRICE.ToString();
            cmd.Parameters.Add("pPRINT_PO", OracleDbType.Varchar2).Value = pDataList.PRINT_PO.ToString();
            cmd.Parameters.Add("pPRINT_STICKER", OracleDbType.Varchar2).Value = pDataList.PRINT_STICKER.ToString();
            cmd.Parameters.Add("pADD_STOCK_LEVEL", OracleDbType.Decimal).Value = pDataList.ADD_STOCK_LEVEL;
            cmd.Parameters.Add("pSTD_SAFE_STOCK", OracleDbType.Decimal).Value = pDataList.STD_SAFE_STOCK;
            cmd.Parameters.Add("pLEAD_TIME_ON", OracleDbType.Decimal).Value = pDataList.LEAD_TIME_ON;
            cmd.Parameters.Add("pLEAD_TIME_OFF", OracleDbType.Decimal).Value = pDataList.LEAD_TIME_OFF;
            cmd.Parameters.Add("pORDER_INTERVAL", OracleDbType.Decimal).Value = pDataList.ORDER_INTERVAL;
            cmd.Parameters.Add("pSUGGEST_FLAG", OracleDbType.Varchar2).Value = pDataList.SUGGEST_FLAG.ToString();
            cmd.Parameters.Add("pFQO_FLAG", OracleDbType.Varchar2).Value = pDataList.FQO_FLAG.ToString();
            cmd.Parameters.Add("pTOP_VALUE_ITEMS", OracleDbType.Decimal).Value = pDataList.TOP_VALUE_ITEMS;
            cmd.Parameters.Add("pCPS_FLAG", OracleDbType.Varchar2).Value = pDataList.CPS_FLAG.ToString();

            cmd.Parameters.Add("pMETHOD_PRICE", OracleDbType.Varchar2).Value = pDataList.METHOD_PRICE.ToString();
            cmd.Parameters.Add("pMETHOD_ISC", OracleDbType.Varchar2).Value = pDataList.METHOD_ISC.ToString();
            cmd.Parameters.Add("pVENDOR_MAIN", OracleDbType.Varchar2).Value = pDataList.VENDOR_MAIN.ToString();
            cmd.Parameters.Add("pMAPPING_ATTRIBUTE1", OracleDbType.Varchar2).Value = pDataList.MAPPING_ATTRIBUTE1.ToString();
            cmd.Parameters.Add("pIP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
            cmd.Parameters.Add("pVENDOR_CONTACT", OracleDbType.Varchar2).Value = pDataList.VENDOR_CONTACT.ToString();
            cmd.Parameters.Add("pTAX_ID", OracleDbType.Varchar2).Value = pDataList.TAX_ID;
            cmd.Parameters.Add("P_VENDOR_EMAIL", OracleDbType.Varchar2).Value = pDataList.VENDOR_EMAIL;
            cmd.Parameters.Add("P_ENABLE_FLAG", OracleDbType.Varchar2).Value = pDataList.ENABLED_FLAG;
            cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = pDataList.ORDER_CLASS;


            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM002P_CheckMasterGlobal")]
        [Authorize]
        public IHttpActionResult SNM002P_CheckMasterGlobal([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_CHECK_MASTER_GLOBAL";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_GLOBAL_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_GLOBAL_CODE.ToString();
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE.ToString();
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM002P_ValidateDelete/{VENDOR_CODE}")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM002P_ValidateDelete(string VENDOR_CODE)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM002P_VALID_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VENDOR_CODE;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM002P_Delete/{VENDOR_CODE}")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM002P_Delete(string VENDOR_CODE)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM002P_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VENDOR_CODE;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_CURRENT_FORM", OracleDbType.Varchar2).Value = "SNM002P";
            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNM002P_Download")]
        [Authorize]
        public HttpResponseMessage SNM002P_Download([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM002P_GET_VENDOR_AC";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = param["VENDOR_CODE"];
            cmd.Parameters.Add("pVENDOR_GLOBAL_CODE", OracleDbType.Varchar2).Value = param["VENDOR_GLOBAL_CODE"];
            cmd.Parameters.Add("pVENDOR_NAME", OracleDbType.Varchar2).Value = param["VENDOR_NAME_TH"];
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            var json = JsonConvert.SerializeObject(dt);
            var List1 = JsonConvert.DeserializeObject<List<DataModel.SNM002P>>(json);
            HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);
            string gLocation = "~/tempFile/" + "SNM002P" + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);
            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, "SNM002P.xlsx");
            string gReturnLocation = Path.Combine(gLocation, "SNM002P.xlsx");
            var excel2 = List1.ToExcel("VendorInfo");
            byte[] excel = excel2;
            File.WriteAllBytes(gFileLocation, excel);
            string path = HttpContext.Current.Server.MapPath("~/" + gReturnLocation.Substring(1));
            if (!File.Exists(path))
            {
                return Request.CreateErrorResponse(HttpStatusCode.NotFound, "File not found.");
            }
            try
            {
                string mimeType = MimeMapping.GetMimeMapping("SNM020P.xlsx");
                StreamContent x = new StreamContent(new FileStream(path, FileMode.Open, FileAccess.Read));
                response.Content = x;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue(mimeType);
                response.Content.Headers.ContentDisposition = new ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = "SNM020P.xlsx";
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM002P_Download");
                return Request.CreateResponse(HttpStatusCode.BadRequest, ex);
            }
            return response;
        }
        #endregion

        #region SNSE148

        [HttpPost, Route("SNSE148_UploadandGet")]
        [Authorize]
        public async Task<IHttpActionResult> SNSE148_UploadandGet(HttpRequestMessage reques)
        {
            try
            {
                DataSet ds = new DataSet();

                var x = await SNSE148_Upload(reques);

                ds = SNSE148_Get_AfterUpload();

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE148_UploadandGet");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpGet, Route("SNSE148_Get_AfterUpload")]
        public DataSet SNSE148_Get_AfterUpload()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE148_GET_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ROOTPATH", OracleDbType.Varchar2).Value = ConfigurationManager.AppSettings["RootDBPath"];
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return ds;
        }


        [HttpPost, Route("SNSE148_Export")]
        public HttpResponseMessage SNSE148_Export(List<DataModel.SNSE148_MODEL> dModel)
        {
            DataTable dt = new DataTable();
            string x = string.Empty;
            string filename = "SNSE148_NEWFILE.tsv";
            string floderLocation = "SNSE148";
            dt = DTFM.ToDatatable<DataModel.SNSE148_MODEL>(dModel);
            x = DataService.WriteTSV(dt, filename, floderLocation, "SNSE148");
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }

        [HttpPost, Route("SNSE148_Export_MPS")]
        public HttpResponseMessage SNSE148_Export_MPS(List<DataModel.SNSE148_MPS_MODEL> dModel)
        {
            DataTable dt = new DataTable();
            string x = string.Empty;
            string filename = "SNSE148_NEWFILE.tsv";
            string floderLocation = "SNSE148";
            dt = DTFM.ToDatatable<DataModel.SNSE148_MPS_MODEL>(dModel);
            x = DataService.WriteTSV(dt, filename, floderLocation, "SNSE148_MPS");
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }


        [HttpPost, Route("SNSE148_Upload")]
        [Authorize]
        public async Task<IHttpActionResult> SNSE148_Upload(HttpRequestMessage request)
        {

            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }

            var reqParts = await request.Content.ReadAsMultipartAsync();

            try
            {
                foreach (var file in reqParts.Contents)
                {

                    var buffer = await file.ReadAsByteArrayAsync();

                    string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                    string gRootPath = ConfigurationManager.AppSettings["RootSharedPath"].ToString();
                    string gUploadLication = System.IO.Path.Combine(gRootPath, "tempFile/SNSE148");
                    string gFileLocation = System.IO.Path.Combine(gUploadLication, gFileName);

                    DataService.SaveBytesToFileByLocation(buffer
                                                    , gUploadLication
                                                    , gFileLocation);

                    int fileRowCount = 0;
                    int rowCount = 0;
                    string line = "";
                    DataTable dt = new DataTable();
                    OracleCommand cmd;

                    using (StreamReader reader = new StreamReader(gFileLocation))
                    {

                        while ((line = reader.ReadLine()) != null)
                        {
                            string[] tsv = line.Split(new char[] { '\t' }).ToArray();

                            tsv = tsv.Select(x => x.Trim()).ToArray();

                            if (fileRowCount == 1)
                            {
                                //Set columns
                                foreach (string colName in tsv)
                                {
                                    dt.Columns.Add(colName, typeof(string));
                                }

                                cmd = new OracleCommand();
                                cmd.CommandText = "SP_NP_SNSE148_DEL_DATA";

                                oOracledb.SqlQueryReturnValue(cmd);
                            }
                            if (fileRowCount > 1)
                            {

                                dt.Rows.Add(tsv);
                                DataRow row = dt.Rows[rowCount];

                                cmd = new OracleCommand();
                                cmd.CommandText = "SP_NP_SNSE148_INS_DATA";
                                cmd.Parameters.Add("P_ITEM001", OracleDbType.Varchar2).Value = row["Your Code"].ToString();
                                cmd.Parameters.Add("P_ITEM002", OracleDbType.Varchar2).Value = row["Role"].ToString();
                                cmd.Parameters.Add("P_ITEM003", OracleDbType.Varchar2).Value = row["Role Number"].ToString();
                                cmd.Parameters.Add("P_ITEM004", OracleDbType.Varchar2).Value = row["Recommend ID"].ToString();
                                cmd.Parameters.Add("P_ITEM005", OracleDbType.Varchar2).Value = row["Project ID"].ToString();
                                cmd.Parameters.Add("P_ITEM006", OracleDbType.Varchar2).Value = row["Model"].ToString();
                                cmd.Parameters.Add("P_ITEM007", OracleDbType.Varchar2).Value = row["Year"].ToString();
                                cmd.Parameters.Add("P_ITEM008", OracleDbType.Varchar2).Value = row["MAC"].ToString();
                                cmd.Parameters.Add("P_ITEM009", OracleDbType.Varchar2).Value = row["Production"].ToString();
                                cmd.Parameters.Add("P_ITEM010", OracleDbType.Varchar2).Value = row["Sales"].ToString();
                                cmd.Parameters.Add("P_ITEM011", OracleDbType.Varchar2).Value = row["Section"].ToString();
                                cmd.Parameters.Add("P_ITEM012", OracleDbType.Varchar2).Value = row["Part Code"].ToString();
                                cmd.Parameters.Add("P_ITEM013", OracleDbType.Varchar2).Value = row["Part No"].ToString();
                                cmd.Parameters.Add("P_ITEM014", OracleDbType.Varchar2).Value = row["Part Name"].ToString();
                                cmd.Parameters.Add("P_ITEM015", OracleDbType.Varchar2).Value = row["NSC to Order"].ToString();
                                cmd.Parameters.Add("P_ITEM016", OracleDbType.Varchar2).Value = row["Order due Date"].ToString();
                                cmd.Parameters.Add("P_ITEM017", OracleDbType.Varchar2).Value = row["Recommendation Date"].ToString();
                                cmd.Parameters.Add("P_ITEM018", OracleDbType.Varchar2).Value = row["D/S"].ToString();
                                cmd.Parameters.Add("P_ITEM019", OracleDbType.Varchar2).Value = row["Recommended Q'ty"].ToString();
                                cmd.Parameters.Add("P_ITEM020", OracleDbType.Varchar2).Value = row["Self Point Modified Q'ty"].ToString();
                                cmd.Parameters.Add("P_ITEM021", OracleDbType.Varchar2).Value = row["Self Point Reason"].ToString();
                                //cmd.Parameters.Add("P_ITEM022", OracleDbType.Varchar2).Value = row["Self Point Reason Message"].ToString();
                                cmd.Parameters.Add("P_ITEM023", OracleDbType.Varchar2).Value = row["Self Point Modification Flag"].ToString();
                                cmd.Parameters.Add("P_ITEM024", OracleDbType.Varchar2).Value = row["Self Point Modification Date"].ToString();
                                cmd.Parameters.Add("P_ITEM025", OracleDbType.Varchar2).Value = row["Downstream Point Country (1)"].ToString();
                                cmd.Parameters.Add("P_ITEM026", OracleDbType.Varchar2).Value = row["Downstream Point Modified Q'ty (1)"].ToString();
                                cmd.Parameters.Add("P_ITEM027", OracleDbType.Varchar2).Value = row["Downstream Point Reason (1)"].ToString();
                                cmd.Parameters.Add("P_ITEM028", OracleDbType.Varchar2).Value = row["Downstream Point Modification Flag (1)"].ToString();
                                cmd.Parameters.Add("P_ITEM029", OracleDbType.Varchar2).Value = row["Downstream Point Modification Date (1)"].ToString();
                                cmd.Parameters.Add("P_ITEM030", OracleDbType.Varchar2).Value = row["Downstream Point Country (2)"].ToString();
                                cmd.Parameters.Add("P_ITEM031", OracleDbType.Varchar2).Value = row["Downstream Point Modified Q'ty (2)"].ToString();
                                cmd.Parameters.Add("P_ITEM032", OracleDbType.Varchar2).Value = row["Downstream Point Reason (2)"].ToString();
                                cmd.Parameters.Add("P_ITEM033", OracleDbType.Varchar2).Value = row["Downstream Point Modification Flag (2)"].ToString();
                                cmd.Parameters.Add("P_ITEM034", OracleDbType.Varchar2).Value = row["Downstream Point Modification Date (2)"].ToString();
                                cmd.Parameters.Add("P_ITEM035", OracleDbType.Varchar2).Value = row["Downstream Point Country (3)"].ToString();
                                cmd.Parameters.Add("P_ITEM036", OracleDbType.Varchar2).Value = row["Downstream Point Modified Q'ty (3)"].ToString();
                                cmd.Parameters.Add("P_ITEM037", OracleDbType.Varchar2).Value = row["Downstream Point Reason (3)"].ToString();
                                cmd.Parameters.Add("P_ITEM038", OracleDbType.Varchar2).Value = row["Downstream Point Modification Flag (3)"].ToString();
                                cmd.Parameters.Add("P_ITEM039", OracleDbType.Varchar2).Value = row["Downstream Point Modification Date (3)"].ToString();
                                cmd.Parameters.Add("P_ITEM040", OracleDbType.Varchar2).Value = row["Downstream Point Country (4)"].ToString();
                                cmd.Parameters.Add("P_ITEM041", OracleDbType.Varchar2).Value = row["Downstream Point Modified Q'ty (4)"].ToString();
                                cmd.Parameters.Add("P_ITEM042", OracleDbType.Varchar2).Value = row["Downstream Point Reason (4)"].ToString();
                                cmd.Parameters.Add("P_ITEM043", OracleDbType.Varchar2).Value = row["Downstream Point Modification Flag (4)"].ToString();
                                cmd.Parameters.Add("P_ITEM044", OracleDbType.Varchar2).Value = row["Downstream Point Modification Date (4)"].ToString();
                                cmd.Parameters.Add("P_ITEM045", OracleDbType.Varchar2).Value = row["Downstream Point Country (5)"].ToString();
                                cmd.Parameters.Add("P_ITEM046", OracleDbType.Varchar2).Value = row["Downstream Point Modified Q'ty (5)"].ToString();
                                cmd.Parameters.Add("P_ITEM047", OracleDbType.Varchar2).Value = row["Downstream Point Reason (5)"].ToString();
                                cmd.Parameters.Add("P_ITEM048", OracleDbType.Varchar2).Value = row["Downstream Point Modification Flag (5)"].ToString();
                                cmd.Parameters.Add("P_ITEM049", OracleDbType.Varchar2).Value = row["Downstream Point Modification Date (5)"].ToString();
                                //cmd.Parameters.Add("P_ITEM050", OracleDbType.Varchar2).Value = row["PMS Stock On Hand"].ToString();
                                //cmd.Parameters.Add("P_ITEM051", OracleDbType.Varchar2).Value = row["PMS P/O QTY"].ToString();
                                //cmd.Parameters.Add("P_ITEM052", OracleDbType.Varchar2).Value = row["PMS B/O QTY"].ToString();
                                //cmd.Parameters.Add("P_ITEM053", OracleDbType.Varchar2).Value = row["PMS Average Demand"].ToString();
                                //cmd.Parameters.Add("P_ITEM054", OracleDbType.Varchar2).Value = row["Order Point"].ToString();
                                //cmd.Parameters.Add("P_ITEM055", OracleDbType.Varchar2).Value = row["Vendor Code"].ToString();
                                //cmd.Parameters.Add("P_ITEM056", OracleDbType.Varchar2).Value = row["Group Part No"].ToString();
                                //cmd.Parameters.Add("P_ITEM057", OracleDbType.Varchar2).Value = row["Confirm QTY"].ToString();

                                oOracledb.SqlQueryReturnValue(cmd);

                                rowCount++;
                            }
                            fileRowCount++;
                        }
                    }


                }

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE148_Upload");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            return Ok("DONE");
        }



        #endregion


        #region SNPP105

        [HttpPost, Route("SNPP105_Save")]
        [Authorize]
        public IHttpActionResult SNPP105_Save([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNPP105_SAVE";
            cmd.Parameters.Add("pCOM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pETD_DATE", OracleDbType.Varchar2).Value = pDataList.ETD_DATE;
            cmd.Parameters.Add("pETP_DATE", OracleDbType.Varchar2).Value = pDataList.ETP_DATE;
            cmd.Parameters.Add("pINVOICE_NO", OracleDbType.Varchar2).Value = pDataList.INVOICE_NO;
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE;
            cmd.Parameters.Add("pCURRENT_FORM", OracleDbType.Varchar2).Value = "SNPP105";
            cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_USER_NAME), ParameterDirection.Input);
            cmd.Parameters.Add("pPO_NO1", OracleDbType.Varchar2).Value = pDataList.PO_NO1;
            cmd.Parameters.Add("pGROUP_OPTION", OracleDbType.Varchar2).Value = pDataList.GROUP_OPTION;
            cmd.Parameters.Add("pPO_NO2", OracleDbType.Varchar2).Value = pDataList.PO_NO2;
            cmd.Parameters.Add("pPART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP105_SaveNew")]
        [Authorize]
        public IHttpActionResult SNPP105_SaveNew([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP105_SAVE_NEW";
            cmd.Parameters.Add("pCOM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pINVOICE_NO", OracleDbType.Varchar2).Value = pDataList.INVOICE_NO;
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE;
            cmd.Parameters.Add("pCURRENT_FORM", OracleDbType.Varchar2).Value = "SNPP105";
            cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_USER_NAME), ParameterDirection.Input);
            cmd.Parameters.Add("pPO_NO1", OracleDbType.Varchar2).Value = pDataList.PO_NO1;
            cmd.Parameters.Add("pGROUP_OPTION", OracleDbType.Varchar2).Value = pDataList.GROUP_OPTION;
            cmd.Parameters.Add("pPO_NO2", OracleDbType.Varchar2).Value = pDataList.PO_NO2;
            cmd.Parameters.Add("pPART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO;

            cmd.Parameters.Add("V_ETD_DATE", OracleDbType.Varchar2).Value = pDataList.V_ETD_DATE;
            cmd.Parameters.Add("V_ETP_DATE", OracleDbType.Varchar2).Value = pDataList.V_ETP_DATE;
            cmd.Parameters.Add("V_ETA_EO_BKK_DATE", OracleDbType.Varchar2).Value = pDataList.V_ETA_EO_BKK_DATE;
            cmd.Parameters.Add("V_ETA_EO_UPC_DATE", OracleDbType.Varchar2).Value = pDataList.V_ETA_EO_UPC_DATE;
            cmd.Parameters.Add("V_ETA_RO_BKK_DATE", OracleDbType.Varchar2).Value = pDataList.V_ETA_RO_BKK_DATE;
            cmd.Parameters.Add("V_ETA_RO_UPC_DATE", OracleDbType.Varchar2).Value = pDataList.V_ETA_RO_UPC_DATE;

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNPP105_CalETD_ETP")]
        [Authorize]
        public IHttpActionResult SNPP105_CalETD_ETP([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP105_CAL_ETD_ETP";
            cmd.Parameters.Add("pCOM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pETD_DATE", OracleDbType.Varchar2).Value = pDataList.ETD_DATE;
            cmd.Parameters.Add("pETP_DATE", OracleDbType.Varchar2).Value = pDataList.ETP_DATE;
            cmd.Parameters.Add("pINVOICE_NO", OracleDbType.Varchar2).Value = pDataList.INVOICE_NO;
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE;
            cmd.Parameters.Add("pCURRENT_FORM", OracleDbType.Varchar2).Value = "SNPP105";
            cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_USER_NAME), ParameterDirection.Input);
            cmd.Parameters.Add("pPO_NO1", OracleDbType.Varchar2).Value = pDataList.PO_NO1;
            cmd.Parameters.Add("pGROUP_OPTION", OracleDbType.Varchar2).Value = pDataList.GROUP_OPTION;
            cmd.Parameters.Add("pPO_NO2", OracleDbType.Varchar2).Value = pDataList.PO_NO2;
            cmd.Parameters.Add("pPART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPP105_GetInvoiceByVendor/{pInvNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPP105_GetInvoiceByVendor(string pInvNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            pInvNo = ismoUtil.escapeCharacter(pInvNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_GET_INVOICE_NO";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pInvNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        #endregion


        #region SNPE044

        [HttpPost, Route("SNPE044_UploadandGet")]
        [Authorize]
        public async Task<IHttpActionResult> SNPE044_UploadandGet(HttpRequestMessage request)
        {
            try
            {
                if (!request.Content.IsMimeMultipartContent())
                {
                    throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
                }

                //Upload file to location
                var reqParts = await request.Content.ReadAsMultipartAsync();

                string FullfileName = String.Concat("SNPE044", "-", DateTime.Now.ToString("yyyyMMddHHmm"), ".CSV");
                string outputLocation = "~/tempFile/" + "SNPE044" + "/";
                string outputPath = System.Web.HttpContext.Current.Server.MapPath(outputLocation);
                string fileLocation = String.Concat(outputPath, FullfileName);

                foreach (var file in reqParts.Contents)
                {
                    var buffer = await file.ReadAsByteArrayAsync();

                    DataService.SaveBytesToFileByLocation(buffer
                                                    , fileLocation
                                                    , fileLocation);
                }

                //Delete temp
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE044_DELETE_TEMP";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);


                //Begin read and insert temp
                string Header = "VENDOR_CODE,PO_NO,PART_NO,ETD_CONFIRM,QTY_CONFIRM";
                DataTable dt = DataService.ConvertCSVtoDataTable(fileLocation, Header);

                int count = 0;
                foreach (DataRow data in dt.Rows)
                {
                    count++;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE044_INSERT_TEMP";
                    cmd.Parameters.Add("P_ID", OracleDbType.Int32).Value = count;
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data["VENDOR_CODE"].ToString();
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = data["PO_NO"].ToString();
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                    cmd.Parameters.Add("P_ETD_CONFIRM", OracleDbType.Varchar2).Value = data["ETD_CONFIRM"].ToString();
                    cmd.Parameters.Add("P_QTY_CONFIRM", OracleDbType.Varchar2).Value = data["QTY_CONFIRM"].ToString();
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);
                }

                //Validate data
                DataSet ds = SNPE044_ValidateAndGet();

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE044_UploadandGet");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

        }

        [HttpGet, Route("SNPE044_ValidateAndGet")]
        public DataSet SNPE044_ValidateAndGet()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNPE044_VALIDATE_AND_GET";
            cmd.Parameters.Add("P_COM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return ds;
        }

        [HttpPost, Route("SNPE044_SAVE_ETD")]
        [Authorize]
        public IHttpActionResult SNPE044_SAVE_ETD([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE044_SAVE_ETD_UPLOAD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2, data["VENDOR_CODE"].ToString(), ParameterDirection.Input);
                cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2, data["PO_NO"].ToString(), ParameterDirection.Input);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2, data["PART_NO"].ToString(), ParameterDirection.Input);
                cmd.Parameters.Add("P_ETD_CONFIRM", OracleDbType.Varchar2, data["ETD_CONFIRM"].ToString(), ParameterDirection.Input);
                cmd.Parameters.Add("P_QTY_CONFIRM", OracleDbType.Varchar2, data["QTY_CONFIRM"].ToString(), ParameterDirection.Input);
                cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2, data["ITEM_NO"].ToString(), ParameterDirection.Input);
                cmd.Parameters.Add("P_PO_QTY", OracleDbType.Varchar2, data["PO_QTY"].ToString(), ParameterDirection.Input);
                cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2, data["PO_DATE"].ToString(), ParameterDirection.Input);
                cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_USER_NAME), ParameterDirection.Input);
                cmd.Parameters.Add("P_CURRENT_FORM", OracleDbType.Varchar2, "SNPE044", ParameterDirection.Input);
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

            }
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNPE044_Export")]
        public HttpResponseMessage SNPE1044_Export(List<DataModel.SNPE044> dModel)
        {
            DataTable dt = new DataTable();
            string x = string.Empty;
            string filename = "SNPE044.csv";
            string floderLocation = "SNPE044";
            //dt = DTFM.ToDatatable<DataModel.SNPE044>(dModel);
            dt.Columns.Add("colum1");

            dt.Rows.Add("ID;PO2C");
            dt.Rows.Add("B");
            dt.Rows.Add("C;X1;Y1;K\"No.\"");
            dt.Rows.Add("C;X2;Y1;K\"Vendor Code\"");
            dt.Rows.Add("C;X3;Y1;K\"PO No.\"");
            dt.Rows.Add("C;X4;Y1;K\"Part No.\"");
            dt.Rows.Add("C;X5;Y1;K\"ETD Confirm\"");
            dt.Rows.Add("C;X6;Y1;K\"Qty Confirm\"");
            dt.Rows.Add("C;X7;Y1;K\"Error Message\"");

            //dt.Rows.Add(new object[] { "ID;PO2C", "Rashid"});
            int countrow = 0;
            int itemno = 0;
            for (var i = 0; i < dModel.Count; i++)
            {
                countrow = i + 2;
                itemno = i + 1;
                dt.Rows.Add("C;X1;Y" + countrow + ";K" + '"' + itemno + '"');
                dt.Rows.Add("C;X2;Y" + countrow + ";K" + '"' + dModel[i].VENDOR_CODE + '"');
                dt.Rows.Add("C;X3;Y" + countrow + ";K" + '"' + dModel[i].PO_NO + '"');
                dt.Rows.Add("C;X4;Y" + countrow + ";K" + '"' + dModel[i].PART_NO + '"');
                dt.Rows.Add("C;X5;Y" + countrow + ";K" + '"' + dModel[i].ETD_CONFIRM + '"');
                dt.Rows.Add("C;X6;Y" + countrow + ";K" + '"' + dModel[i].QTY_CONFIRM + '"');
                dt.Rows.Add("C;X7;Y" + countrow + ";K" + '"' + dModel[i].ERR_MASSAGE + '"');
            }

            dt.Rows.Add("E");

            x = DataService.WriteCSVNoColumn(dt, filename, floderLocation);
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }

        #endregion

        #region SNSQ040



        [HttpPost, Route("SNSQ040_GetCriteria")]
        public DataSet SNSQ040_GetCriteria([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ040_GET_CRITERIA";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pDATE_FROM", OracleDbType.Varchar2).Value = pData.DATE_FROM;
            cmd.Parameters.Add("pDATE_TO", OracleDbType.Varchar2).Value = pData.DATE_TO;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return ds;
        }

        [HttpPost, Route("SNSQ040_GetIndentFPO")]
        public DataSet SNSQ040_GetIndentFPO([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ040_GET_INDENT_FPO";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pDATE_FROM", OracleDbType.Varchar2).Value = pData.DATE_FROM;
            cmd.Parameters.Add("pDATE_TO", OracleDbType.Varchar2).Value = pData.DATE_TO;
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE;
            cmd.Parameters.Add("pINDENT_STATUS", OracleDbType.Varchar2).Value = pData.INDENT_STATUS;
            cmd.Parameters.Add("pVENDOR_TYPE", OracleDbType.Varchar2).Value = pData.VENDOR_TYPE;
            cmd.Parameters.Add("pFPO_NO", OracleDbType.Varchar2).Value = pData.FPO_NO;
            cmd.Parameters.Add("pRECOMMAND_ID", OracleDbType.Varchar2).Value = pData.RECOMMAND_ID;


            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cReturn2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return ds;
        }

        [HttpGet, Route("SNSQ040_GetIndentDetailTab2/{FPO_NO}")]
        public DataSet SNSQ040_GetIndentDetailTab2(string FPO_NO)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ040_GET_DETAIL_TAB2";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pFPO_NO", OracleDbType.Varchar2).Value = FPO_NO;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return ds;
        }

        [HttpGet, Route("SNSQ040_GetIndentStatusTab3/{ITEM_NO}/{FPO_NO}")]
        public DataSet SNSQ040_GetIndentStatusTab3(string ITEM_NO, string FPO_NO)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ040_GET_STATUS_TAB3";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pITEM_NO", OracleDbType.Varchar2).Value = ITEM_NO;
            cmd.Parameters.Add("pFPO_NO", OracleDbType.Varchar2).Value = FPO_NO;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return ds;
        }


        [HttpPost, Route("SNSQ040_Download")]
        public HttpResponseMessage SNSQ040_Download(List<DataModel.SNSQ040_MODEL> dModel)
        {
            DataTable dt = new DataTable();
            string x = string.Empty;
            string filename = "SNSQ040_FILE.csv";
            string floderLocation = "SNSQ040";
            dt = DTFM.ToDatatable<DataModel.SNSQ040_MODEL>(dModel);
            x = DataService.WriteCSV(dt, filename, floderLocation, "SNSQ040");
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);

            return File;
        }

        [HttpPost, Route("SNSQ040_UpdateIndentHeader")]
        [Authorize]
        public IHttpActionResult SNSQ040_UpdateIndentHeader([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "sp_NP_SNSQ040_UPDATE_INDENT_H";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("pFPO_NO", OracleDbType.Varchar2).Value = data["FPO_NO"].ToString();
                cmd.Parameters.Add("pSEND_STATUS", OracleDbType.Varchar2).Value = data["SEND_STATUS"].ToString();
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                //dt = ds.Tables[0];

                //if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                //{
                //    string errString = dt.Rows[0]["MESSAGE"].ToString();
                //    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                //}

            }

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNM003P
        [HttpGet, Route("SNM003P_GetData/{VENDOR_CODE}")]
        public DataSet SNM003P_GetData(string VENDOR_CODE)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM003P_GETDATA";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = VENDOR_CODE;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return ds;
        }

        [HttpGet, Route("SNM003P_GetVendorName/{VENDOR_CODE}")]
        public DataSet SNM003P_GetVendorName(string VENDOR_CODE)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM003P_GET_VENDOR_NAME";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = VENDOR_CODE;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return ds;
        }

        [HttpPost, Route("SNM003P_EditVendorCategory")]
        [Authorize]
        public IHttpActionResult SNM003P_EditVendorCategory([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            var x = HttpContext.Current.Request.UserHostAddress;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM003P_EDIT";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE;
            cmd.Parameters.Add("pPART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.CATAGORY;
            cmd.Parameters.Add("pSTOCK_LEVEL_ON", OracleDbType.Varchar2).Value = pDataList.STOCK_LEVEL_ON;
            cmd.Parameters.Add("pSTOCK_LEVEL_OFF", OracleDbType.Varchar2).Value = pDataList.STOCK_LEVEL_OFF;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pIP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
            cmd.Parameters.Add("pLAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM003P";
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM003P_InsertVendorCategory")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM003P_InsertVendorCategory([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();

            foreach (var data in pDataList)
            {

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "sp_NP_SNM003P_INSERT";
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = data["VENDOR_CODE"].ToString();
                cmd.Parameters.Add("pPART_CATEGORY", OracleDbType.Varchar2).Value = data["CATAGORY"].ToString();
                cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("pIP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                cmd.Parameters.Add("pLAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM003P";
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);


            }
            return Ok("DONE");
        }

        #endregion

        #region SNM030P
        [HttpPost, Route("SNM030P_GetFulfillRate")]
        [Authorize]
        public IHttpActionResult SNM030P_GetFulfillRate([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM030P_GET_FULFILLMENT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FULFILL_RATE", OracleDbType.Varchar2).Value = pData.Fulfillment;
            cmd.Parameters.Add("P_SAFE_ALLOWANCE", OracleDbType.Varchar2).Value = pData.SafetyAllowance;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM030P_GetMasterFulfill/{Fulfillment}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM030P_GetMasterFulfill(string Fulfillment, int noofshowrec)
        {
            DataSet ds = new DataSet();

            Fulfillment = ismoUtil.escapeCharacter(Fulfillment);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_FULFILL_RATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FULFILL_RATE", OracleDbType.Varchar2).Value = Fulfillment;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM030P_GetMasterSafeAllowance/{SafetyAllowance}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM030P_GetMasterSafeAllowance(string SafetyAllowance, int noofshowrec)
        {
            DataSet ds = new DataSet();

            SafetyAllowance = ismoUtil.escapeCharacter(SafetyAllowance);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_SAFE_ALLOWANCE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_SAFE_ALLOWANCE", OracleDbType.Varchar2).Value = SafetyAllowance;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM030P_InsertFulfillment")]
        [Authorize]
        public IHttpActionResult SNM030P_InsertFulfillment([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM030P_SAVE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FULFILL_RATE", OracleDbType.Varchar2).Value = pData.Fulfillment;
            cmd.Parameters.Add("P_SAFE_ALLOWANCE", OracleDbType.Varchar2).Value = pData.SafetyAllowance;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pIP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("pLAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM030P";
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM030P_EditFulfillment")]
        [Authorize]
        public IHttpActionResult SNM030P_EditFulfillment([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            //IPAddress ipv4Addresses = Array.Find(Dns.GetHostEntry(string.Empty).AddressList, a => a.AddressFamily == AddressFamily.InterNetwork);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM030P_EDIT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FULFILL_RATE", OracleDbType.Varchar2).Value = pData.Fulfillment;
            cmd.Parameters.Add("P_SAFE_ALLOWANCE", OracleDbType.Varchar2).Value = pData.SafetyAllowance;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pIP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("pLAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM030P";
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM030P_DeleteFulfillment")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM030P_DeleteFulfillment([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            //IPAddress ipv4Addresses = Array.Find(Dns.GetHostEntry(string.Empty).AddressList, a => a.AddressFamily == AddressFamily.InterNetwork);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM030P_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FULFILL_RATE", OracleDbType.Varchar2).Value = pData.Fulfillment;
            cmd.Parameters.Add("P_SAFE_ALLOWANCE", OracleDbType.Varchar2).Value = pData.SafetyAllowance;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pIP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("pLAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM030P";
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNM006P

        [HttpGet, Route("SNM006P_GetBranch/{customerCode}")]
        [Authorize]
        public IHttpActionResult SNM006P_GetBranch(string customerCode)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM006P_BRANCH";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pCUSTOMER_CODE", OracleDbType.Varchar2).Value = customerCode;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }



        [HttpGet, Route("SNM006P_ValidateCustomerCode/{CUSTOMER_CODE}")]
        [Authorize]
        public IHttpActionResult SNM006P_ValidateCustomerCode(string CUSTOMER_CODE)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM006P_VALIDATE_CUS";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = CUSTOMER_CODE;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM006P_GetData")]
        [Authorize]
        public IHttpActionResult SNM006P_GetData([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM006P_GETDATA";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pCUSTOMER_CODE", OracleDbType.Varchar2).Value = pDataList.CUSTOMER_CODE;
            cmd.Parameters.Add("pBRANCH_CODE", OracleDbType.Varchar2).Value = pDataList.BRANCH_CODE;
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM006P_InsertCustomerOil")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM006P_InsertCustomerOil([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            var x = HttpContext.Current.Request.UserHostAddress.ToString();
            //IPAddress ipv4Addresses = Array.Find(Dns.GetHostEntry(string.Empty).AddressList, a => a.AddressFamily == AddressFamily.InterNetwork);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM006P_INSERT";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pCUSTOMER_CODE", OracleDbType.Varchar2).Value = pDataList.CUSTOMER_CODE;
            cmd.Parameters.Add("pBRANCH_CODE", OracleDbType.Varchar2).Value = pDataList.BRANCH_CODE;
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE;
            cmd.Parameters.Add("pOIL_CUST_CODE", OracleDbType.Varchar2).Value = pDataList.OIL_CUST_CODE;
            cmd.Parameters.Add("pOIL_SHIP_CODE", OracleDbType.Varchar2).Value = pDataList.OIL_SHIP_CODE;
            cmd.Parameters.Add("pSERVICE_BRANCH", OracleDbType.Varchar2).Value = pDataList.SERVICE_BRANCH;
            cmd.Parameters.Add("pOIL_PO_CYCLE", OracleDbType.Varchar2).Value = pDataList.OIL_PO_CYCLE;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pLAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM006P";
            cmd.Parameters.Add("pIP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM006P_EditCustomerOil")]
        [Authorize]
        public IHttpActionResult SNM006P_EditCustomerOil([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            var x = HttpContext.Current.Request.UserHostAddress.ToString();
            //IPAddress ipv4Addresses = Array.Find(Dns.GetHostEntry(string.Empty).AddressList, a => a.AddressFamily == AddressFamily.InterNetwork);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM006P_EDIT";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pCUSTOMER_CODE", OracleDbType.Varchar2).Value = pDataList.CUSTOMER_CODE;
            cmd.Parameters.Add("pBRANCH_CODE", OracleDbType.Varchar2).Value = pDataList.BRANCH_CODE;
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE;
            cmd.Parameters.Add("pOIL_CUST_CODE", OracleDbType.Varchar2).Value = pDataList.OIL_CUST_CODE;
            cmd.Parameters.Add("pOIL_SHIP_CODE", OracleDbType.Varchar2).Value = pDataList.OIL_SHIP_CODE;
            cmd.Parameters.Add("pSERVICE_BRANCH", OracleDbType.Varchar2).Value = pDataList.SERVICE_BRANCH;
            cmd.Parameters.Add("pOIL_PO_CYCLE", OracleDbType.Varchar2).Value = pDataList.OIL_PO_CYCLE;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pLAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM006P";
            cmd.Parameters.Add("pIP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM006P_DeleteCustomerOil")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM006P_DeleteCustomerOil([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            var x = HttpContext.Current.Request.UserHostAddress.ToString();
            //IPAddress ipv4Addresses = Array.Find(Dns.GetHostEntry(string.Empty).AddressList, a => a.AddressFamily == AddressFamily.InterNetwork);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM006P_DELETE";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pCUSTOMER_CODE", OracleDbType.Varchar2).Value = pDataList.CUSTOMER_CODE;
            cmd.Parameters.Add("pBRANCH_CODE", OracleDbType.Varchar2).Value = pDataList.BRANCH_CODE;
            cmd.Parameters.Add("pVENDOR_CODE", OracleDbType.Varchar2).Value = pDataList.VENDOR_CODE;
            cmd.Parameters.Add("pSYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("pLAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM006P";
            cmd.Parameters.Add("pIP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion
        //--- SNBA007_IC , SNBA008 , SNBA021_LO
        [HttpGet, Route("GetJobBatchID/{JOB_ID}")]
        [Authorize]
        public IHttpActionResult GetJobBatchID(string JOB_ID)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MAINTENANCE_JOB_LOAD";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pJOB_ID", OracleDbType.Varchar2).Value = JOB_ID;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("GetJobBatchID2/{JOB_ID}")]
        [Authorize]
        public IHttpActionResult GetJobBatchID2(string JOB_ID)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MAINTENANCE_JOB_LOAD_2";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pJOB_ID", OracleDbType.Varchar2).Value = JOB_ID;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        //--- SNBA007_IC , SNBA008 , SNBA021_LO
        [HttpPost, Route("SaveJobBatchID")]
        [Authorize]
        public IHttpActionResult SaveJobBatchID([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MAINTENANCE_JOB_SAVE";
            cmd.Parameters.Add("PCOMPANY_CODE", OracleDbType.Varchar2).Value = data["COMPANY_CODE"].ToString();
            cmd.Parameters.Add("PJOB_ID", OracleDbType.Varchar2).Value = data["JOB_ID"].ToString();
            cmd.Parameters.Add("PJOB_STATUS", OracleDbType.Varchar2).Value = data["JOB_STATUS"].ToString();
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = data["START_DATE"] == null ? (object)DBNull.Value : Convert.ToDateTime(data["START_DATE"]);
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = data["END_DATE"] == null ? (object)DBNull.Value : Convert.ToDateTime(data["END_DATE"]);
            cmd.Parameters.Add("P_START_STATUS", OracleDbType.Varchar2).Value = data["START_STATUS"].ToString();
            cmd.Parameters.Add("P_END_STATUS", OracleDbType.Varchar2).Value = data["END_STATUS"].ToString();
            cmd.Parameters.Add("PUSER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("CReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];

            if (dt.Rows[0]["STATUS"].ToString() == "Fail")
            {
                string errString = data["JOB_ID"].ToString() + "/\n" + dt.Rows[0]["MESSAGE"].ToString();
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            }

            return Ok("Done");

        }


        [HttpPost, Route("SaveJobBatchIDWithPC")]
        [Authorize]
        public IHttpActionResult SaveJobBatchIDWithPC([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MAINTENANCE_PC_JOB_SAVE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = data["COMPANY_CODE"].ToString();
            cmd.Parameters.Add("P_JOB_ID", OracleDbType.Varchar2).Value = data["JOB_ID"].ToString();
            cmd.Parameters.Add("P_JOB_STATUS", OracleDbType.Varchar2).Value = data["JOB_STATUS"].ToString();
            cmd.Parameters.Add("P_PROCESS_CODE", OracleDbType.Varchar2).Value = data["PROCESS_CODE"].ToString();
            cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = data["START_DATE"] == null ? (object)DBNull.Value : Convert.ToDateTime(data["START_DATE"]);
            cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = data["END_DATE"] == null ? (object)DBNull.Value : Convert.ToDateTime(data["END_DATE"]);
            cmd.Parameters.Add("P_START_STATUS", OracleDbType.Varchar2).Value = data["START_STATUS"].ToString();
            cmd.Parameters.Add("P_END_STATUS", OracleDbType.Varchar2).Value = data["END_STATUS"].ToString();
            cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];

            if (dt.Rows[0]["STATUS"].ToString() == "Fail")
            {
                string errString = data["JOB_ID"].ToString() + "/\n" + dt.Rows[0]["MESSAGE"].ToString();
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            }

            return Ok("Done");

        }


        [HttpPost, Route("ClearJobBatchID")]
        [Authorize]
        public IHttpActionResult ClearJobBatchID([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MAINTENANCE_JOB_CLEAR";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = data["COMPANY_CODE"].ToString();
            cmd.Parameters.Add("P_JOB_ID", OracleDbType.Varchar2).Value = data["JOB_ID"].ToString();
            cmd.Parameters.Add("P_JOB_STATUS", OracleDbType.Varchar2).Value = data["JOB_STATUS"].ToString();
            cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];

            if (dt.Rows[0]["STATUS"].ToString() == "Fail")
            {
                string errString = data["JOB_ID"].ToString() + "/\n" + dt.Rows[0]["MESSAGE"].ToString();
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            }

            return Ok("Done");

        }

        //--- SNBA007_IC , SNBA008 , SNBA021_LO
        [HttpGet, Route("GetBatchSub/{JOB_ID}")]
        [Authorize]
        public IHttpActionResult GetBatchSub(string JOB_ID)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MAINTENANCE_BTH_SUB_LOAD";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pJOB_ID", OracleDbType.Varchar2).Value = JOB_ID;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        //--- SNBA007_IC , SNBA008 , SNBA021_LO
        [HttpPost, Route("SaveBatchSub")]
        [Authorize]
        public IHttpActionResult SaveBatchSub([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MAINTENANCE_BTH_SUB_SAVE";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = data["COMPANY_CODE"].ToString();
            cmd.Parameters.Add("pJOB_ID", OracleDbType.Varchar2).Value = data["JOB_ID"].ToString();
            cmd.Parameters.Add("pJOB_STATUS", OracleDbType.Varchar2).Value = data["JOB_STATUS"].ToString();
            cmd.Parameters.Add("pUSER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];

            if (dt.Rows[0]["STATUS"].ToString() == "Fail")
            {
                string errString = data["JOB_ID"].ToString() + "/\n" + dt.Rows[0]["MESSAGE"].ToString();
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            }

            return Ok("Done");

        }


        #region SNM080P

        [HttpPost, Route("SNPE005_M_CancelPart/{po_no}/{item_no}/{sub_item_no}")]
        [Authorize]
        public IHttpActionResult SNPE005_M_CancelPart(string po_no, string item_no, string sub_item_no)
        {
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSP005_M_DELETE_INDENT";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = po_no;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = item_no;
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = sub_item_no;

            cmd = oOracledb.SqlQueryReturnValue(cmd);

            return Ok();
        }

        //---- SNM080P SP_NP_SNM080P_FIND_2DS
        [HttpGet, Route("GetIndenStatus/{PO_NO}")]
        [Authorize]
        public IHttpActionResult GetIndenStatus(string PO_NO)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM080P_FIND_2DS";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pPO_NO", OracleDbType.Varchar2).Value = PO_NO;
            cmd.Parameters.Add("cRETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cRETRUN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("GetIndentStatus/{PO_NO}/{PO_DATE}/{INVOICE_NO}/{INVOICE_DATE}/{SHIPPED_DATE}/{ORDER_PART_NO}/{ACCEPT_PART_NO}")]
        [Authorize]
        public IHttpActionResult GetIndentStatus(string PO_NO, string PO_DATE, string INVOICE_NO, string INVOICE_DATE, string SHIPPED_DATE, string ORDER_PART_NO, string ACCEPT_PART_NO)
        {
            DataSet ds = new DataSet();

            INVOICE_NO = ismoUtil.escapeCharacter(INVOICE_NO);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM080P_FIND_DETAIL";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pPO_NO", OracleDbType.Varchar2).Value = PO_NO.ToUpper() == "NULL" ? (object)DBNull.Value : PO_NO;
            cmd.Parameters.Add("pPO_DATE", OracleDbType.Varchar2).Value = PO_DATE.ToUpper() == "NULL" ? (object)DBNull.Value : PO_DATE;
            cmd.Parameters.Add("pINVOICE_NO", OracleDbType.Varchar2).Value = INVOICE_NO.ToUpper() == "NULL" ? (object)DBNull.Value : INVOICE_NO;
            cmd.Parameters.Add("pINVOICE_DATE", OracleDbType.Varchar2).Value = INVOICE_DATE.ToUpper() == "NULL" ? (object)DBNull.Value : INVOICE_DATE;
            cmd.Parameters.Add("pSHIPPED_DATE", OracleDbType.Varchar2).Value = SHIPPED_DATE.ToUpper() == "NULL" ? (object)DBNull.Value : SHIPPED_DATE;
            cmd.Parameters.Add("pORDER_PART_NO", OracleDbType.Varchar2).Value = ORDER_PART_NO.ToUpper() == "NULL" ? (object)DBNull.Value : ORDER_PART_NO;
            cmd.Parameters.Add("pACCEPT_PART_NO", OracleDbType.Varchar2).Value = ACCEPT_PART_NO.ToUpper() == "NULL" ? (object)DBNull.Value : ACCEPT_PART_NO;
            cmd.Parameters.Add("cRETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        //---- SNM080P SP_NP_SNM080P_ETD_LIST
        [HttpGet, Route("GetETDList/{PO_NO}/{ITEM_NO}/{SUB_ITEM_NO}")]
        [Authorize]
        public IHttpActionResult GetETDList(string PO_NO, int ITEM_NO, string SUB_ITEM_NO)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM080P_ETD_LIST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = PO_NO;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = ITEM_NO;
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = SUB_ITEM_NO;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpPost, Route("GetExchangeRate")]
        [Authorize]
        public IHttpActionResult GetExchangeRate([FromBody] dynamic data)
        {
            //DataSet ds = new DataSet();

            //OracleCommand cmd = new OracleCommand();
            //cmd.CommandText = "SP_NP_CAL_EXCHANGE_RATE";
            //cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            //cmd.Parameters.Add("P_SHIPPED_DATE", OracleDbType.Varchar2).Value = SHIPPED_DATE;
            //cmd.Parameters.Add("P_CURRENCY_CODE", OracleDbType.Varchar2).Value = CURRENCY_CODE;
            //cmd.Parameters.Add("P_NET_AMT_C", OracleDbType.Double).Value = NET_AMT_C;
            //cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_CAL_EXCHANGE_RATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("P_SHIPPED_DATE", OracleDbType.Varchar2).Value = data["SHIPPED_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_CURRENCY_CODE", OracleDbType.Varchar2).Value = data["CURRENCY_CODE"].ToString();
            cmd.Parameters.Add("P_NET_AMT_C", OracleDbType.Double).Value = data["NET_AMT_C"].ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        [HttpPost, Route("SNM080P_EditItem")]
        [Authorize]
        public IHttpActionResult SNM080P_EditItem([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM080P_SAVE";


                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = data["PO_NO"].ToString();
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data["ORDER_TYPE"].ToString();
                cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = data["ITEM_NO"].ToString();
                cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data["SUB_ITEM_NO"].ToString();
                cmd.Parameters.Add("P_ORDER_QTY", OracleDbType.Varchar2).Value = data["ORDER_QTY"].ToString();
                cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Varchar2).Value = data["ACCEPT_QTY"].ToString();
                cmd.Parameters.Add("P_NET_WEIGHT", OracleDbType.Double).Value = data["NET_WEIGHT"].ToString();
                cmd.Parameters.Add("P_UNIT_PRICE", OracleDbType.Double).Value = data["UNIT_PRICE"].ToString();
                cmd.Parameters.Add("P_TARIFF_CODE", OracleDbType.Varchar2).Value = data["TARIFF_CODE"].ToString();

                //oOracledb.WriteLog("ErrorHandle", "DUTY_RATE " + data["DUTY_RATE"].ToString(), "SNM080P_EditItem");
                //oOracledb.WriteLog("ErrorHandle", "NET_AMT_C " + data["NET_AMT_C"].ToString(), "SNM080P_EditItem");
                //oOracledb.WriteLog("ErrorHandle", "EXCHANGE_RATE " + data["EXCHANGE_RATE"].ToString(), "SNM080P_EditItem");
                //oOracledb.WriteLog("ErrorHandle", "NET_AMT_B " + data["NET_AMT_B"].ToString(), "SNM080P_EditItem");

                cmd.Parameters.Add("P_DUTY_RATE", OracleDbType.Double).Value = data["DUTY_RATE"].ToString();
                cmd.Parameters.Add("P_SERIAL_NO", OracleDbType.Varchar2).Value = data["SERIAL_NO"].ToString();
                cmd.Parameters.Add("P_NET_AMT_C", OracleDbType.Double).Value = data["NET_AMT_C"].ToString();
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = data["INVOICE_NO"].ToString();
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Varchar2).Value = data["INVOICE_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_SHIPPED_DATE", OracleDbType.Varchar2).Value = data["SHIPPED_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_CONTAINER_NO", OracleDbType.Varchar2).Value = data["CONTAINER_NO"].ToString();
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = data["CASE_NO"].ToString();
                cmd.Parameters.Add("P_SUB_CASE_NO", OracleDbType.Varchar2).Value = data["SUB_CASE_NO"].ToString();

                //oOracledb.WriteLog("ErrorHandle", "Track 01", "SNM080P_EditItem");

                cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Varchar2).Value = data["ETD_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_ETP_DATE", OracleDbType.Varchar2).Value = data["ETP_DATE"].ToString("dd-MM-yyyy");
                //oOracledb.WriteLog("ErrorHandle", "Track 02", "SNM080P_EditItem");
                cmd.Parameters.Add("P_ARRIVAL_DATE", OracleDbType.Varchar2).Value = data["ARRIVAL_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_ETA_EO_BKK_DATE", OracleDbType.Varchar2).Value = data["ETA_EO_BKK_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_ETA_EO_UPC_DATE", OracleDbType.Varchar2).Value = data["ETA_EO_UPC_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_ETA_RO_BKK_DATE", OracleDbType.Varchar2).Value = data["ETA_RO_BKK_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_ETA_RO_UPC_DATE", OracleDbType.Varchar2).Value = data["ETA_RO_UPC_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = data["STATUS_CODE"].ToString();
                cmd.Parameters.Add("P_STATUS_ACCOUNT", OracleDbType.Varchar2).Value = data["STATUS_ACCOUNT"].ToString();
                cmd.Parameters.Add("P_CURRENCY_CODE", OracleDbType.Varchar2).Value = data["CURRENCY_CODE"].ToString();

                //oOracledb.WriteLog("ErrorHandle", "Track 03", "SNM080P_EditItem");
                cmd.Parameters.Add("P_EXCHANGE_RATE", OracleDbType.Double).Value = data["EXCHANGE_RATE"].ToString();
                cmd.Parameters.Add("P_NET_AMT_B", OracleDbType.Double).Value = data["NET_AMT_B"].ToString();
                //oOracledb.WriteLog("ErrorHandle", "Track 04", "SNM080P_EditItem");

                cmd.Parameters.Add("pUSER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "DONE")
                    {
                        oOracledb.WriteLog("ErrorHandle", ds.Tables[0].Rows[0]["STATUS"].ToString(), "SNM080P_EditItem");
                        return Ok("Error : " + ds.Tables[0].Rows[0]["STATUS"].ToString());
                    }
                    else
                    {
                        return Ok("Done");
                    }
                }
                else
                {
                    return Ok("Error");
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle"
                    , ", ITEM_NO : " + data["ITEM_NO"].ToString() +
                    ", SUB_ITEM_NO : " + data["SUB_ITEM_NO"].ToString() +
                     ", PO_NO : " + data["PO_NO"].ToString() + "  : " +
                    ex.Message, "SNM080P_EditItem");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }


        }

        [HttpPost, Route("SNM080P_AddSubItem")]
        [Authorize]
        public IHttpActionResult SNM080P_AddSubItem([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM080P_ADD_SUB_ITEM_R";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = data["PO_NO"].ToString();
            cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2).Value = data["PO_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data["ORDER_TYPE"].ToString();
            cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = data["PO_CLASS"].ToString();
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data["VENDOR_CODE"].ToString();
            cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = data["ORDER_PART_NO"].ToString();
            cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = data["ACCEPT_PART_NO"].ToString();


            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = data["ITEM_NO"].ToString();
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data["SUB_ITEM_NO"].ToString();
            cmd.Parameters.Add("P_OLD_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data["OLD_SUB_ITEM_NO"].ToString();

            cmd.Parameters.Add("P_ORDER_QTY", OracleDbType.Int16).Value = data["ORDER_QTY"].ToString();
            cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Int16).Value = data["ACCEPT_QTY"].ToString();
            cmd.Parameters.Add("P_NET_WEIGHT", OracleDbType.Double).Value = data["NET_WEIGHT"].ToString();
            cmd.Parameters.Add("P_UNIT_PRICE", OracleDbType.Double).Value = data["UNIT_PRICE"].ToString();
            cmd.Parameters.Add("P_TARIFF_CODE", OracleDbType.Varchar2).Value = data["TARIFF_CODE"].ToString();
            cmd.Parameters.Add("P_DUTY_RATE", OracleDbType.Double).Value = data["DUTY_RATE"].ToString();
            cmd.Parameters.Add("P_SERIAL_NO", OracleDbType.Varchar2).Value = data["SERIAL_NO"].ToString();
            cmd.Parameters.Add("P_NET_AMT_C", OracleDbType.Double).Value = data["NET_AMT_C"].ToString();
            cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = data["INVOICE_NO"].ToString();
            cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Varchar2).Value = data["INVOICE_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_SHIPPED_DATE", OracleDbType.Varchar2).Value = data["SHIPPED_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_CONTAINER_NO", OracleDbType.Varchar2).Value = data["CONTAINER_NO"].ToString();
            cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = data["CASE_NO"].ToString();
            cmd.Parameters.Add("P_SUB_CASE_NO", OracleDbType.Varchar2).Value = data["SUB_CASE_NO"].ToString();

            cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Varchar2).Value = data["ETD_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETP_DATE", OracleDbType.Varchar2).Value = data["ETP_DATE"].ToString("dd-MM-yyyy");

            cmd.Parameters.Add("P_ARRIVAL_DATE", OracleDbType.Varchar2).Value = data["ARRIVAL_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETA_EO_BKK_DATE", OracleDbType.Varchar2).Value = data["ETA_EO_BKK_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETA_EO_UPC_DATE", OracleDbType.Varchar2).Value = data["ETA_EO_UPC_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETA_RO_BKK_DATE", OracleDbType.Varchar2).Value = data["ETA_RO_BKK_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETA_RO_UPC_DATE", OracleDbType.Varchar2).Value = data["ETA_RO_UPC_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = data["STATUS_CODE"];
            cmd.Parameters.Add("P_STATUS_ACCOUNT", OracleDbType.Varchar2).Value = data["STATUS_ACCOUNT"];
            cmd.Parameters.Add("P_CURRENCY_CODE", OracleDbType.Varchar2).Value = data["CURRENCY_CODE"];
            cmd.Parameters.Add("P_EXCHANGE_RATE", OracleDbType.Double).Value = data["EXCHANGE_RATE"].ToString();
            cmd.Parameters.Add("P_NET_AMT_B", OracleDbType.Double).Value = data["NET_AMT_B"].ToString();


            cmd.Parameters.Add("pUSER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            if (ds.Tables.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "DONE")
                {
                    return Ok("Error : " + ds.Tables[0].Rows[0]["STATUS"].ToString());
                }
                else
                {
                    return Ok("Done");
                }
            }
            else
            {
                return Ok("Error");
            }

        }


        [HttpPost, Route("SNM080P_UpdateETD")]
        [Authorize]
        public IHttpActionResult SNM080P_UpdateETD([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM080P_ETD_SAVE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            //cmd.Parameters.Add("P_MODE", OracleDbType.Varchar2).Value = "";
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = data["PO_NO"].ToString();
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = data["ITEM_NO"].ToString();
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data["SUB_ITEM_NO"].ToString();
            cmd.Parameters.Add("P_H_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data["H_SUB_ITEM_NO"].ToString();

            cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Int16).Value = data["ACCEPT_QTY"].ToString();
            cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Varchar2).Value = data["ETD_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETP_DATE", OracleDbType.Varchar2).Value = data["ETP_DATE"].ToString("dd-MM-yyyy");

            cmd.Parameters.Add("P_ETA_EO_BKK_DATE", OracleDbType.Varchar2).Value = data["ETA_EO_BKK_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETA_EO_UPC_DATE", OracleDbType.Varchar2).Value = data["ETA_EO_UPC_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETA_RO_BKK_DATE", OracleDbType.Varchar2).Value = data["ETA_RO_BKK_DATE"].ToString("dd-MM-yyyy");
            cmd.Parameters.Add("P_ETA_RO_UPC_DATE", OracleDbType.Varchar2).Value = data["ETA_RO_UPC_DATE"].ToString("dd-MM-yyyy");

            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = data["LAST_UPD_PGM"].ToString();

            cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


            ds = oOracledb.SqlQueryDS_CMD(cmd);

            if (ds.Tables.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "Done")
                {
                    return Ok("Error : " + ds.Tables[0].Rows[0]["MESSAGE"].ToString());
                }
                else
                {
                    return Ok("Done");
                }
            }
            else
            {
                return Ok("Error");
            }


        }


        [HttpPost, Route("GetEstimateDate")]
        [Authorize]
        public IHttpActionResult GetEstimateDate([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_CAL_ETD_ETP";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CALC_DATE", OracleDbType.Varchar2).Value = data["CALC_DATE"].ToString("dd-MM-yyyy");

            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data["VENDOR_CODE"].ToString();
            cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = data["VENDOR_TYPE"].ToString();
            cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = data["PO_CLASS"].ToString();
            cmd.Parameters.Add("P_JOB_TYPE", OracleDbType.Varchar2).Value = data["JOB_TYPE"].ToString();
            cmd.Parameters.Add("P_CALC_TYPE", OracleDbType.Varchar2).Value = data["CALC_TYPE"].ToString();

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("SNM080P_GetInvoice/{pInvNo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNM080P_GetInvoice(string pInvNo, int pShowRec)
        {
            DataSet ds = new DataSet();

            pInvNo = ismoUtil.escapeCharacter(pInvNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_GET_INVOICE_NO";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pInvNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        #endregion

        #region SNPE005

        [HttpGet, Route("GetVendorInfoSNP005/{PO_NO}/{PO_DATE}/{PO_CLASS}/{VENDOR_CODE}")]
        [Authorize]
        public IHttpActionResult GetVendorInfoSNP005(string PO_NO, string PO_DATE, string PO_CLASS, string VENDOR_CODE)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE005_VENDOR_INFO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = PO_NO;
            cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2).Value = PO_DATE;
            cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = PO_CLASS;
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VENDOR_CODE;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("GetETD_SNP005/{PART_NO}/{PO_DATE}/{C_METHOD}/{VENDOR_TYPE}/{VENDOR_CODE}")]
        [Authorize]
        public IHttpActionResult GetETD_SNP005(string PART_NO, string PO_DATE, string C_METHOD, string VENDOR_TYPE, string VENDOR_CODE)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE005_ETD_GET";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PART_NO;
            cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2).Value = PO_DATE;
            cmd.Parameters.Add("P_C_METHOD", OracleDbType.Varchar2).Value = C_METHOD;
            cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = VENDOR_TYPE;
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VENDOR_CODE;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }


        [HttpGet, Route("GenPO/{ORDER_CLASS}/{ORDER_TYPE}/{OVERSEA_FLAG}")]
        [Authorize]
        public IHttpActionResult GenPO(string ORDER_CLASS, string ORDER_TYPE, string OVERSEA_FLAG)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE005_GET_PO_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = ORDER_CLASS;
            cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = ORDER_TYPE;
            cmd.Parameters.Add("P_OVERSEA_FLAG", OracleDbType.Varchar2).Value = OVERSEA_FLAG;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpPost, Route("SavePOWithPartNo")]
        [Authorize]
        public IHttpActionResult SavePOWithPartNo([FromBody] dynamic[] data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string gPoNo;

            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd.CommandText = "SP_NP_SNPE005_GET_PO_NO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data[0]["PO_CLASS"].ToString();
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data[0]["ORDER_TYPE"].ToString();
                cmd.Parameters.Add("P_OVERSEA_FLAG", OracleDbType.Varchar2).Value = data[0]["OVERSEA_FLAG"].ToString();
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                gPoNo = ds.Tables[0].Rows[0][0].ToString();
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Ok("Error : Found duplicate PO, please try to save again.");
                }

                odb.WriteLog("SNPE005_M Save PO", ex.Message, ex.StackTrace);
                throw new Exception("Error : " + ex.Message);
            }
            catch (Exception ex)
            {
                odb.WriteLog("SNPE005_M Save PO", ex.Message, ex.StackTrace);
                throw new Exception("Error : " + ex.Message);
            }

            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE005_BACKUP_CPS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = gPoNo;
                cmd.Parameters.Add("R_ROW_INSERTED", OracleDbType.Decimal).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                var rowCount = cmd.Parameters["R_ROW_INSERTED"].Value.ToString();

                odb.WriteLog("SNPE005_M Save PO", "Backup CPS file completed for PO: " + gPoNo + ". total " + rowCount + " records.", "");
            }
            catch (OracleException ex)
            {
                if (ex.Number == 1)
                {
                    odb.WriteLog("SNPE005_M Save PO", "Duplicate records on backup CPS", ex.StackTrace);
                    throw new Exception("Error : " + ex.Message);
                }
            }
            catch (Exception ex)
            {
                odb.WriteLog("SNPE005_M Save PO", ex.Message, ex.StackTrace);
                throw new Exception("Error : " + ex.Message);
            }

            foreach (dynamic d in data)
            {
                try
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE005_SAVE_PART_NO";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = gPoNo;
                    cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2).Value = data[0]["PO_DATE"].ToString("dd-MM-yyyy");
                    cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = data[0]["PO_CLASS"].ToString();
                    cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data[0]["ORDER_TYPE"].ToString();

                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data[0]["VENDOR_CODE"].ToString();
                    cmd.Parameters.Add("P_TOTAL_QTY", OracleDbType.Int16).Value = data[0]["TOTAL_QTY"].ToString();
                    cmd.Parameters.Add("P_TOTAL_AMT", OracleDbType.Varchar2).Value = data[0]["TOTAL_AMT"].ToString();
                    cmd.Parameters.Add("P_TOT_AVERAGE_AMT", OracleDbType.Varchar2).Value = data[0]["TOTAL_AVERAGE_AMT"].ToString();
                    cmd.Parameters.Add("P_TOT_STANDARD_AMT", OracleDbType.Varchar2).Value = data[0]["TOTAL_STANDARD_AMT"].ToString();
                    cmd.Parameters.Add("P_COUNT_ITEM", OracleDbType.Int16).Value = data[0]["COUNT_ITEM"].ToString();

                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = d["ITEM_NO"].ToString();
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"].ToString();
                    cmd.Parameters.Add("P_ORDER_QTY", OracleDbType.Int16).Value = d["ACCEPT_QTY"].ToString();
                    cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Varchar2).Value = d["ETD_DATE"].ToString("dd-MM-yyyy");

                    cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = data[0]["LAST_UPD_PGM"].ToString();
                    cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                    ds = oOracledb.SqlQueryDS_CMD(cmd);

                    if (ds.Tables.Count > 0)
                    {
                        if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "Done")
                        {
                            string errString = "Error : " + d["PART_NO"].ToString() + "/\n" + ds.Tables[0].Rows[0]["STATUS"].ToString();
                            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                        }
                    }
                    else
                    {
                        //dt = new DataTable();
                        return Ok("Error : No return data");
                    }



                }
                catch (Exception ex)
                {
                    //--- Roll back ---
                    odb.WriteLog("SNPE005_M Save PO", ex.Message, ex.StackTrace);
                    return Ok("Error : " + ex.Message);
                }
                finally
                {

                }


            }

            //if (dt.Rows[0]["STATUS"].ToString() == "Fail")
            //{
            //    string errString = d["P_PART_NO"].ToString() + "/\n" + dt.Rows[0]["MESSAGE"].ToString();
            //    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            //}

            return Ok(gPoNo);

        }

        [HttpPost, Route("SNPE005_M_EditPart")]
        [Authorize]
        public IHttpActionResult SNPE005_M_EditPart([FromBody] dynamic[] data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();

            foreach (dynamic d in data)
            {
                try
                {

                    if (d["itemType"] == null)
                    {
                        cmd = new OracleCommand();
                        cmd.CommandText = "sp_np_snpe005_edit_part";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = d["PO_NO"].ToString();
                        cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2).Value = d["PO_DATE"].ToString("dd-MM-yyyy");
                        cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = d["PO_CLASS"].ToString();
                        cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = d["ORDER_TYPE"].ToString();

                        cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = d["VENDOR_CODE"].ToString();

                        cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = d["ITEM_NO"].ToString();
                        cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = d["SUB_ITEM_NO"].ToString();

                        cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"].ToString();
                        cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = d["STATUS_CODE"].ToString();

                        cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Varchar2).Value = d["ETD_DATE"].ToString("dd-MM-yyyy");
                        cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                        cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = d["LAST_UPD_PGM"].ToString();
                        cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                        ds = oOracledb.SqlQueryDS_CMD(cmd);
                    }
                    else if (d["itemType"].ToString() == "New")
                    {
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNPE005_SAVE_PART_NO";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = d["PO_NO"].ToString();
                        cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2).Value = data[0]["PO_DATE"].ToString("dd-MM-yyyy");
                        cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = data[0]["PO_CLASS"].ToString();
                        cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data[0]["ORDER_TYPE"].ToString();

                        cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data[0]["VENDOR_CODE"].ToString();
                        cmd.Parameters.Add("P_TOTAL_QTY", OracleDbType.Int16).Value = 0;
                        cmd.Parameters.Add("P_TOTAL_AMT", OracleDbType.Varchar2).Value = "0";
                        cmd.Parameters.Add("P_TOT_AVERAGE_AMT", OracleDbType.Varchar2).Value = "0";
                        cmd.Parameters.Add("P_TOT_STANDARD_AMT", OracleDbType.Varchar2).Value = "0";
                        cmd.Parameters.Add("P_COUNT_ITEM", OracleDbType.Int16).Value = 0;

                        cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = d["ITEM_NO"].ToString();
                        cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"].ToString();
                        cmd.Parameters.Add("P_ORDER_QTY", OracleDbType.Int16).Value = d["ACCEPT_QTY"].ToString();
                        cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Varchar2).Value = d["ETD_DATE"].ToString("dd-MM-yyyy");

                        cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = data[0]["LAST_UPD_PGM"].ToString();
                        cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                        cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                        ds = oOracledb.SqlQueryDS_CMD(cmd);
                    }

                    if (ds.Tables.Count > 0)
                    {
                        if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "Done")
                        {
                            string errString = "Error : " + d["PART_NO"].ToString() + "/\n" + ds.Tables[0].Rows[0]["STATUS"].ToString();
                            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                        }
                    }
                }
                catch (Exception ex)
                {
                    //--- Roll back ---
                    string errString = d["P_PART_NO"].ToString() + ex.Message.ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));

                }



            }

            return Ok("Done");

        }


        [HttpPost, Route("SNPE005_M_SaveAddPart/{pPoNo}")]
        [Authorize]
        public IHttpActionResult SNPE005_M_SaveAddPart(string pPoNo, [FromBody] dynamic[] data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();

            foreach (dynamic d in data)
            {
                try
                {
                    cmd = new OracleCommand();

                    cmd.CommandText = "SP_NP_SNPE005_SAVE_PART_NO";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pPoNo;
                    cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2).Value = data[0]["PO_DATE"].ToString("dd-MM-yyyy");
                    cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = data[0]["PO_CLASS"].ToString();
                    cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data[0]["ORDER_TYPE"].ToString();

                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data[0]["VENDOR_CODE"].ToString();
                    cmd.Parameters.Add("P_TOTAL_QTY", OracleDbType.Int16).Value = data[0]["TOTAL_QTY"].ToString();
                    cmd.Parameters.Add("P_TOTAL_AMT", OracleDbType.Varchar2).Value = data[0]["TOTAL_AMT"].ToString();
                    cmd.Parameters.Add("P_TOT_AVERAGE_AMT", OracleDbType.Varchar2).Value = data[0]["TOTAL_AVERAGE_AMT"].ToString();
                    cmd.Parameters.Add("P_TOT_STANDARD_AMT", OracleDbType.Varchar2).Value = data[0]["TOTAL_STANDARD_AMT"].ToString();
                    cmd.Parameters.Add("P_COUNT_ITEM", OracleDbType.Int16).Value = data[0]["COUNT_ITEM"].ToString();

                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = d["ITEM_NO"].ToString();
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"].ToString();
                    cmd.Parameters.Add("P_ORDER_QTY", OracleDbType.Int16).Value = d["ACCEPT_QTY"].ToString();
                    cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Varchar2).Value = d["ETD_DATE"].ToString("dd-MM-yyyy");

                    cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = data[0]["LAST_UPD_PGM"].ToString();
                    cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                    // dt = ds.Tables[0];
                    ///return Ok("Done");

                    if (ds.Tables.Count > 0)
                    {
                        if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "Done")
                        {
                            string errString = "Error : " + d["PART_NO"].ToString() + "/\n" + ds.Tables[0].Rows[0]["STATUS"].ToString();
                            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                        }
                    }
                }
                catch (Exception ex)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE005_M_SaveAddPart");
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));

                }

            }

            return Ok("Done");

        }

        #endregion

        #region SNPE003
        [HttpGet, Route("SNPE003_GetVendorInfo/{pVendorCode?}")]
        [Authorize]
        public IHttpActionResult SNPE003_GetVendorInfo(string pVendorCode = "")
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNPE003_GET_VENDOR_INFO";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode.ToString();


                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPE003_GetPoSuggestion/{pVendorCode}")]
        [Authorize]
        public IHttpActionResult SNPE003_GetPoSuggestion(string pVendorCode)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNPE003_SCH_PO_SUGGEST";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode.ToString();

                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPE003_SaveChange")]
        [Authorize]
        public IHttpActionResult SNPE003_SaveChange([FromBody] dynamic[] paramList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string screenId = "SNPE003";
            foreach (var param in paramList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE003_SAVE_CHANGE";
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_GROUP_PART_NO", OracleDbType.Varchar2).Value = param["GROUP_PART_NO"].ToString();
                cmd.Parameters.Add("PI_SUGGEST_QTY", OracleDbType.Varchar2).Value = param["SUGGEST_ORDER_QTY"].ToString();
                cmd.Parameters.Add("PI_LOCK_SUGGEST", OracleDbType.Varchar2).Value = param["LOCK_SUGGEST"].ToString();
                cmd.Parameters.Add("PI_SUGGEST_STATUS", OracleDbType.Varchar2).Value = param["_CancelRequest"].ToString();
                cmd.Parameters.Add("PI_SCREEN_ID", OracleDbType.Varchar2).Value = screenId;
                cmd.Parameters.Add("PI_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("PO_C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                {
                    string errString = dt.Rows[0]["MESSAGE"].ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }

            }

            return Ok("Done");
        }


        [HttpGet, Route("SNPE003_GetPartInfo/{partNo}")]
        [Authorize]
        public IHttpActionResult SNPE003_GetPartInfo(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE003_GET_PART_INFO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN5", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN6", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        #endregion


        #region SNPP021LO

        [HttpGet, Route("SNPP021LO_GetData")]
        [Authorize]
        public IHttpActionResult SNPP021LO_GetData()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP021LO";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPP021LO_GetVendor")]
        [Authorize]
        public IHttpActionResult SNPP021LO_GetVendor()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP021LO_VENDOR";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP021LO_BeginProcess")]
        [Authorize]
        public IHttpActionResult SNPP021LO_BeginProcess()
        {
            DataSet ds = new DataSet();
            string returnMessage;
            string status;

            OracleCommand cmd = new OracleCommand();

            cmd.CommandText = "SP_NP_SNPP021LO_MAIN_PROCESS";
            cmd.Parameters.Add("VPARAM_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("VPARAM_PGM", OracleDbType.Varchar2).Value = "SNPP021LO";
            cmd.Parameters.Add("VPARAM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_PO_RANGE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            DataTable dtProcessStatus = ds.Tables[0];

            returnMessage = dtProcessStatus.Rows[0]["MESSAGE"].ToString();
            status = dtProcessStatus.Rows[0]["STATUS"].ToString();

            if (status == "Fail")
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, returnMessage));
            }
            else if (status == "Done")
            {
                DataTable dtPORange = ds.Tables[1];

                return Ok(new { START_PO = dtPORange.Rows[0]["START_PO"], END_PO = dtPORange.Rows[0]["END_PO"] });
            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, "Something wrong in process."));
        }

        #endregion

        #region SNPP202

        [HttpGet, Route("SNPP202_GetINV/{pInvNo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNPP202_GetINV(string pInvNo, int pShowRec)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP202_INV_NO";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ITM_INV_NO", OracleDbType.Varchar2).Value = pInvNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNPP202_StartProcess/{pFInvNo}/{pLInvNo}")]
        [Authorize]
        public IHttpActionResult SNPP202_StartProcess(string pFInvNo, string pLInvNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP202_START_PROCESS";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_ITM_FIN_NO", OracleDbType.Varchar2).Value = ismoUtil.escapeCharacter(pFInvNo);
            cmd.Parameters.Add("P_ITM_LIN_NO", OracleDbType.Varchar2).Value = ismoUtil.escapeCharacter(pLInvNo);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_ALL_REC", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            DataTable dtProcessStatus = ds.Tables[0];

            string returnMessage = dtProcessStatus.Rows[0]["MESSAGE"].ToString();
            string status = dtProcessStatus.Rows[0]["STATUS"].ToString();

            if (status == "Fail")
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, returnMessage));
            }
            else if (status == "Done")
            {
                DataTable dtCountRec = ds.Tables[1];

                return Ok(new { COUNT_REC = dtCountRec.Rows[0]["COUNT_REC"] });
            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, "Something wrong in process."));
        }
        #endregion

        #region SNSQ009

        [HttpGet, Route("SNSQ009_GetAcceptPart/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSQ009_GetAcceptPart(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ009_GET_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ009_Query/{accept_part_no}")]
        [Authorize]
        public IHttpActionResult SNSQ009_Query(string accept_part_no)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ009_QUERY";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("p_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = accept_part_no;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ010_Query/{accept_part_no}")]
        [Authorize]
        public IHttpActionResult SNSQ010_Query(string accept_part_no)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ010_QUERY";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("p_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = accept_part_no;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSQ009_SaveUpdate")]
        [Authorize]
        public IHttpActionResult SNSQ009_SaveUpdate([FromBody] dynamic[] pCancelRec)
        {
            DataSet ds = new DataSet();

            foreach (var rec in pCancelRec)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSQ009_SAVE";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("p_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("p_CUSTOMER_CODE", OracleDbType.Varchar2).Value = rec["CUSTOMER_CODE"].ToString();
                cmd.Parameters.Add("p_ORDER_NO", OracleDbType.Varchar2).Value = rec["ORDER_NO"].ToString();
                cmd.Parameters.Add("p_ITEM_NO", OracleDbType.Varchar2).Value = rec["ITEM_NO"].ToString();
                cmd.Parameters.Add("p_SUB_ITEM_NO", OracleDbType.Varchar2).Value = rec["SUB_ITEM_NO"].ToString();
                cmd.Parameters.Add("p_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = rec["ACCEPT_PART_NO"].ToString();
                cmd.Parameters.Add("p_UNIT_PRICE", OracleDbType.Double).Value = rec["UNIT_PRICE"];
                cmd.Parameters.Add("p_UPDATE_ALLOW_AUTH", OracleDbType.Varchar2).Value = rec["UPDATE_ALLOW_AUTH"].ToString();
                cmd.Parameters.Add("p_CHECK_CANCEL", OracleDbType.Varchar2).Value = rec["CANCEL_FLAG"].ToString();
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }

            return Ok();
        }
        #endregion

        #region SNSP005_M
        [HttpGet, Route("SNSP005_M_Query/{part_no}")]
        [Authorize]
        public IHttpActionResult SNSP005_M_Query(string part_no)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSP005_M_QUERY";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part_no;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("SNSP005_M_GetDetail/{po_no}/{item_no}")]
        [Authorize]
        public IHttpActionResult SNSP005_M_GetDetail(string po_no, string item_no)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSP005_M_GET_DETAIL";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = po_no;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = item_no;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);


            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSP005_M_CalETD")]
        [Authorize]
        public IHttpActionResult SNSP005_M_CalETD([FromBody] dynamic pIndent)
        {

            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSP005_M_CAL_ETD";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pIndent["VENDOR_CODE"];
            cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = pIndent["VENDOR_TYPE"];
            cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = pIndent["PO_CLASS"];
            cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Date, Convert.ToDateTime(pIndent["ETD_DATE"]), ParameterDirection.InputOutput);
            cmd.Parameters.Add("P_ETP_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("P_ETA_EO_BKK_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("P_ETA_EO_UPC_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("P_ETA_RO_BKK_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("P_ETA_RO_UPC_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;

            //cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            cmd = oOracledb.SqlQueryReturnValue(cmd);

            var retValue = new
            {
                ETP_DATE = cmd.Parameters["P_ETP_DATE"].Value.ToString(),
                ETA_EO_BKK_DATE = cmd.Parameters["P_ETA_EO_BKK_DATE"].Value.ToString(),
                ETA_EO_UPC_DATE = cmd.Parameters["P_ETA_EO_UPC_DATE"].Value.ToString(),
                ETA_RO_BKK_DATE = cmd.Parameters["P_ETA_RO_BKK_DATE"].Value.ToString(),
                ETA_RO_UPC_DATE = cmd.Parameters["P_ETA_RO_UPC_DATE"].Value.ToString()
            };

            return Ok(retValue);
        }

        [HttpPost, Route("SNSP005_M_CalETP")]
        [Authorize]
        public IHttpActionResult SNSP005_M_CalETP([FromBody] dynamic pIndent)
        {

            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSP005_M_CAL_ETP";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pIndent["VENDOR_CODE"];
            cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = pIndent["VENDOR_TYPE"];
            cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = pIndent["PO_CLASS"];
            cmd.Parameters.Add("P_ETP_DATE", OracleDbType.Date, Convert.ToDateTime(pIndent["ETP_DATE"]), ParameterDirection.InputOutput);
            cmd.Parameters.Add("P_ETA_EO_BKK_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("P_ETA_EO_UPC_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("P_ETA_RO_BKK_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("P_ETA_RO_UPC_DATE", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;

            //cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            cmd = oOracledb.SqlQueryReturnValue(cmd);

            var retValue = new
            {
                ETA_EO_BKK_DATE = cmd.Parameters["P_ETA_EO_BKK_DATE"].Value.ToString(),
                ETA_EO_UPC_DATE = cmd.Parameters["P_ETA_EO_UPC_DATE"].Value.ToString(),
                ETA_RO_BKK_DATE = cmd.Parameters["P_ETA_RO_BKK_DATE"].Value.ToString(),
                ETA_RO_UPC_DATE = cmd.Parameters["P_ETA_RO_UPC_DATE"].Value.ToString()
            };

            return Ok(retValue);
        }

        [HttpPost, Route("SNSP005_M_SaveIndent")]
        [Authorize]
        public IHttpActionResult SNSP005_M_SaveIndent([FromBody] dynamic[] pIndent)
        {
            foreach (var record in pIndent)
            {
                OracleCommand cmd = new OracleCommand();
                gSQL = "SP_NP_SNSP005_M_SAVE_INDENT";

                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = record["VENDOR_CODE"];
                cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = record["PO_NO"];
                cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = record["ITEM_NO"];
                cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = record["SUB_ITEM_NO"];
                cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Int16).Value = record["ACCEPT_QTY"];
                cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = record["STATUS_CODE"];
                cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Date).Value = record["ETD_DATE"];
                cmd.Parameters.Add("P_ETP_DATE", OracleDbType.Date).Value = record["ETP_DATE"];
                cmd.Parameters.Add("P_ETA_EO_BKK_DATE", OracleDbType.Date).Value = record["ETA_EO_BKK_DATE"];
                cmd.Parameters.Add("P_ETA_EO_UPC_DATE", OracleDbType.Date).Value = record["ETA_EO_UPC_DATE"];
                cmd.Parameters.Add("P_ETA_RO_BKK_DATE", OracleDbType.Date).Value = record["ETA_RO_BKK_DATE"];
                cmd.Parameters.Add("P_ETA_RO_UPC_DATE", OracleDbType.Date).Value = record["ETA_RO_UPC_DATE"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                cmd = oOracledb.SqlQueryReturnValue(cmd);
            }

            return Ok();
        }


        [HttpPost, Route("SNSP005_M_SaveETDConfirm")]
        [Authorize]
        public IHttpActionResult SNSP005_M_SaveETDConfirm([FromBody] dynamic[] pIndent)
        {
            foreach (var record in pIndent)
            {
                OracleCommand cmd = new OracleCommand();
                gSQL = "SP_NP_SNSP005_M_SAVE_CONFIRM";

                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = record["VENDOR_CODE"];
                cmd.Parameters.Add("P_PO_DATE", OracleDbType.Date).Value = record["PO_DATE"];
                cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = record["PO_NO"];
                cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = record["ITEM_NO"];
                cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = record["SUB_ITEM_NO"];
                cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = record["ORDER_PART_NO"];
                cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = record["ACCEPT_PART_NO"];
                cmd.Parameters.Add("P_ORDER_QTY", OracleDbType.Int16).Value = record["ORDER_QTY"];
                cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Int16).Value = record["ACCEPT_QTY"];
                cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Date).Value = record["ETD_DATE"];
                cmd.Parameters.Add("P_ETP_DATE", OracleDbType.Date).Value = record["ETP_DATE"];
                cmd.Parameters.Add("P_ETA_EO_BKK_DATE", OracleDbType.Date).Value = record["ETA_EO_BKK_DATE"];
                cmd.Parameters.Add("P_ETA_EO_UPC_DATE", OracleDbType.Date).Value = record["ETA_EO_UPC_DATE"];
                cmd.Parameters.Add("P_ETA_RO_BKK_DATE", OracleDbType.Date).Value = record["ETA_RO_BKK_DATE"];
                cmd.Parameters.Add("P_ETA_RO_UPC_DATE", OracleDbType.Date).Value = record["ETA_RO_UPC_DATE"];
                cmd.Parameters.Add("P_CONFIRM_FLAG", OracleDbType.Varchar2).Value = record["CONFIRM_FLAG"];
                cmd.Parameters.Add("P_CONFIRM_DATE", OracleDbType.Date).Value = record["CONFIRM_DATE"];
                cmd.Parameters.Add("P_CREATE_TYPE", OracleDbType.Varchar2).Value = record["CREATE_TYPE"];
                cmd.Parameters.Add("P_TYPE", OracleDbType.Varchar2).Value = record["TYPE"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                cmd = oOracledb.SqlQueryReturnValue(cmd);
            }

            return Ok();
        }

        [HttpPost, Route("SNSP005_M_DeleteIndent/{po_no}/{item_no}/{sub_item_no}")]
        [Authorize]
        public IHttpActionResult SNSP005_M_DeleteIndent(string po_no, string item_no, string sub_item_no)
        {
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSP005_M_DELETE_INDENT";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = po_no;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = item_no;
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = sub_item_no;

            cmd = oOracledb.SqlQueryReturnValue(cmd);

            return Ok();
        }

        [HttpPost, Route("SNSP005_M_DeleteConfirm/{po_no}/{item_no}/{sub_item_no}")]
        [Authorize]
        public IHttpActionResult SNSP005_M_DeleteConfirm(string po_no, string item_no, string sub_item_no)
        {
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSP005_M_DELETE_CONFIRM";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = po_no;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = item_no;
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = sub_item_no;

            cmd = oOracledb.SqlQueryReturnValue(cmd);

            return Ok();
        }

        #endregion

        //BF Start
        #region SNPR008_M

        //[HttpGet, Route("SNPR008_M_Get_Suggest_Order/{VENDOR_CODE}")]        
        //public IHttpActionResult SNPR008_M_Get_Suggest_Order(string VENDOR_CODE)               

        [HttpPost, Route("SNPR008_M_Get_Suggest_Order")]
        [Authorize]
        public IHttpActionResult SNPR008_M_Get_Suggest_Order([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR008_M_SK_PRE_PRINTED";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("pVENDOR_CODE_From", OracleDbType.Varchar2).Value = data["VENDOR_CODE_From"].ToString();
            cmd.Parameters.Add("pVENDOR_CODE_To", OracleDbType.Varchar2).Value = data["VENDOR_CODE_To"].ToString();

            cmd.Parameters.Add("pVENDOR_TYPE_From", OracleDbType.Varchar2).Value = data["VENDOR_TYPE_From"].ToString();
            cmd.Parameters.Add("pVENDOR_TYPE_To", OracleDbType.Varchar2).Value = data["VENDOR_TYPE_To"].ToString();

            cmd.Parameters.Add("pPART_NO_From", OracleDbType.Varchar2).Value = data["PART_NO_From"].ToString();
            cmd.Parameters.Add("pPART_NO_To", OracleDbType.Varchar2).Value = data["PART_NO_To"].ToString();

            cmd.Parameters.Add("pStaff_ID", OracleDbType.Varchar2).Value = data["Staff_ID"].ToString();

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        #endregion

        #region SNPR008_FBO
        [HttpPost, Route("SNPR008_FBO_Get_Suggest_Order")]
        [Authorize]
        public IHttpActionResult SNPR008_FBO_Get_Suggest_Order([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR008_FBO_PRINTED";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("pVENDOR_CODE_From", OracleDbType.Varchar2).Value = data["VENDOR_CODE_From"].ToString();
            cmd.Parameters.Add("pVENDOR_CODE_To", OracleDbType.Varchar2).Value = data["VENDOR_CODE_To"].ToString();

            cmd.Parameters.Add("pVENDOR_TYPE_From", OracleDbType.Varchar2).Value = data["VENDOR_TYPE_From"].ToString();
            cmd.Parameters.Add("pVENDOR_TYPE_To", OracleDbType.Varchar2).Value = data["VENDOR_TYPE_To"].ToString();

            cmd.Parameters.Add("pPART_NO_From", OracleDbType.Varchar2).Value = data["PART_NO_From"].ToString();
            cmd.Parameters.Add("pPART_NO_To", OracleDbType.Varchar2).Value = data["PART_NO_To"].ToString();

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        #endregion

        #region SNSD172_F

        [HttpGet, Route("SNSD172_F_Get_Staff_Name/{STAFF_ID}")]
        [Authorize]
        public IHttpActionResult SNSD172_F_Get_Staff_Name(string STAFF_ID)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSD172_F_GET_STAFFNAME";
            //cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("pSTAFF_ID", OracleDbType.Varchar2).Value = STAFF_ID;

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNPP021PRN
        [HttpPost, Route("SNPP021PRN_SK_PRN_LOCAL")]
        [Authorize]
        public IHttpActionResult SNPP021PRN_SK_PRN_LOCAL()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP021PRN_SK_PRN_LO";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP021PRN_SK_PRN_IMPORT")]
        [Authorize]
        public IHttpActionResult SNPP021PRN_SK_PRN_IMPORT()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP021PRN_SK_PRN_IM";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion


        //BF end

        //New Add //12/10/2019

        #region SNSQ088

        [HttpPost, Route("SNSQ088_SearchOrderPartNoList")]
        [Authorize]
        public IHttpActionResult SNSQ088_SearchOrderPartNoList([FromBody] dynamic SRM)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            //gSQL = "SP_NP_SNSQ088_BTN_SEARCH";
            gSQL = "SP_NP_SNSQ088_SCH_Indent_D";

            try
            {
                //Search Order Part No ==> CREATE_DATA(VMware FN)
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = SRM.FromPoDate == null ? (object)DBNull.Value : Convert.ToDateTime(SRM.FromPoDate);
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = SRM.ToPoDate == null ? (object)DBNull.Value : Convert.ToDateTime(SRM.ToPoDate);

                cmd.Parameters.Add("P_FROM_PO_NO", OracleDbType.Varchar2).Value = SRM.FromPONo.ToString() == "" ? (object)DBNull.Value : SRM.FromPONo.ToString();
                cmd.Parameters.Add("P_TO_PO_NO", OracleDbType.Varchar2).Value = SRM.ToPONo.ToString() == "" ? (object)DBNull.Value : SRM.ToPONo.ToString();


                cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = SRM.PoClass.ToString() == "" ? (object)DBNull.Value : SRM.PoClass.ToString();

                cmd.Parameters.Add("P_FROM_VENDOR_CODE", OracleDbType.Varchar2).Value = SRM.FromVendorCode.ToString() == "" ? (object)DBNull.Value : SRM.FromVendorCode.ToString();
                cmd.Parameters.Add("P_TO_VENDOR_CODE", OracleDbType.Varchar2).Value = SRM.ToVendorCode.ToString() == "" ? (object)DBNull.Value : SRM.ToVendorCode.ToString();

                cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = SRM.VendorType.ToString() == "" ? (object)DBNull.Value : SRM.VendorType.ToString();
                cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = SRM.OrderPartNo.ToString() == "" ? (object)DBNull.Value : SRM.OrderPartNo.ToString();

                cmd.Parameters.Add("P_PRINT_STATUS", OracleDbType.Varchar2).Value = SRM.PrintStatus.ToString() == "" ? (object)DBNull.Value : SRM.PrintStatus.ToString();

                //string strUser = DataService.GetIdentity(User, Cons.SS_USER_NAME);// is not "707941" but is "2" then not match at create by user_id in Database
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                //cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = "707941";//fix it for dev.

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSQ088_SaveCheckList")]
        [Authorize]
        public IHttpActionResult SNSQ088_SaveCheckList([FromBody] dynamic[] pData)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            //Clear old checklist
            cmd.CommandText = "SP_NP_SNSQ088_CLEAR_CHECKLIST";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            oOracledb.SqlQueryReturnValue(cmd);


            foreach (var data in pData)
            {
                try
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNSQ088_SAVE_CHECKLIST";
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.ORDER_PART_NO == null ? (object)DBNull.Value : data.ORDER_PART_NO.ToString();
                    cmd.Parameters.Add("P_PART_NAME", OracleDbType.Varchar2).Value = data.ORDER_PART_NAME == null ? (object)DBNull.Value : data.ORDER_PART_NAME.ToString();
                    cmd.Parameters.Add("P_ORDER_QTY", OracleDbType.Int16).Value = data.ORDER_QTY == null ? (object)DBNull.Value : data.ORDER_QTY;
                    cmd.Parameters.Add("P_PO_PACKAGE", OracleDbType.Int16).Value = data.STICKER_PACKER == null ? (object)DBNull.Value : data.STICKER_PACKER;
                    cmd.Parameters.Add("P_LABEL_QTY", OracleDbType.Int16).Value = data.LABEL_QTY == null ? (object)DBNull.Value : data.LABEL_QTY;
                    cmd.Parameters.Add("P_LABEL_VALUE", OracleDbType.Int16).Value = data.LABEL_VALUE == null ? (object)DBNull.Value : data.LABEL_VALUE;
                    cmd.Parameters.Add("P_PO_DATE", OracleDbType.Date).Value = data.PO_DATE == null ? (object)DBNull.Value : Convert.ToDateTime(data.PO_DATE);
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = data.PO_NO == null ? (object)DBNull.Value : data.PO_NO.ToString();
                    cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Int16).Value = data.PO_CLASS == null ? (object)DBNull.Value : data.PO_CLASS;
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = data.PO_ITEM_NO == null ? (object)DBNull.Value : data.PO_ITEM_NO.ToString();
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data.VENDOR_CODE == null ? (object)DBNull.Value : data.VENDOR_CODE.ToString();
                    cmd.Parameters.Add("P_VENDOR_NAME", OracleDbType.Varchar2).Value = data.VENDOR_NAME == null ? (object)DBNull.Value : data.VENDOR_NAME.ToString();
                    cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = data.VENDOR_TYPE == null ? (object)DBNull.Value : data.VENDOR_TYPE.ToString();
                    cmd.Parameters.Add("P_ORIGIN_CODE", OracleDbType.Int16).Value = data.ORIGIN_CODE == null ? (object)DBNull.Value : data.ORIGIN_CODE;
                    cmd.Parameters.Add("P_ORIGIN_NAME", OracleDbType.Varchar2).Value = data.ORIGIN_NAME == null ? (object)DBNull.Value : data.ORIGIN_NAME.ToString();
                    cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                }
                catch (Exception ex)
                {
                    System.Console.WriteLine("Exception: {0}", ex.ToString());
                }
            }

            return Ok();
        }



        //[HttpGet, Route("SNSQ088_GetManualPrintInfo/{strPartNo}")]
        //[Authorize]
        //public IHttpActionResult SNSQ088_GetManualPrintInfo(string strPartNo)
        //{
        //    DataSet ds = new DataSet();
        //    OracleCommand cmd = new OracleCommand();
        //    gSQL = "SP_NP_SNSQ088_G_ManualPrint";

        //    try
        //    {
        //        cmd.CommandText = gSQL;
        //        cmd.CommandType = CommandType.StoredProcedure;
        //        cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

        //        cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = strPartNo == "" ? (object)DBNull.Value : strPartNo;
        //        cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 1;
        //        cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //        ds = oOracledb.SqlQueryDS_CMD(cmd);
        //    }
        //    catch (Exception ex)
        //    {
        //        System.Console.WriteLine("Exception: {0}", ex.ToString());
        //    }

        //    return Json(DTFM.convertToList(ds));
        //}

        [HttpPost, Route("SNSQ088_SavePrintManual")]
        [Authorize]
        public IHttpActionResult SNSQ088_SavePrintManual([FromBody] dynamic manualPrint)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSQ088_PRINT_MANUAL";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = manualPrint.PartNo == null ? (object)DBNull.Value : manualPrint.PartNo.ToString();
                cmd.Parameters.Add("P_PART_NAME", OracleDbType.Varchar2).Value = manualPrint.PartName == null ? (object)DBNull.Value : manualPrint.PartName.ToString();

                cmd.Parameters.Add("P_ORIGIN_NAME", OracleDbType.Varchar2).Value = manualPrint.OriginName == null ? (object)DBNull.Value : manualPrint.OriginName.ToString();
                //manualPrint.MasterStrickerPackage
                cmd.Parameters.Add("P_LABEL_QTY", OracleDbType.Varchar2).Value = manualPrint.LabelQty;
                cmd.Parameters.Add("P_LABEL_VALUE", OracleDbType.Varchar2).Value = manualPrint.LabelValue;

                string strUser = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        //BF New Add 15M01Y2020
        [HttpPost, Route("SNSQ088_SavePrintLabel")]
        [Authorize]
        public IHttpActionResult SNSQ088_SavePrintLabel([FromBody] dynamic manualPrint)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSQ088_PRN_LABEL";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ088_GetManualPart/{partno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSQ088_GetManualPart(string partno, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partno = ismoUtil.escapeCharacter(partno);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ088_G_MANUALPRINT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partno != null && partno == "null" ? "" : partno;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        //End BF New Add 15M01Y2020


        #endregion
        #region SNSQ005

        [HttpGet, Route("SNSQ005_GetPart/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPart(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetPartMaster/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartMaster(string partNo)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_MASTER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetPartInfo/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_G1_INFO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetPartInfo_G2/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo_G2(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_G2_INFO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetPartInfo_G3/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo_G3(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_G3_BO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }



        [HttpGet, Route("SNSQ005_GetPartInfo_G4/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo_G4(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_G4_ALLOCATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetPartInfo_G5/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo_G5(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_G5_ETP";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetPartInfo_G6/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo_G6(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_G6_CP";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("SNSQ005_GetPartInfo_SUS/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo_SUS(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_SUS";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetPartInfo_TF/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo_TF(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_TF";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetIndentInfo/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetIndentInfo(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_INDENT_INFO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("SNSQ005_GetVendorETD/{PoNo}/{itemNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetVendorETD(string PoNo, int itemNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_VENDOR_ETD";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = PoNo;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = itemNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSQ005_GetPartInfo_KIT/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetPartInfo_KIT(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_PART_KIT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETRUN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        // [HttpGet, Route("SNSQ005_GetOrderInfo/{partNo}")]
        // [Authorize]
        // public IHttpActionResult SNSQ005_GetOrderInfo(string partNo)
        // {
        //     DataSet ds = new DataSet();

        //     OracleCommand cmd = new OracleCommand();
        //     cmd.CommandText = "SP_NP_SNSQ005_GET_ORDER_INFO";
        //     cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //     cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
        //     cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //     cmd.Parameters.Add("C_RETRUN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //     cmd.Parameters.Add("C_RETRUN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //     cmd.Parameters.Add("C_RETRUN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //     ds = oOracledb.SqlQueryDS_CMD(cmd);
        //     return Json(DTFM.convertToList(ds));
        // }

        [HttpGet, Route("SNSQ005_GetGroupPartInfo/{partNo}")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetGroupPartInfo(string partNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_G_PART_INFO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN5", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNSQ005_GetSubOrderBO")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetSubOrderBO([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_SUB_ORDER_BO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = param.CUSTOMER_CODE;
            cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = param.ORDER_NO;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = param.ITEM_NO;
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = param.SUB_ITEM_NO;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSQ005_GetSubOrderAllocate")]
        [Authorize]
        public IHttpActionResult SNSQ005_GetSubOrderAllocate([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ005_GET_SUB_ORDER_ALLOCATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = param.CUSTOMER_CODE;
            cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = param.ORDER_NO;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = param.ITEM_NO;
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = param.SUB_ITEM_NO;
            cmd.Parameters.Add("C_RETRUN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        // [HttpGet, Route("SNSQ005_GetConsoleStockInfo/{partNo}")]
        // [Authorize]
        // public IHttpActionResult SNSQ005_GetConsoleStockInfo(string partNo)
        // {
        //     DataSet ds = new DataSet();

        //     OracleCommand cmd = new OracleCommand();
        //     cmd.CommandText = "SP_NP_SNSQ005_GET_CONSOLE_STOCK_INFO";
        //     cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //     cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
        //     cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //     cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //     cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //     cmd.Parameters.Add("C_RETURN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //     ds = oOracledb.SqlQueryDS_CMD(cmd);
        //     return Json(DTFM.convertToList(ds));
        // }



        #endregion
        //end New add //12/10/2019

        //BF New Add 20M12Y2019
        #region SNPP021PRN_FBO

        [HttpPost, Route("SNPP021PRN_FBO_SK_PRN_LOCAL")]
        [Authorize]
        public IHttpActionResult SNPP021PRN_FBO_SK_PRN_LOCAL()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP021PRN_FBO_SK_PRN_LO";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPP021PRN_FBO_SK_PRN_IMPORT")]
        [Authorize]
        public IHttpActionResult SNPP021PRN_FBO_SK_PRN_IMPORT()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP021PRN_FBO_SK_PRN_IM";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion
        #region SNSD172_F

        [HttpPost, Route("SNSD172_GetDataSetToExcel")]
        [Authorize]
        public IHttpActionResult SNSD172_GetDataSetToExcel([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSD172_F_TO_EXCEL2";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_MONTH", OracleDbType.Int16).Value = data.MONTH == null ? (object)DBNull.Value : data.MONTH;
                cmd.Parameters.Add("P_YEAR", OracleDbType.Int16).Value = data.YEAR == null ? (object)DBNull.Value : data.YEAR;

                cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = data.STAFF_ID == null ? (object)DBNull.Value : data.STAFF_ID.ToString();
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data.VENDOR_CODE_From == null ? (object)DBNull.Value : data.VENDOR_CODE_From.ToString();

                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                //string strIp = System.Net.Dns.GetHostEntry(System.Net.Dns.GetHostName()).AddressList.GetValue(0).ToString();

                string strHostName = System.Net.Dns.GetHostName();
                IPHostEntry ipEntry = System.Net.Dns.GetHostEntry(strHostName);
                IPAddress[] addr = ipEntry.AddressList;
                string strIp = addr[1].ToString();

                //cmd.Parameters.Add("P_IP_ADDRESS", OracleDbType.Varchar2).Value = strIp;//work on localhost too.
                //cmd.Parameters.Add("P_IP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNSD172_GetDataSetToExcel_ForSup")]
        [Authorize]
        public IHttpActionResult SNSD172_GetDataSetToExcel_ForSup([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSD172_F_TO_EXCEL";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_MONTH", OracleDbType.Int16).Value = data.MONTH == null ? (object)DBNull.Value : data.MONTH;
                cmd.Parameters.Add("P_YEAR", OracleDbType.Int16).Value = data.YEAR == null ? (object)DBNull.Value : data.YEAR;

                cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = data.STAFF_ID == null ? (object)DBNull.Value : data.STAFF_ID.ToString();
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data.VENDOR_CODE_From == null ? (object)DBNull.Value : data.VENDOR_CODE_From.ToString();

                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }
        #endregion
        //end New Add 20M12Y2019

        //Add 2M2Y2020
        [HttpPost, Route("SNSD172_F_GetMonthYearOfDateControl")]
        [Authorize]
        public IHttpActionResult SNSD172_F_GetMonthYearOfDateControl()
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_CURRENT_MONTH_YEAR";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        //end New Add 2M2Y2020

        //BF end






        #region SNSP022_M

        [HttpGet, Route("SNPE022_M_GetInvoice/{pInvoiceNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE022_M_GetInvoice(string pInvoiceNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            pInvoiceNo = ismoUtil.escapeCharacter(pInvoiceNo);

            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNPE022_M_GETINVOICE";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pInvoiceNo != null && pInvoiceNo == "null" ? "" : pInvoiceNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPE022_M_Query/{pInvNo}/{pVendorCode}")]
        [Authorize]
        public IHttpActionResult SNPE022_M_Query(string pInvNo, string pVendorCode)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                gSQL = "SP_NP_SNPE022_M_Query";

                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pInvNo;
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;
                cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE022_M_SaveInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpGet, Route("SNPE022_M_QueryNullInv/{pVendorCode}/{pPONo}")]
        [Authorize]
        public IHttpActionResult SNPE022_M_QueryNullInv(string pVendorCode, string pPONo)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                gSQL = "SP_NP_SNPE022_M_Query";

                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = DBNull.Value;
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;
                cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pPONo;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE022_M_SaveInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNPE022_M_SaveInvoice")]
        [Authorize]
        public IHttpActionResult SNPE022_M_SaveInvoice([FromBody] dynamic[] pIndentRows)
        {
            try
            {
                OracleCommand cmd;
                int count = 0;
                string invoiceNo = null;
                string invoiceDate = null;
                string shippedDate = null;
                string vendorCode = null;


                foreach (var pIndentRow in pIndentRows)
                {
                    invoiceNo = pIndentRow["INVOICE_NO"];
                    invoiceDate = pIndentRow["INVOICE_DATE"];
                    vendorCode = pIndentRow["VENDOR_CODE"];
                    count++;

                    if (count == 1)
                    {
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNPE022_M_DELETE_TEMP";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, "ssComCode");
                        cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceNo;
                        cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(invoiceDate);
                        cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorCode;

                        oOracledb.SqlQueryReturnValue(cmd);
                    }

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE022_M_SAVE_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, "ssComCode");
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceNo;
                    cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(invoiceDate);
                    cmd.Parameters.Add("P_SHIPPED_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pIndentRow["SHIPPED_DATE"]);
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pIndentRow["PO_NO"];
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorCode;
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = pIndentRow["ITEM_NO"];
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = pIndentRow["SUB_ITEM_NO"];
                    cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = pIndentRow["ACCEPT_PART_NO"];
                    cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Varchar2).Value = pIndentRow["ACCEPT_QTY"];
                    cmd.Parameters.Add("P_ETP_DATE", OracleDbType.Date).Value = pIndentRow["_ETP_DATE"] == null ? (object)DBNull.Value : Convert.ToDateTime(pIndentRow["_ETP_DATE"]);
                    cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = pIndentRow["STATUS_CODE"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, "ssUserName");

                    oOracledb.SqlQueryReturnValue(cmd);

                }

                if (invoiceNo != null && invoiceDate != null)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE022_M_SAVE_INV";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, "ssComCode");
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceNo;
                    cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(invoiceDate);
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorCode;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, "ssUserName");

                    oOracledb.SqlQueryReturnValue(cmd);
                }

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE022_M_SaveInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }
        #endregion
        #region SNM031P
        [HttpGet, Route("SNM031P_GetVendorInfo/{pVendorCode?}")]
        [Authorize]
        public IHttpActionResult SNM031P_GetVendorInfo(string pVendorCode = "")
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNM031P_GET_VENDOR_INFO";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;


                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM031P_GetVendorInfo");
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM031P_GetFulfillmentList")]
        [Authorize]
        public IHttpActionResult SNM031P_GetFulfillmentList()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNM031P_GET_FULFILLMENT";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RESULT_1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RESULT_2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RESULT_3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM031P_GetFulfillmentList");
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM031P_GetOrderFactor/{pVendorCode?}")]
        [Authorize]
        public IHttpActionResult SNM031P_GetOrderFactor(string pVendorCode = "")
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNM031P_GET_FACTOR_LIST";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;

                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM031P_GetOrderFactor");
            }

            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNM031P_SaveChange")]
        [Authorize]
        public IHttpActionResult SNM031P_SaveChange([FromBody] dynamic[] paramList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string screenId = "SNM031P";
            foreach (var param in paramList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM031P_SAVE_CHANGE";
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = param["VENDOR_CODE"].ToString();
                cmd.Parameters.Add("PI_PART_CATEGORY", OracleDbType.Varchar2).Value = param["PART_CATEGORY"].ToString();
                cmd.Parameters.Add("PI_FLUCTUATE_CODE", OracleDbType.Varchar2).Value = param["FLUCTUATION_CODE"].ToString();
                cmd.Parameters.Add("PI_FULFILL_RATE", OracleDbType.Varchar2).Value = param["FULFILL_RATE"].ToString();
                cmd.Parameters.Add("PI_STD_SAFE_STOCK", OracleDbType.Varchar2).Value = param["STD_SAFETY_STOCK"].ToString();
                cmd.Parameters.Add("PI_ORDER_FREQUENCY", OracleDbType.Varchar2).Value = param["ORDER_FREQUENCY"].ToString();
                cmd.Parameters.Add("PI_ALLOWANCE_RATE", OracleDbType.Varchar2).Value = param["ALLOWANCE_RATE"].ToString();

                cmd.Parameters.Add("PI_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("PI_SCREEN_ID", OracleDbType.Varchar2).Value = screenId;
                cmd.Parameters.Add("PI_IP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                {
                    string errString = dt.Rows[0]["MESSAGE"].ToString();
                    oOracledb.WriteLog("ErrorHandle", errString, "SNM031P_GetOrderFactor");
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }

            }

            return Ok("Done");
        }
        [HttpPost, Route("SNM031P_SaveAdd")]
        [Authorize]
        public IHttpActionResult SNM031P_SaveAdd([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                OracleCommand cmd = new OracleCommand();
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM031P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_CATEGORY", OracleDbType.Varchar2).Value = pParam["CATEGORY"];
                cmd.Parameters.Add("P_FLUCTUATE_CODE", OracleDbType.Varchar2).Value = pParam["FLUCTUATE_CODE"];
                cmd.Parameters.Add("P_FULFILL_RATE", OracleDbType.Varchar2).Value = pParam["FULFILL_RATE"];
                cmd.Parameters.Add("P_STD_DEVIATION", OracleDbType.Varchar2).Value = pParam["STD_DEVIATION"];
                cmd.Parameters.Add("P_ALLOWANCE_RATE", OracleDbType.Varchar2).Value = pParam["ALLOWANCE_RATE"];
                cmd.Parameters.Add("P_SAFETY_STOCK", OracleDbType.Varchar2).Value = pParam["SAFETY_STOCK"];
                cmd.Parameters.Add("P_ORDER_FREQUENCY", OracleDbType.Varchar2).Value = pParam["ORDER_FREQUENCY"];
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("P_IP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                return Json(new { result = r_status, message = "Done" });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM147_Insert");
                return Json(new { result = "Fail", message = ex.Message });
            }
        }
        #endregion

        #region SNPQ002
        [HttpGet, Route("SNPQ002_QUERY/{pVendorCode}/{pPONo}/{pPODate}")]
        [Authorize]
        public IHttpActionResult SNPQ002_QUERY(
          string pVendorCode,
          string pPONo,
          string pPODate)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNPQ002_QUERY";
            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode == "null" ? (object)DBNull.Value : pVendorCode;
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pPONo == "null" ? (object)DBNull.Value : pPONo;
            cmd.Parameters.Add("P_PO_DATE", OracleDbType.Date).Value = pPODate == "null" ? (object)DBNull.Value : Convert.ToDateTime(pPODate);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNPP021EX_M

        [HttpPost, Route("SNPP021EX_M_BeginProcess")]
        [Authorize]
        public IHttpActionResult SNPP021EX_M_BeginProcess()
        {
            DataSet ds = new DataSet();
            string returnMessage;
            string status;

            OracleCommand cmd = new OracleCommand();

            cmd.CommandText = "SP_NP_SNPP021EX_MAIN_PROCESS";
            cmd.Parameters.Add("VPARAM_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("VPARAM_PGM", OracleDbType.Varchar2).Value = "SNPP021EX_M";
            cmd.Parameters.Add("VPARAM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_PO_RANGE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            DataTable dtProcessStatus = ds.Tables[0];

            returnMessage = dtProcessStatus.Rows[0]["MESSAGE"].ToString();
            status = dtProcessStatus.Rows[0]["STATUS"].ToString();

            if (status == "Fail")
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, returnMessage));
            }
            else if (status == "Done")
            {
                DataTable dtPORange = ds.Tables[1];

                return Ok(new { START_PO = dtPORange.Rows[0]["START_PO"], END_PO = dtPORange.Rows[0]["END_PO"] });
            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, "Something wrong in process."));
        }
        [HttpGet, Route("SNPP021EX_M_GetVendor")]
        [Authorize]
        public IHttpActionResult SNPP021EX_M_GetVendor()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP021EX_M_VENDOR";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        #endregion


        #region SNSD141_99_1

        [HttpPost, Route("SNSD141_99_1_FindStaff/{P_STAFF_INCHARGE}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSD141_99_1_FindStaff(string P_STAFF_INCHARGE, int numberrecord, [FromBody] dynamic pVendor)
        {
            DataSet ds = new DataSet();

            P_STAFF_INCHARGE = ismoUtil.escapeCharacter(P_STAFF_INCHARGE);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSD141_99_1_USER_FIND";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_STAFF", OracleDbType.Varchar2).Value = (P_STAFF_INCHARGE.ToUpper() == "NULL") ? (object)DBNull.Value : P_STAFF_INCHARGE.ToString();
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendor["VENDOR_CODE"];
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }


        [HttpGet, Route("SNSD141_99_1_FindVendor/{P_VENDOR}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSD141_99_1_FindVendor(string P_VENDOR, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_VENDOR = ismoUtil.escapeCharacter(P_VENDOR);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSD141_99_1_VENDOR_FIND";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = P_VENDOR.ToUpper() == "NULL" ? (object)DBNull.Value : P_VENDOR;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNSD141_99_1_FindVendor/{P_VENDOR}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSD141_99_1_FindVendor(string P_VENDOR, int numberrecord, [FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            P_VENDOR = ismoUtil.escapeCharacter(P_VENDOR);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSD141_99_1_VENDOR_SKID";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = P_VENDOR.ToUpper() == "NULL" ? (object)DBNull.Value : P_VENDOR;
            cmd.Parameters.Add("p_SK_USER_ID", OracleDbType.Varchar2).Value = data["SK_USER_ID"];
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));



        }

        [HttpPost, Route("SNSD141_99_1_GetDataBO")]
        [Authorize]
        public HttpResponseMessage SNSD141_99_1_GetDataBO([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            string xxx = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSD141_99_1_BO_QTY";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_AGED_BO", OracleDbType.Varchar2).Value = data["AGED_BO"].ToString();
            cmd.Parameters.Add("P_ETD_DATE_FROM", OracleDbType.Varchar2).Value = data["ETD_DATE_FROM"].ToString();
            cmd.Parameters.Add("P_ETD_DATE_TO", OracleDbType.Varchar2).Value = data["ETD_DATE_TO"].ToString();
            cmd.Parameters.Add("P_STAFF_INCHARGE", OracleDbType.Varchar2).Value = data["StaffCode"].ToString();
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data["VendorCode"].ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            string dateFrom = data["ETD_DATE_FROM"].ToString();
            string dateTo = data["ETD_DATE_TO"].ToString();
            string vendorCode = data["VendorCode"].ToString();
            string date = DateTime.Now.ToString("d/MM/yyyy");
            string staffName = data["ENAME"] != "" && data["ENAME"] != null ? data["ENAME"].ToString() : "";

            string x = SNSD141_99_1_ExportBO(ds.Tables[0], "SNSD141_99_1.csv", "SNSD141_99_1", dateFrom, dateTo, vendorCode, date, staffName);
            SystemApiController sys = new SystemApiController();
            var respons = sys.downloadFile(x.Substring(1), "SNSD141_99_1.csv");
            return respons;

        }

        public static string SNSD141_99_1_ExportBO(DataTable dt, string fileName, string FloderLocation, string dateFrom, string dateTo, string vendorCode, string date, string staffName)
        {
            string vendor_code = "AABBBBBBBCCCCCCCCCCCCCCCCC";
            bool Succes = false;
            bool firstInsert = false;
            var summary = 0;
            //DataTable dt = new DataTable();
            //dt = ds.Tables[0];
            string gLocation = "~/tempFile/" + FloderLocation + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, fileName);
            string gReturnLocation = Path.Combine(gLocation, fileName);
            SystemApiController sys = new SystemApiController();
            try
            {
                StringBuilder sb = new StringBuilder();

                string firstRow = "Follow Up Report (NEW) By Part No.";
                sb.AppendLine(firstRow);
                string Row2 = "Report No.:SNSD141_99_1";
                sb.AppendLine(Row2);
                string Row3 = "As at : " + dateFrom + " TO: " + dateTo;
                sb.AppendLine(Row3);
                string Row4 = "Run Date : " + date;
                sb.AppendLine(Row4);



                string[] HeaderForExport = new string[]
                      {  "Indent No",
                        "Item",
                        "Flag",
                        "Part No.",
                        "Part Name",
                        "AVD",
                        "On Hand",
                        "BO Qty",
                        "Cost",
                        "Model",
                        "Order Date",
                        "Etd Date",
                        "Etd Flag",
                        "Ord Q'ty",
                        "Rev. Q'ty",
                        "Bal Q'ty",
                        "L/T",
                        "BO Day",
                        "Purchase Amt",
                          };

                IEnumerable<string> columnNames = HeaderForExport.Select(h => h.ToString());
                sb.AppendLine(string.Join(",", columnNames));

                foreach (DataRow row in dt.Rows)
                {

                    if (row[19].ToString() != vendor_code)
                    {
                        vendor_code = row[19].ToString();
                        if (firstInsert)
                        {
                            firstInsert = false;
                            string RowSumary = "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + "TOTAL AMOUNT BY VENDOR :" + row[19].ToString() + "," + summary;
                            sb.AppendLine(RowSumary);
                            summary = 0;
                        }

                        string Row = "Vendor Code : " + row[19].ToString() + "," + "," + CsvEscape(row[20].ToString()) + "," + "Staff Incharge : " + row[21].ToString() + "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + "," + ",";
                        sb.AppendLine(Row);
                        for (int i = 0; i < dt.Columns.Count - 3; i++)
                        {

                            sb.Append(CsvEscape(row[i].ToString()));
                            sb.Append(i == dt.Columns.Count - 4 ? "\n" : ",");
                        }
                        summary += Int32.Parse(row[17].ToString());
                    }
                    else
                    {
                        firstInsert = true;
                        for (int i = 0; i < dt.Columns.Count - 3; i++)
                        {

                            sb.Append(CsvEscape(row[i].ToString()));
                            sb.Append(i == dt.Columns.Count - 4 ? "\n" : ",");
                        }

                        summary += Int32.Parse(row[17].ToString());
                    }

                }

                File.WriteAllText(gFileLocation, sb.ToString());

                Succes = true;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }

            if (Succes)
            {
                return gReturnLocation;
            }
            else
            {

                return "";
            }

        }
        static string CsvEscape(string value)
        {
            if (value.Contains(","))
            {
                return "\"" + value.Replace("\"", "\"\"") + "\"";
            }
            return value;
        }


        #endregion

        #region SNPR019
        [HttpGet, Route("SNPR019_FindFVendor/{P_VENDOR}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNPR019_FindFVendor(string P_VENDOR, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_VENDOR = ismoUtil.escapeCharacter(P_VENDOR);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR019_VENDOR_FIND";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = P_VENDOR.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPR019_FindFInvoice/{P_INVOICE}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNPR019_FindFInvoice(string P_INVOICE, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_INVOICE = ismoUtil.escapeCharacter(P_INVOICE);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR019_INVOICE_FIND";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = P_INVOICE.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPR019_TransData")]
        [Authorize]
        public IHttpActionResult SNPR019_TransData([FromBody] dynamic pConditions)
        {
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR019_DATA_TO_WORK092";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE_FROM", OracleDbType.Varchar2).Value = pConditions["VENDOR_CODE_FROM"];
            cmd.Parameters.Add("P_VENDOR_CODE_TO", OracleDbType.Varchar2).Value = pConditions["VENDOR_CODE_TO"];
            cmd.Parameters.Add("P_INVOICE_NO_FROM", OracleDbType.Varchar2).Value = pConditions["INVOICE_NO_FROM"];
            cmd.Parameters.Add("P_INVOICE_NO_TO", OracleDbType.Varchar2).Value = pConditions["INVOICE_NO_TO"];
            cmd.Parameters.Add("P_SHIPPED_DATE_FROM", OracleDbType.Date).Value = pConditions["SHIPPED_DATE_FROM"];
            cmd.Parameters.Add("P_SHIPPED_DATE_TO", OracleDbType.Date).Value = pConditions["SHIPPED_DATE_TO"];
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

            oOracledb.SqlQueryReturnValue(cmd);

            return Ok();
        }

        [HttpGet, Route("SNPR019_GenerateReport/{reportName}")]
        [Authorize]
        public async Task<IHttpActionResult> SNPR019_GenerateReport(string reportName)
        {
            //Get querystring
            var queryStrings = Request.GetQueryNameValuePairs();

            var reportParams = new List<ParameterValue>();

            //Set report type EXCELOPENXML or PDF
            var fileType = "PDF";

            //Set output location & filename
            var outputLocation = String.Concat(ConfigurationManager.AppSettings["DefaultReportOutputPath"], "/SNPR019/", DateTime.Now.ToString("yyyyMMddHHmm"), "/");
            var fileName = String.Concat(reportName, ".", fileType);

            //Create report parameters
            foreach (var qs in queryStrings)
            {
                reportParams.Add(new ParameterValue
                {
                    Name = qs.Key,
                    Value = qs.Value,
                    Label = qs.Key
                });
            }

            try
            {
                //Generate report
                await ReportServices.GenerateReport(reportName, fileType, reportParams, fileName, outputLocation);
            }
            catch (Exception ex)
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }


            return Ok(outputLocation.Trim('~'));
        }

        [HttpPost, Route("SNPR019_Download")]
        public HttpResponseMessage SNPR019_Download(List<FileDownloadViewModel> model)
        {

            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.DownloadMultipleFilesAsZip(model);
            return File;
        }

        #endregion

        #region SNSQ027
        [HttpGet, Route("SNSQ027_GetVendor/{P_VENDOR}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSQ027_GetVendor(string P_VENDOR, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_VENDOR = ismoUtil.escapeCharacter(P_VENDOR);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ027_GET_VENDOR_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = P_VENDOR.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("SNSQ027_GetPartNo/{P_Part_No}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSQ027_GetPartNo(string P_Part_No, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_Part_No = ismoUtil.escapeCharacter(P_Part_No);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ027_GET_ORDER_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = P_Part_No.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }
        [HttpGet, Route("SNSQ027_FilterPartName/{P_Part_No}")]
        [Authorize]
        public IHttpActionResult SNSQ027_FilterPartName(string P_Part_No)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ027_GET_ORDER_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = P_Part_No.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("SNSQ027_GetCustomer/{P_Customer}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSQ027_GetCustomer(string P_Customer, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_Customer = ismoUtil.escapeCharacter(P_Customer);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ027_GET_CUSTOMER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_CUSTOMER_CODE", OracleDbType.Varchar2).Value = P_Customer.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }
        [HttpGet, Route("SNSQ027_FilterCusName/{P_Customer}")]
        [Authorize]
        public IHttpActionResult SNSQ027_FilterCusName(string P_Customer)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ027_GET_CUSTOMER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_CUSTOMER_CODE", OracleDbType.Varchar2).Value = P_Customer.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("SNSQ027_GetOrder/{P_Order}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSQ027_GetOrder(string P_Order, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_Order = ismoUtil.escapeCharacter(P_Order);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ027_GET_ORDER_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_ORDER_NO", OracleDbType.Varchar2).Value = P_Order.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("SNSQ027_GetStaffUser/{P_Staff_User}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSQ027_GetStaffUser(string P_Staff_User, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_Staff_User = ismoUtil.escapeCharacter(P_Staff_User);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ027_GET_STAFF_USER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_STAFF_USER_ID", OracleDbType.Varchar2).Value = (P_Staff_User.ToUpper() == "NULL") ? (object)DBNull.Value : P_Staff_User.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("SNSQ027_GetOrderClass")]
        [Authorize]
        public IHttpActionResult SNSQ027_GetOrderClass()
        {
            DataSet ds = new DataSet();

            gSQL = "SP_NP_SNSQ027_GET_ORDER_CLASS";
            ds = oOracledb.SqlQueryDS(gSQL);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSQ027_GetDataList")]
        [Authorize]
        public IHttpActionResult SNSQ027_GetDataList([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSQ027_SCH_BACK_ORDER";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data.VendorCode.ToString();
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PartNo.ToString();
                cmd.Parameters.Add("P_AGED_BO", OracleDbType.Varchar2).Value = data.AGED_BO.ToString();
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CustomerCode.ToString();
                cmd.Parameters.Add("P_OVERSEA_FLAG_C", OracleDbType.Varchar2).Value = data.OVERSEA_FLAG_C.ToString();
                cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.OrderNo.ToString();
                cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data.ORDER_CLASS.ToString();
                cmd.Parameters.Add("P_STAFF_INCHANGE", OracleDbType.Varchar2).Value = data.StaffUser.ToString();
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }


        //[HttpPost, Route("SNSQ027_GetPartNo")]
        //[Authorize]
        //public HttpResponseMessage SNSQ027_GetPartNo([FromBody] dynamic data)
        //{
        //    DataSet ds = new DataSet();

        //    string xxx = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

        //    OracleCommand cmd = new OracleCommand();
        //    cmd.CommandText = "SP_NP_SNSQ027_SCH_BACK_ORDER";
        //    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data.VendorCode.ToString();
        //    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PartNo.ToString();
        //    cmd.Parameters.Add("P_AGED_BO", OracleDbType.Varchar2).Value = data.AGED_BO.ToString();
        //    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CustomerCode.ToString();
        //    cmd.Parameters.Add("P_OVERSEA_FLAG_C", OracleDbType.Varchar2).Value = data.OVERSEA_FLAG_C.ToString();
        //    cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.OrderNo.ToString();
        //    cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data.ORDER_CLASS.ToString();
        //    cmd.Parameters.Add("P_STAFF_INCHANGE", OracleDbType.Varchar2).Value = data.StaffUser.ToString();
        //    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //    ds = oOracledb.SqlQueryDS_CMD(cmd);

        //    string x = SNSQ027_ExportPartNo(ds.Tables[0], "SNSQ027_OnScreen.csv", "SNSQ027_OnScreen");
        //    SystemApiController sys = new SystemApiController();
        //    var respons = sys.downloadFile(x.Substring(1), "SNSQ027_OnScreen.csv");
        //    return respons;

        //}
        //public static string SNSQ027_ExportPartNo(DataTable dt, string fileName, string FloderLocation)
        //{

        //    bool Succes = false;
        //    //DataTable dt = new DataTable();
        //    //dt = ds.Tables[0];
        //    string gLocation = "~/tempFile/" + FloderLocation + "/";
        //    string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

        //    FileInfo filePath = new FileInfo(gWriteLocation);
        //    filePath.Directory.Create();
        //    string gFileLocation = Path.Combine(gWriteLocation, fileName);
        //    string gReturnLocation = Path.Combine(gLocation, fileName);
        //    SystemApiController sys = new SystemApiController();
        //    try
        //    {
        //        StringBuilder sb = new StringBuilder();

        //        IEnumerable<string> columnNames = dt.Columns.Cast<DataColumn>().Select(column => column.ColumnName);
        //        sb.AppendLine(string.Join(",", columnNames));

        //        foreach (DataRow row in dt.Rows)
        //        {
        //            for (int i = 0; i < dt.Columns.Count; i++)
        //            {

        //                sb.Append(CsvEscape(row[i].ToString()));
        //                sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
        //            }
        //        }

        //        File.WriteAllText(gFileLocation, sb.ToString());

        //        Succes = true;
        //    }
        //    catch (Exception ex)
        //    {
        //        Console.WriteLine(ex);
        //    }

        //    if (Succes)
        //    {
        //        return gReturnLocation;
        //    }
        //    else
        //    {

        //        return "";
        //    }

        //}


        [HttpPost, Route("SNSQ027_GetBo_By_PartNo")]
        [Authorize]
        public IHttpActionResult SNSQ027_GetBo_By_PartNo([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSQ027_GET_BO";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.ORDER_PART_NO.ToString();
                cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data.ORDER_CLASS.ToString();
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }


        //[HttpPost, Route("SNSQ027_GetBO_By_PartNo_Export")]
        //[Authorize]
        //public HttpResponseMessage SNSQ027_GetBO_By_PartNo_Export([FromBody] dynamic data)
        //{
        //    DataSet ds = new DataSet();

        //    OracleCommand cmd = new OracleCommand();
        //    cmd.CommandText = "SP_NP_SNSQ027_GET_BO";
        //    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PartNO;
        //    cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data.OrderClass;
        //    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //    ds = oOracledb.SqlQueryDS_CMD(cmd);


        //    string x = SNSQ027_ExportBoOnScreen(ds.Tables[0], "SNSQ027_ETD.csv", "SNSQ027_ETD");
        //    SystemApiController sys = new SystemApiController();
        //    var respons = sys.downloadFile(x.Substring(1), "SNSQ027_ETD.csv");
        //    return respons;

        //}

        //public static string SNSQ027_ExportBoOnScreen(DataTable dt, string fileName, string FloderLocation)
        //{

        //    bool Succes = false;
        //    //DataTable dt = new DataTable();
        //    //dt = ds.Tables[0];
        //    string gLocation = "~/tempFile/" + FloderLocation + "/";
        //    string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

        //    FileInfo filePath = new FileInfo(gWriteLocation);
        //    filePath.Directory.Create();
        //    string gFileLocation = Path.Combine(gWriteLocation, fileName);
        //    string gReturnLocation = Path.Combine(gLocation, fileName);
        //    SystemApiController sys = new SystemApiController();
        //    try
        //    {
        //        StringBuilder sb = new StringBuilder();

        //        IEnumerable<string> columnNames = dt.Columns.Cast<DataColumn>().Select(column => column.ColumnName);
        //        sb.AppendLine(string.Join(",", columnNames));

        //        foreach (DataRow row in dt.Rows)
        //        {
        //            for (int i = 0; i < dt.Columns.Count; i++)
        //            {

        //                sb.Append(CsvEscape(row[i].ToString()));
        //                sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
        //            }
        //        }

        //        File.WriteAllText(gFileLocation, sb.ToString());

        //        Succes = true;
        //    }
        //    catch (Exception ex)
        //    {
        //        Console.WriteLine(ex);
        //    }

        //    if (Succes)
        //    {
        //        return gReturnLocation;
        //    }
        //    else
        //    {

        //        return "";
        //    }

        //}


        //[HttpGet, Route("GetBO_By_PartNo/{PartNO}/{OrderClass}")]
        //[Authorize]
        //public string GetBO_By_PartNo(string PartNO , string OrderClass)
        //{
        //    DataSet ds = new DataSet();
        //    string xxx = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);


        //    OracleCommand cmd = new OracleCommand();
        //cmd.CommandText = "SP_NP_SNSQ027_GET_BO";
        //    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PartNO;
        //    cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = OrderClass;
        //    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //    ds = oOracledb.SqlQueryDS_CMD(cmd);

        //    var x = SNSQ027_ExportBoOnScreen(ds.Tables[0], "SNSQ027_OnScreen.csv", "SNSQ027_OnScreen");

        //    return x;

        //}
        //public static string SNSQ027_ExportBoOnScreen(DataTable dt, string fileName, string FloderLocation)
        //    {

        //        bool Succes = false;
        //        //DataTable dt = new DataTable();
        //        //dt = ds.Tables[0];
        //        string gLocation = "~/tempFile/" + FloderLocation + "/";
        //        string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

        //        FileInfo filePath = new FileInfo(gWriteLocation);
        //        filePath.Directory.Create();
        //        string gFileLocation = Path.Combine(gWriteLocation, fileName);
        //        string gReturnLocation = Path.Combine(gLocation, fileName);

        //        try
        //        {


        //            StringBuilder sb = new StringBuilder();

        //            //string firstRow = "UYK5F3030 V1.0 Order_Modification";

        //            //sb.AppendLine(firstRow);



        //            IEnumerable<string> columnNames = dt.Columns.Cast<DataColumn>().Select(column => column.ColumnName);
        //            sb.AppendLine(string.Join(",", columnNames));

        //            foreach (DataRow row in dt.Rows)
        //            {
        //                IEnumerable<string> fields = row.ItemArray.Select(field => field.ToString());
        //                sb.AppendLine(string.Join(",", fields));
        //            }

        //            File.WriteAllText(gFileLocation, sb.ToString());

        //            Succes = true;
        //        }
        //        catch (Exception ex)
        //        {
        //            Console.WriteLine(ex);
        //        }

        //        if (Succes)
        //        {
        //            return gReturnLocation;
        //        }
        //        else
        //        {

        //            return "";
        //        }

        //    }

        #endregion



        #region SNPP027
        [HttpGet, Route("SNPP027_GeneratePO")]
        [Authorize]
        public IHttpActionResult SNPP027_GeneratePO()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            // string screenId = "SNPP027";

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP027_GENERATE_PO";
            cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("PI_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("PO_C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];

            if (dt.Rows[0]["STATUS"].ToString() == "Fail")
            {
                string errString = dt.Rows[0]["MESSAGE"].ToString();
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            }

            //return Ok("Done");
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPP027_GeneratePO_Ondemand")]
        [Authorize]
        public IHttpActionResult SNPP027_GeneratePO_Ondemand()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            // string screenId = "SNPP027";

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPP027_GENERATE_PO_OD";
            cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("PI_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("PO_C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];

            if (dt.Rows[0]["STATUS"].ToString() == "Fail")
            {
                string errString = dt.Rows[0]["MESSAGE"].ToString();
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            }

            //return Ok("Done");
            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNM040P
        [HttpGet, Route("SNM040P_GetETAData/{pVendorCode?}")]
        [Authorize]
        public IHttpActionResult SNM040P_GetETAData(string pVendorCode = "")
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNM040P_GET_ETA_DATA";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;

                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM040P_GetJobMethod/{pJobType}")]
        [Authorize]
        public IHttpActionResult SNM040P_GetJobMethod(string pJobType)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNM040P_GET_JOB_METHOD";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_JOB_TYPE", OracleDbType.Varchar2).Value = pJobType;

                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM040P_CheckETADupplication/{pJobType}/{pJobMethod}/{pVendorType}/{pVendorCode}")]
        [Authorize]
        public IHttpActionResult SNM040P_CheckETADupplication(
            string pJobType,
            string pJobMethod,
            string pVendorType,
            string pVendorCode)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNM040P_CHECK_DUP";
            string dupFlag = "";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_JOB_TYPE", OracleDbType.Varchar2).Value = pJobType;
                cmd.Parameters.Add("PI_JOB_METHOD", OracleDbType.Varchar2).Value = pJobMethod;
                cmd.Parameters.Add("PI_VENDOR_TYPE", OracleDbType.Varchar2).Value = pVendorType;
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;

                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows.Count > 0)
                    {
                        dupFlag = ds.Tables[0].Rows[0][0].ToString();
                    }
                    else
                    {
                        dupFlag = "";
                    }

                }
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(dupFlag);
        }

        [HttpGet, Route("SNM040P_GetETAInfo/{pJobType}/{pJobMethod}/{pVendorType}/{pVendorCode}")]
        [Authorize]
        public IHttpActionResult SNM040P_GetETAInfo(
            string pJobType,
            string pJobMethod,
            string pVendorType,
            string pVendorCode)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNM040P_GET_ETA_INFO";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_JOB_TYPE", OracleDbType.Varchar2).Value = pJobType;
                cmd.Parameters.Add("PI_JOB_METHOD", OracleDbType.Varchar2).Value = pJobMethod;
                cmd.Parameters.Add("PI_VENDOR_TYPE", OracleDbType.Varchar2).Value = pVendorType;
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;

                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM040P_SaveChangeAdd")]
        [Authorize]
        public IHttpActionResult SNM040P_SaveChangeAdd([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string screenId = "SNM040P";
            string resultMessage = "Done";
            if (param != null)
            {
                try
                {
                    OracleCommand cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM040P_SAVE_ADD";
                    cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("PI_JOB_TYPE", OracleDbType.Varchar2).Value = param["JobTypeCtrl"].ToString();
                    cmd.Parameters.Add("PI_JOB_METHOD", OracleDbType.Varchar2).Value = param["JobMethodCtrl"].ToString();
                    cmd.Parameters.Add("PI_VENDOR_TYPE", OracleDbType.Varchar2).Value = param["VendorTypeCtrl"].ToString();
                    cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = param["VendorCodeCtrl"].ToString();
                    cmd.Parameters.Add("PI_LEAD_TIME_ETD", OracleDbType.Varchar2).Value = param["LeadTimeETDCtrl"].ToString();
                    cmd.Parameters.Add("PI_LEAD_TIME_ETP", OracleDbType.Varchar2).Value = param["LeadTimeETPCtrl"].ToString();
                    cmd.Parameters.Add("PI_ETA_EO_BKK", OracleDbType.Varchar2).Value = param["LeadTimeETAEOBkkCtrl"].ToString();
                    cmd.Parameters.Add("PI_ETA_EO_UPC", OracleDbType.Varchar2).Value = param["LeadTimeETAEOUpcCtrl"].ToString();
                    cmd.Parameters.Add("PI_ETA_RO_BKK", OracleDbType.Varchar2).Value = param["LeadTimeETAROBkkCtrl"].ToString();
                    cmd.Parameters.Add("PI_ETA_RO_UPC", OracleDbType.Varchar2).Value = param["LeadTimeETAROUpcCtrl"].ToString();
                    cmd.Parameters.Add("PI_CALCULATE_TYPE", OracleDbType.Varchar2).Value = param["CalculateTypeCtrl"].ToString();

                    cmd.Parameters.Add("PI_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("PI_CREATE_PGM", OracleDbType.Varchar2).Value = screenId;
                    cmd.Parameters.Add("PI_IP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                    cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                    dt = ds.Tables[0];

                    if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                    {
                        resultMessage = dt.Rows[0]["MESSAGE"].ToString();
                    }
                }
                catch (Exception ex)
                {
                    string errString = ex.Message.ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }


            }

            return Ok(resultMessage);
        }

        [HttpPost, Route("SNM040P_SaveChangeEdit")]
        [Authorize]
        public IHttpActionResult SNM040P_SaveChangeEdit([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string screenId = "SNM040P";
            string resultMessage = "Done";
            if (param != null)
            {
                try
                {
                    OracleCommand cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM040P_SAVE_EDIT";
                    cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("PI_JOB_TYPE", OracleDbType.Varchar2).Value = param["JobTypeCtrl"].ToString();
                    cmd.Parameters.Add("PI_JOB_METHOD", OracleDbType.Varchar2).Value = param["JobMethodCtrl"].ToString();
                    cmd.Parameters.Add("PI_VENDOR_TYPE", OracleDbType.Varchar2).Value = param["VendorTypeCtrl"].ToString();
                    cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = param["VendorCodeCtrl"].ToString();
                    cmd.Parameters.Add("PI_LEAD_TIME_ETD", OracleDbType.Varchar2).Value = param["LeadTimeETDCtrl"].ToString();
                    cmd.Parameters.Add("PI_LEAD_TIME_ETP", OracleDbType.Varchar2).Value = param["LeadTimeETPCtrl"].ToString();
                    cmd.Parameters.Add("PI_ETA_EO_BKK", OracleDbType.Varchar2).Value = param["LeadTimeETAEOBkkCtrl"].ToString();
                    cmd.Parameters.Add("PI_ETA_EO_UPC", OracleDbType.Varchar2).Value = param["LeadTimeETAEOUpcCtrl"].ToString();
                    cmd.Parameters.Add("PI_ETA_RO_BKK", OracleDbType.Varchar2).Value = param["LeadTimeETAROBkkCtrl"].ToString();
                    cmd.Parameters.Add("PI_ETA_RO_UPC", OracleDbType.Varchar2).Value = param["LeadTimeETAROUpcCtrl"].ToString();
                    cmd.Parameters.Add("PI_CALCULATE_TYPE", OracleDbType.Varchar2).Value = param["CalculateTypeCtrl"].ToString();

                    cmd.Parameters.Add("PI_UPDATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("PI_UPDATE_PGM", OracleDbType.Varchar2).Value = screenId;
                    cmd.Parameters.Add("PI_IP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                    cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                    dt = ds.Tables[0];

                    if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                    {
                        resultMessage = dt.Rows[0]["MESSAGE"].ToString();
                    }
                }
                catch (Exception ex)
                {
                    string errString = ex.Message.ToString();
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                }


            }

            return Ok(resultMessage);
        }

        [HttpGet, Route("SNM040P_SaveChangeDelete/{pJobType}/{pJobMethod}/{pVendorType}/{pVendorCode}")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM040P_SaveChangeDelete(
            string pJobType,
            string pJobMethod,
            string pVendorType,
            string pVendorCode)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string resultMessage = "Done";

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM040P_SAVE_DELETE";
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_JOB_TYPE", OracleDbType.Varchar2).Value = pJobType;
                cmd.Parameters.Add("PI_JOB_METHOD", OracleDbType.Varchar2).Value = pJobMethod;
                cmd.Parameters.Add("PI_VENDOR_TYPE", OracleDbType.Varchar2).Value = pVendorType;
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;

                cmd.Parameters.Add("PI_UPDATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("PI_IP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                if (dt.Rows[0]["STATUS"].ToString() == "Fail")
                {
                    resultMessage = dt.Rows[0]["MESSAGE"].ToString();
                }
            }
            catch (Exception ex)
            {
                string errString = ex.Message.ToString();
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
            }




            return Ok(resultMessage);
        }
        #endregion

        #region SNM042P

        //[HttpGet, Route("SNM042P_GetTariff")]
        //public IHttpActionResult SNM042P_GetTariff()
        //{
        //    DataSet ds = new DataSet();
        //    OracleCommand cmd = new OracleCommand();
        //    cmd.CommandText = "SP_NP_SNM042P_TARIFF_MASTER";
        //    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType).Value = archar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //    cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //    ds = oOracledb.SqlQueryDS_CMD(cmd);
        //    return Json(DTFM.convertToList(ds));
        //}

        [HttpPost, Route("SNM042P_GetTariff_SEARCH")]
        [Authorize]
        public IHttpActionResult SNM042P_GetTariff_SEARCH([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNM042P_MT_TARIFF_SEARCH";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_TARIFF_CODE", OracleDbType.Varchar2).Value = data.TariffCode.ToString();
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM042P_GetTariffCode/{P_Tariff_Code}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNM042P_GetTariffCode(string P_Tariff_Code, int numberrecord)
        {
            DataSet ds = new DataSet();

            P_Tariff_Code = ismoUtil.escapeCharacter(P_Tariff_Code);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM042P_TARIFF_FIND";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_TARIFF_CODE", OracleDbType.Varchar2).Value = P_Tariff_Code.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        //[HttpGet, Route("SNM042P_GetTariffList")]
        //public IHttpActionResult SNM042P_GetTariffList()
        //{
        //    DataSet ds = new DataSet();

        //    gSQL = "SP_NP_SNM042P_TARIFF_LIST";
        //    ds = oOracledb.SqlQueryDS(gSQL);
        //    return Json(DTFM.convertToList(ds));
        //}

        [HttpPost, Route("SNM042P_SaveTariff")]
        [Authorize]
        public IHttpActionResult SNM042P_SaveTariff([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM042P_TARIFF_SAVE";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pEFFECTIVE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["EFFECTIVE_DATE"].ToString());
            cmd.Parameters.Add("pTARIFF_CODE", OracleDbType.Varchar2).Value = data["TARIFF_CODE"];
            cmd.Parameters.Add("pDUTY_RATE", OracleDbType.Varchar2).Value = data["DUTY_RATE"].ToString();
            cmd.Parameters.Add("pNAME_THAI", OracleDbType.Varchar2).Value = data["NAME_THAI"].ToString();
            cmd.Parameters.Add("pNAME_ENG", OracleDbType.Varchar2).Value = data["NAME_ENG"].ToString();
            cmd.Parameters.Add("pLAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

            //Modify by BF.
            //Modify Date: 20M2Y2020
            //Note: Issue tpm_tariff_master_log must update IP_Address
            string strHostName = System.Net.Dns.GetHostName();
            IPHostEntry ipEntry = System.Net.Dns.GetHostEntry(strHostName);
            IPAddress[] addr = ipEntry.AddressList;
            string strIp = addr[1].ToString();

            cmd.Parameters.Add("pIP_ADDRESS", OracleDbType.Varchar2).Value = strIp;//work on localhost too.
            //End modify.

            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Ok("Done");
        }

        [HttpPost, Route("SNM042P_SaveAdd_MT_TariffCode")]
        [Authorize]
        public IHttpActionResult SNM042P_SaveAdd_MT_TariffCode([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM042P_MT_TARIFF_ADD";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_EFFECTIVE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["EFFECTIVE_DATE"].ToString());
            cmd.Parameters.Add("P_TARIFF_CODE", OracleDbType.Varchar2).Value = data["TARIFF_CODE"];
            cmd.Parameters.Add("P_DUTY_RATE", OracleDbType.Varchar2).Value = data["DUTY_RATE"].ToString();
            cmd.Parameters.Add("P_NAME_THAI", OracleDbType.Varchar2).Value = data["NAME_THAI"] == null ? (object)DBNull.Value : data["NAME_THAI"];
            cmd.Parameters.Add("P_NAME_ENG", OracleDbType.Varchar2).Value = data["NAME_ENG"] == null ? (object)DBNull.Value : data["NAME_ENG"];
            cmd.Parameters.Add("P_EXPIRE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["EXPIRE_DATE"].ToString());
            cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Ok("Done");
        }

        #endregion



        [HttpGet, Route("SearchPO/{PO_NO}/{PO_DATE}/{INV_NO}/{INV_DATE}/{SHIP_DATE}")]
        [Authorize]
        public IHttpActionResult SearchPO(string PO_NO, string PO_DATE, string INV_NO, string INV_DATE, string SHIP_DATE)
        {
            DataSet ds = new DataSet();

            PO_NO = ismoUtil.escapeCharacter(PO_NO);
            INV_NO = ismoUtil.escapeCharacter(INV_NO);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PO_SEARCH";
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2, PO_NO, ParameterDirection.Input);
            cmd.Parameters.Add("P_PO_DATE", OracleDbType.Varchar2, PO_DATE, ParameterDirection.Input);
            cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2, INV_NO, ParameterDirection.Input);
            cmd.Parameters.Add("P_INV_DATE", OracleDbType.Varchar2, INV_DATE, ParameterDirection.Input);
            cmd.Parameters.Add("P_SHIP_DATE", OracleDbType.Varchar2, SHIP_DATE, ParameterDirection.Input);

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        #region SNSD148_F

        [HttpPost, Route("SNSD148_F_GetStaff/{staffID}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSD148_F_GetStaff(string staffID, int noofshowrec, [FromBody] dynamic pVendor)
        {
            DataSet ds = new DataSet();

            staffID = ismoUtil.escapeCharacter(staffID);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSD148_F_STAFF_BYID";
            cmd.Parameters.Add("p_STAFF_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_STAFF_ID", OracleDbType.Varchar2).Value = staffID.ToUpper() == "NULL" ? (object)DBNull.Value : staffID;
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendor["VendorCode"];
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSD148_F_GetVendor/{vendorCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSD148_F_GetVendor(string vendorCode, int noofshowrec, [FromBody] dynamic pStaff)
        {
            DataSet ds = new DataSet();

            vendorCode = ismoUtil.escapeCharacter(vendorCode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSD148_F_VENDOR";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorCode.ToUpper() == "NULL" ? (object)DBNull.Value : vendorCode;
            cmd.Parameters.Add("p_STAFF_ID", OracleDbType.Varchar2).Value = pStaff["StaffID"];
            cmd.Parameters.Add("P_OVERSEA_FLAG", OracleDbType.Varchar2).Value = pStaff["OverseaFlag"];
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNM011P
        [HttpGet, Route("SNM011P_GetPartCategory/{partCategory}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM011P_GetPartCategory(string partCategory, int noofshowrec)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM011P_PART_CGR";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = partCategory.ToUpper() != "NULL" ? partCategory : "";
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        [HttpGet, Route("SNM011P_GetDetail/{partCategory?}")]
        [Authorize]
        public IHttpActionResult SNM011P_GetDetail(string partCategory = null)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM011P_GET_DETAIL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = partCategory;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNM011P_INSERT")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM011P_INSERT([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM011P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pData.PART_CATEGORY;
                cmd.Parameters.Add("P_SEQ_NO", OracleDbType.Varchar2).Value = pData.SEQ_NO;
                cmd.Parameters.Add("P_STD_DEVIATION_F", OracleDbType.Varchar2).Value = pData.STD_DEVIATION_F;
                cmd.Parameters.Add("P_STD_DEVIATION_T", OracleDbType.Varchar2).Value = pData.STD_DEVIATION_T;
                cmd.Parameters.Add("P_FLUCTUATE_CODE", OracleDbType.Varchar2).Value = pData.FLUCTUATE_CODE;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM011P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_ATTRIBUTE1", OracleDbType.Varchar2).Value = pData.ATTRIBUTE1;
                cmd.Parameters.Add("P_ATTRIBUTE2", OracleDbType.Varchar2).Value = pData.ATTRIBUTE2;
                cmd.Parameters.Add("P_ATTRIBUTE3", OracleDbType.Varchar2).Value = pData.ATTRIBUTE3;
                cmd.Parameters.Add("P_ATTRIBUTE4", OracleDbType.Varchar2).Value = pData.ATTRIBUTE4;
                cmd.Parameters.Add("P_ATTRIBUTE5", OracleDbType.Varchar2).Value = pData.ATTRIBUTE5;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM011P_INSERT");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNM011P_UPDATE")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM011P_UPDATE([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM011P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pData.PART_CATEGORY;
                cmd.Parameters.Add("P_SEQ_NO", OracleDbType.Varchar2).Value = pData.SEQ_NO;
                cmd.Parameters.Add("P_STD_DEVIATION_F", OracleDbType.Varchar2).Value = pData.STD_DEVIATION_F;
                cmd.Parameters.Add("P_STD_DEVIATION_T", OracleDbType.Varchar2).Value = pData.STD_DEVIATION_T;
                cmd.Parameters.Add("P_FLUCTUATE_CODE", OracleDbType.Varchar2).Value = pData.FLUCTUATE_CODE;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM011P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM011P_UPDATE");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        #endregion

        #region SNSE201

        [HttpGet, Route("SNSE201_GetRecommend")]
        [Authorize]
        public IHttpActionResult SNSE201_GetRecommend()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE201_GET_RECOMMEND";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE201_UploadFile")]
        [Authorize]
        public async Task<IHttpActionResult> SNSE201_UploadFile(HttpRequestMessage request)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();
            try
            {
                OracleCommand cmd;
                foreach (var file in reqParts.Contents)
                {
                    var buffer = await file.ReadAsByteArrayAsync();

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNSE201_DELETE_TEMP";
                    oOracledb.SqlQueryReturnValue(cmd);
                    string line, lineTitle = "";
                    int lineCount = 0;
                    int rowCount = 0;
                    Stream stream = new MemoryStream(buffer);
                    StreamReader reader = new StreamReader(stream);
                    DataTable fillRateTable = new DataTable();
                    while ((line = reader.ReadLine()) != null)
                    {
                        lineCount++;
                        if (lineCount == 1)
                        {
                            lineTitle = line;
                        }
                        else if (lineCount == 2)
                        {
                            fillRateTable = SNSE201_SplitToHeader(line);
                        }
                        if (lineCount > 2)
                        {
                            rowCount++;
                            SNSE201_SplitToData(line, ref fillRateTable);
                            cmd = new OracleCommand();
                            cmd.CommandText = "SP_NP_SNSE201_INSERT_TEMP";
                            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                            cmd.Parameters.Add("P_DATA", OracleDbType.Varchar2).Value = line;
                            cmd.Parameters.Add("P_ROW", OracleDbType.Int16).Value = rowCount;
                            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                            oOracledb.SqlQueryReturnValue(cmd);
                        }
                    }
                    reader.Close();
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNSE201_VALIDATE_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("C_RECOMMEND_ID", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                    string recommendId = cmd.Parameters["C_RECOMMEND_ID"].Value.ToString();


                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNSE201_IGNORED_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                    DataSet dataSet = oOracledb.SqlQueryDS_CMD(cmd);
                    DataTable dataTable = dataSet.Tables[0];
                    return Ok(new { result = "Done", recommendId = recommendId, data = fillRateTable, title = lineTitle, errorList = DTFM.convertToList(dataTable) });
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE201_UploadFile");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
            return Ok(new { result = "Fail", message = "Unable to process." });
        }
        private DataTable SNSE201_SplitToHeader(string textData)
        {
            DataTable dt = new DataTable();
            string[] columns = textData.Split('\t');
            foreach (string column in columns)
            {
                dt.Columns.Add(column);
            }
            return dt;
        }
        private void SNSE201_SplitToData(string textData, ref DataTable dataTable)
        {
            int colCount = 0;
            DataRow dataRow = dataTable.NewRow();
            string[] dataList = textData.Split('\t');
            foreach (DataColumn column in dataTable.Columns)
            {
                dataRow[column] = dataList[colCount];
                colCount++;
            }
            dataTable.Rows.Add(dataRow);
        }

        [HttpPost, Route("SNSE201_DownloadRaw")]
        public HttpResponseMessage SNSE201_DownloadRaw(List<DataModel.SNPE201_RAW> dModel)
        {
            DataTable dt = new DataTable();
            string x = string.Empty;
            string filename = "SNPE201_RAW.csv";
            string floderLocation = "SNPE201";
            dt.Columns.Add("colum1");

            dt.Rows.Add("ID;PO2C");
            dt.Rows.Add("B");
            dt.Rows.Add("C;X1;Y1;K\"Recommend ID\"");
            dt.Rows.Add("C;X2;Y1;K\"Part No.\"");
            dt.Rows.Add("C;X3;Y1;K\"Recommended Q'ty\"");
            dt.Rows.Add("C;X4;Y1;K\"Self Point Modified Q'ty\"");
            dt.Rows.Add("C;X5;Y1;K\"OH Q'ty\"");
            dt.Rows.Add("C;X6;Y1;K\"OH Cost\"");
            dt.Rows.Add("C;X7;Y1;K\"BO Q'ty\"");
            dt.Rows.Add("C;X8;Y1;K\"BO Cost\"");
            dt.Rows.Add("C;X9;Y1;K\"BO Date\"");
            dt.Rows.Add("C;X10;Y1;K\"DLR's PO No.\"");
            dt.Rows.Add("C;X11;Y1;K\"DLR Code\"");
            dt.Rows.Add("C;X12;Y1;K\"DLR Name\"");
            dt.Rows.Add("C;X13;Y1;K\"BO Release Date\"");

            int countrow = 0;
            int itemno = 0;
            for (var i = 0; i < dModel.Count; i++)
            {
                countrow = i + 2;
                itemno = i + 1;
                dt.Rows.Add("C;X1;Y" + countrow + ";K" + '"' + dModel[i].RECOMMEND_ID + '"');
                dt.Rows.Add("C;X2;Y" + countrow + ";K" + '"' + dModel[i].ORDER_PART_NO + '"');
                dt.Rows.Add("C;X3;Y" + countrow + ";K" + '"' + dModel[i].RECOMMENDED_QTY + '"');
                dt.Rows.Add("C;X4;Y" + countrow + ";K" + '"' + dModel[i].SELF_POINT_MOD_QTY + '"');
                dt.Rows.Add("C;X5;Y" + countrow + ";K" + '"' + dModel[i].OH_QTY + '"');
                dt.Rows.Add("C;X6;Y" + countrow + ";K" + '"' + dModel[i].OH_COST + '"');
                dt.Rows.Add("C;X7;Y" + countrow + ";K" + '"' + dModel[i].BO_QTY + '"');
                dt.Rows.Add("C;X8;Y" + countrow + ";K" + '"' + dModel[i].BO_COST_AMT + '"');
                dt.Rows.Add("C;X9;Y" + countrow + ";K" + '"' + dModel[i].BO_DATE + '"');
                dt.Rows.Add("C;X10;Y" + countrow + ";K" + '"' + dModel[i].ORDER_NO + '"');
                dt.Rows.Add("C;X11;Y" + countrow + ";K" + '"' + dModel[i].CUSTOMER_CODE + '"');
                dt.Rows.Add("C;X12;Y" + countrow + ";K" + '"' + dModel[i].CUST_NAME_EN + '"');
                dt.Rows.Add("C;X13;Y" + countrow + ";K" + '"' + Convert.ToDateTime(dModel[i].COMPLETE_BO_DATE) + '"');
            }

            dt.Rows.Add("E");

            x = DataService.WriteCSVNoColumn(dt, filename, floderLocation);
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }

        [HttpGet, Route("SNSE201_GetRawData/{RECOMMEND_ID}/{REPORT_MONTH}")]
        [Authorize]
        public IHttpActionResult SNSE201_GetRawData(string RECOMMEND_ID, string REPORT_MONTH)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE201_GET_RAW_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_RECOMMEND_ID", OracleDbType.Varchar2).Value = RECOMMEND_ID;
            cmd.Parameters.Add("P_REPORT_MONTH", OracleDbType.Varchar2).Value = REPORT_MONTH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE201_DownloadSummary")]
        public HttpResponseMessage SNSE201_DownloadSummary(List<DataModel.SNPE201_SUM> dModel)
        {
            DataTable dt = new DataTable();
            string x = string.Empty;
            string filename = "SNPE201.csv";
            string floderLocation = "SNPE201";
            dt.Columns.Add("colum1");
            dt.Rows.Add("ID;PO2C");
            dt.Rows.Add("B");

            int countrow = 0;
            for (var i = 0; i < dModel.Count; i++)
            {
                countrow = i + 1;
                dt.Rows.Add("C;X" + countrow + ";Y1;K" + '"' + dModel[i].DIALY_HEADER + '"');
                dt.Rows.Add("C;X" + countrow + ";Y2;K" + '"' + dModel[i].PART_NO + '"');
                dt.Rows.Add("C;X" + countrow + ";Y3;K" + '"' + dModel[i].STOCKED_ITEM + '"');
                dt.Rows.Add("C;X" + countrow + ";Y4;K" + '"' + dModel[i].ORDER_RECEIVED + '"');
                dt.Rows.Add("C;X" + countrow + ";Y5;K" + '"' + dModel[i].ORDER_RECEIV_AMT + '"');
                dt.Rows.Add("C;X" + countrow + ";Y6;K" + '"' + dModel[i].SHIPPED_LINES + '"');
                dt.Rows.Add("C;X" + countrow + ";Y7;K" + '"' + dModel[i].SHIPPED_AMT + '"');
                dt.Rows.Add("C;X" + countrow + ";Y8;K" + '"' + dModel[i].BO_LINES + '"');
                dt.Rows.Add("C;X" + countrow + ";Y9;K" + '"' + dModel[i].BO_AMT + '"');
                dt.Rows.Add("C;X" + countrow + ";Y10;K" + '"' + dModel[i].INITIAL_FILL + '"');
                dt.Rows.Add("C;X" + countrow + ";Y11;K" + '"' + dModel[i].INIT_FILL_ACT + '"');
            }
            dt.Rows.Add("E");

            x = DataService.WriteCSVNoColumn(dt, filename, floderLocation);
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }

        [HttpGet, Route("SNSE201_GetSummaryData/{RECOMMEND_ID}/{REPORT_MONTH}")]
        [Authorize]
        public IHttpActionResult SNSE201_GetSummaryData(string RECOMMEND_ID, string REPORT_MONTH)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE201_GET_SUM_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_RECOMMEND_ID", OracleDbType.Varchar2).Value = RECOMMEND_ID;
            cmd.Parameters.Add("P_REPORT_MONTH", OracleDbType.Varchar2).Value = REPORT_MONTH;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE201_SaveData")]
        [Authorize]
        public IHttpActionResult SNSE201_SaveData([FromBody] dynamic data)
        {
            try
            {
                int rowCount = 0;
                OracleCommand cmd;
                var tempRecList = new List<dynamic>(data.TempRecList);
                foreach (var item in tempRecList)
                {
                    rowCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNSE201_UPD_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_RECOMMEND_ID", OracleDbType.Varchar2).Value = data["RECOMMEND_ID"].ToString();
                    cmd.Parameters.Add("P_SEQ", OracleDbType.Int16).Value = rowCount;
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = item["Part No"].ToString();
                    cmd.Parameters.Add("P_SELF_POINT_MOD_QTY", OracleDbType.Int16).Value = item["Self Point Modified Q'ty"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    oOracledb.SqlQueryReturnValue(cmd);
                }
                //DataSet ds = new DataSet();

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE201_SAVE_RECOMMEND";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RECOMMEND_ID", OracleDbType.Varchar2).Value = data["RECOMMEND_ID"].ToString();
                cmd.Parameters.Add("P_DESCRIPTION", OracleDbType.Varchar2).Value = data["DESCRIPTION"].ToString();
                cmd.Parameters.Add("P_SOS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["SOS_DATE"].ToString());
                cmd.Parameters.Add("P_DURATION_MONTH", OracleDbType.Int16).Value = data["DURATION_MONTH"];
                cmd.Parameters.Add("P_FILLRATE_OBJ", OracleDbType.Decimal).Value = data["FILLRATE_OBJ"];
                cmd.Parameters.Add("P_ACTIVE_FLAG", OracleDbType.Varchar2).Value = data["ACTIVE_FLAG"].ToString();
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);
                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE201_SaveData");
                return BadRequest();
            }
        }




        #endregion

        #region SNM081P

        [HttpGet, Route("SNM081P_GetOriginCode/{originCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM081P_GetOriginCode(string originCode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            originCode = ismoUtil.escapeCharacter(originCode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM081P_GET_ORIGIN_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ORIGIN_CODE", OracleDbType.Varchar2).Value = originCode.ToUpper() == "NULL" ? (object)DBNull.Value : originCode;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM081P_GetData")]
        [Authorize]
        public IHttpActionResult SNM081P_GetData([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM081P_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_ORIGIN_CODE", OracleDbType.Varchar2).Value = data["ORIGIN_CODE"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM081P_GetData");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNM081P_Update")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM081P_Update([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM081P_UPDATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ORIGIN_CODE", OracleDbType.Varchar2).Value = data["ORIGIN_CODE"].ToString();
            cmd.Parameters.Add("P_ORIGIN_NAME", OracleDbType.Varchar2).Value = data["ORIGIN_NAME"].ToString();
            cmd.Parameters.Add("P_ORIGIN_NAME2", OracleDbType.Varchar2).Value = data["ORIGIN_NAME2"].ToString();
            cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM081P";
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Ok("Done");
        }

        [HttpPost, Route("SNM081P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM081P_Delete([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM081P_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ORIGIN_CODE", OracleDbType.Varchar2).Value = data["ORIGIN_CODE"].ToString();
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        #endregion

        #region SNSE162

        [HttpGet, Route("SNSE162_getSourcingCode/{sourcingCode}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNSE162_getSourcingCode(string sourcingCode, string NoOfShowRecords)
        {
            try
            {
                DataSet ds = new DataSet();
                sourcingCode = ismoUtil.escapeCharacter(sourcingCode);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE162_SOURCING_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SOURCING_CODE", OracleDbType.Varchar2).Value = sourcingCode.ToUpper() == "NULL" ? (object)DBNull.Value : sourcingCode;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE162_getSourcingCode");
                return Json(new { Status = "Error" });

            }
        }

        [HttpGet, Route("SNSE162_getVendorCode/{VendorCode}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNSE162_getVendorCode(string VendorCode, string NoOfShowRecords)
        {
            try
            {
                DataSet ds = new DataSet();
                VendorCode = ismoUtil.escapeCharacter(VendorCode);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE162_VENDOR_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VendorCode.ToUpper() == "NULL" ? (object)DBNull.Value : VendorCode;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE162_getVendorCode");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpGet, Route("SNSE162_getOriginCode/{OriginCode}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNSE162_getOriginCode(string OriginCode, string NoOfShowRecords)
        {
            try
            {
                DataSet ds = new DataSet();
                OriginCode = ismoUtil.escapeCharacter(OriginCode);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE162_ORIGIN_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_ORIGIN_CODE", OracleDbType.Varchar2).Value = OriginCode.ToUpper() == "NULL" ? (object)DBNull.Value : OriginCode;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE162_getOriginCode");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE162_getSearch")]
        [Authorize]
        public IHttpActionResult SNSE162_getSearch([FromBody] dynamic pData)
        {
            try
            {

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE162_SEARCH";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SOURCING_CODE", OracleDbType.Varchar2).Value = pData.SOURCING_CODE;
                cmd.Parameters.Add("P_SOURCING_GROUP", OracleDbType.Varchar2).Value = pData.SOURCING_GROUP;
                cmd.Parameters.Add("P_ORIGIN_CODE", OracleDbType.Varchar2).Value = pData.ORIGIN_CODE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNSE162_Export_Excel")]
        public HttpResponseMessage SNSE162_Export_Excel(List<DataModel.SNSE162> dModel)
        {

            DataTable dt = new DataTable();
            string x = string.Empty;
            Console.WriteLine();
            string filename = "SNSE162.csv";
            string floderLocation = "SNSE162";


            dt.Columns.Add("colum1");

            dt.Rows.Add("ID;PO2C");
            dt.Rows.Add("B");
            dt.Rows.Add("C;X1;Y1;K\"Seq\"");
            dt.Rows.Add("C;X2;Y1;K\"Sourcing Code\"");
            dt.Rows.Add("C;X3;Y1;K\"Sourcing Group\"");
            dt.Rows.Add("C;X4;Y1;K\"Description\"");
            dt.Rows.Add("C;X5;Y1;K\"Vender Code\"");
            dt.Rows.Add("C;X6;Y1;K\"Origin Code\"");
            dt.Rows.Add("C;X7;Y1;K\"PFPM Register Status\"");
            dt.Rows.Add("C;X8;Y1;K\"Whole Vehicle List Register Status\"");
            dt.Rows.Add("C;X9;Y1;K\"Comments\"");
            dt.Rows.Add("C;X10;Y1;K\"Create By\"");
            dt.Rows.Add("C;X11;Y1;K\"Create Date\"");
            dt.Rows.Add("C;X12;Y1;K\"Last Update Program\"");
            dt.Rows.Add("C;X13;Y1;K\"Last Update By\"");
            dt.Rows.Add("C;X14;Y1;K\"Last Update Date\"");

            int countrow = 0;
            int itemno = 0;
            for (var i = 0; i < dModel.Count; i++)
            {
                countrow = i + 2;
                itemno = i + 1;
                dt.Rows.Add("C;X1;Y" + countrow + ";K" + '"' + dModel[i].SEQ + '"');
                dt.Rows.Add("C;X2;Y" + countrow + ";K" + '"' + dModel[i].SOURCING_CODE + '"');
                dt.Rows.Add("C;X3;Y" + countrow + ";K" + '"' + dModel[i].SOURCING_GROUP + '"');
                dt.Rows.Add("C;X4;Y" + countrow + ";K" + '"' + dModel[i].DESCRIPTION + '"');
                dt.Rows.Add("C;X5;Y" + countrow + ";K" + '"' + dModel[i].VENDOR_CODE + '"');
                dt.Rows.Add("C;X6;Y" + countrow + ";K" + '"' + dModel[i].ORIGIN_CODE + '"');
                dt.Rows.Add("C;X7;Y" + countrow + ";K" + '"' + dModel[i].PFPM_REGIS_STATUS + '"');
                dt.Rows.Add("C;X8;Y" + countrow + ";K" + '"' + dModel[i].WVL_REGIS_STATUS + '"');
                dt.Rows.Add("C;X9;Y" + countrow + ";K" + '"' + dModel[i].COMMENTS + '"');
                dt.Rows.Add("C;X10;Y" + countrow + ";K" + '"' + dModel[i].CREATE_BY + '"');
                dt.Rows.Add("C;X11;Y" + countrow + ";K" + '"' + dModel[i].CREATE_DATE + '"');
                dt.Rows.Add("C;X12;Y" + countrow + ";K" + '"' + dModel[i].LAST_UPD_PGM + '"');
                dt.Rows.Add("C;X13;Y" + countrow + ";K" + '"' + dModel[i].LAST_UPD_BY + '"');
                dt.Rows.Add("C;X14;Y" + countrow + ";K" + '"' + dModel[i].LAST_UPD_DATE + '"');


            }

            dt.Rows.Add("E");

            x = DataService.WriteCSVNoColumn(dt, filename, floderLocation);
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }

        #endregion

        #region SNSE155
        [HttpGet, Route("SNSE155_getCatalogModel/{catalogModel}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNSE155_getCatalogModel(string catalogModel, string NoOfShowRecords)
        {
            try
            {
                DataSet ds = new DataSet();
                catalogModel = ismoUtil.escapeCharacter(catalogModel);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE155_CATALOG_MODEL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CATALOG_MODEL_PFPM", OracleDbType.Varchar2).Value = catalogModel.ToUpper() == "NULL" ? (object)DBNull.Value : catalogModel;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE155_getCatalogModel");
                return Json(new { Status = "Error" });

            }
        }

        [HttpGet, Route("SNSE155_getMainModelPMS/{mainModelPMS}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNSE155_getMainModelPMS(string mainModelPMS, string NoOfShowRecords)
        {
            try
            {
                DataSet ds = new DataSet();
                mainModelPMS = ismoUtil.escapeCharacter(mainModelPMS);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE155_MAIN_MODEL_PMS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_MAIN_MODEL", OracleDbType.Varchar2).Value = mainModelPMS.ToUpper() == "NULL" ? (object)DBNull.Value : mainModelPMS;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE155_getMainModelPMS");
                return Json(new { Status = "Error" });

            }
        }


        [HttpPost, Route("SNSE155_getSearch")]
        [Authorize]
        public IHttpActionResult SNSE155_getSearch([FromBody] dynamic pData)
        {
            try
            {

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE155_SEARCH";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CATALOG_MODEL_PFPM", OracleDbType.Varchar2).Value = pData.CATALOG_MODEL_PFPM;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNSE155_Update")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNSE155_Update([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE155_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CATALOG_MODEL_PFPM", OracleDbType.Varchar2).Value = data.CATALOG_MODEL_PFPM;
                cmd.Parameters.Add("P_MAIN_MODEL_PMS", OracleDbType.Varchar2).Value = data.MAIN_MODEL_PMS;
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                string R_MESSAGE = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (R_STATUS == "FAIL")
                {
                    oOracledb.WriteLog("ErrorHandle", R_MESSAGE, "SNSE155_Update");
                }

                return Json(new { STATUS_MSG = R_STATUS, });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE155_Update");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNSE155_Insert")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNSE155_Insert([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE155_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CATALOG_MODEL_PFPM", OracleDbType.Varchar2).Value = data.CATALOG_MODEL_PFPM;
                cmd.Parameters.Add("P_MAIN_MODEL_PMS", OracleDbType.Varchar2).Value = data.MAIN_MODEL_PMS;
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                string R_MESSAGE = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (R_STATUS == "FAIL")
                {
                    oOracledb.WriteLog("ErrorHandle", R_MESSAGE, "SNSE155_Insert");
                }

                return Json(new { STATUS_MSG = R_STATUS, });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE155_Insert");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNSE155_Delete")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNSE155_Delete([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE155_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CATALOG_MODEL_PFPM", OracleDbType.Varchar2).Value = data.CATALOG_MODEL_PFPM;
                cmd.Parameters.Add("P_MAIN_MODEL_PMS", OracleDbType.Varchar2).Value = data.MAIN_MODEL_PMS;
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                string R_MESSAGE = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (R_STATUS == "FAIL")
                {
                    oOracledb.WriteLog("ErrorHandle", R_MESSAGE, "SNSE155_Delete");
                }

                return Json(new { STATUS_MSG = R_STATUS, });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE155_Delete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNSE155_Export_Excel")]
        public HttpResponseMessage SNSE155_Export_Excel(List<DataModel.SNSE155> dModel)
        {

            DataTable dt = new DataTable();
            string x = string.Empty;
            Console.WriteLine();
            string filename = "SNSE155.csv";
            string floderLocation = "SNSE155";


            dt.Columns.Add("colum1");

            dt.Rows.Add("ID;PO2C");
            dt.Rows.Add("B");
            dt.Rows.Add("C;X1;Y1;K\"Catalog Model (PFPM)\"");
            dt.Rows.Add("C;X2;Y1;K\"Main Model (PMS)\"");
            dt.Rows.Add("C;X3;Y1;K\"Main Model Name (PMS)\"");
            dt.Rows.Add("C;X4;Y1;K\"Create By\"");
            dt.Rows.Add("C;X5;Y1;K\"Create Date\"");
            dt.Rows.Add("C;X6;Y1;K\"Update By\"");
            dt.Rows.Add("C;X7;Y1;K\"Update Date\"");

            int countrow = 0;
            int itemno = 0;
            for (var i = 0; i < dModel.Count; i++)
            {
                countrow = i + 2;
                itemno = i + 1;
                dt.Rows.Add("C;X1;Y" + countrow + ";K" + '"' + dModel[i].CATALOG_MODEL_PFPM + '"');
                dt.Rows.Add("C;X2;Y" + countrow + ";K" + '"' + dModel[i].MAIN_MODEL_PMS + '"');
                dt.Rows.Add("C;X3;Y" + countrow + ";K" + '"' + dModel[i].MAIN_MODEL_NAME + '"');
                dt.Rows.Add("C;X4;Y" + countrow + ";K" + '"' + dModel[i].CREATE_BY + '"');
                dt.Rows.Add("C;X5;Y" + countrow + ";K" + '"' + dModel[i].CREATE_DATE + '"');
                dt.Rows.Add("C;X6;Y" + countrow + ";K" + '"' + dModel[i].LAST_UPD_BY + '"');
                dt.Rows.Add("C;X7;Y" + countrow + ";K" + '"' + dModel[i].LAST_UPD_DATE + '"');

            }

            dt.Rows.Add("E");

            x = DataService.WriteCSVNoColumn(dt, filename, floderLocation);
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }


        #endregion


        #region SNSE158
        [HttpGet, Route("SNSE158_getVendorCode/{vendorCode}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNSE158_getVendorCode(string vendorCode, string NoOfShowRecords)
        {
            try
            {
                DataSet ds = new DataSet();
                vendorCode = ismoUtil.escapeCharacter(vendorCode);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE158_VENDOR_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorCode.ToUpper() == "NULL" ? (object)DBNull.Value : vendorCode;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE158_getVendorCode");
                return Json(new { Status = "Error" });

            }
        }


        [HttpGet, Route("SNSE158_getPartNo/{partNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNSE158_getPartNo(string partNo, string NoOfShowRecords)
        {
            try
            {
                DataSet ds = new DataSet();
                partNo = ismoUtil.escapeCharacter(partNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE158_PART_NO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo.ToUpper() == "NULL" ? (object)DBNull.Value : partNo;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE158_getPartNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));

            }
        }

        [HttpPost, Route("SNSE158_getData")]
        [Authorize]
        public IHttpActionResult SNSE158_getData([FromBody] dynamic pData)
        {
            try
            {

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE158_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
                cmd.Parameters.Add("P_CREATE_PGM", OracleDbType.Varchar2).Value = pData.CREATE_PGM;
                cmd.Parameters.Add("P_UPD_STATUS", OracleDbType.Varchar2).Value = pData.UPD_STATUS;
                cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = pData.FROM_DATE == null ? (object)DBNull.Value : Convert.ToDateTime(pData.FROM_DATE);
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = pData.TO_DATE == null ? (object)DBNull.Value : Convert.ToDateTime(pData.TO_DATE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE158_getData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNSE158_Export_Excel")]
        public HttpResponseMessage SNSE158_Export_Excel(List<DataModel.SNSE158> dModel)
        {

            DataTable dt = new DataTable();
            string x = string.Empty;
            Console.WriteLine();
            string filename = "SNSE158.csv";
            string floderLocation = "SNSE158";


            dt.Columns.Add("colum1");

            dt.Rows.Add("ID;PO2C");
            dt.Rows.Add("B");
            dt.Rows.Add("C;X1;Y1;K\"Seq\"");
            dt.Rows.Add("C;X2;Y1;K\"Part No\"");
            dt.Rows.Add("C;X3;Y1;K\"Part Name\"");
            dt.Rows.Add("C;X4;Y1;K\"Group Part No\"");
            dt.Rows.Add("C;X5;Y1;K\"Approve Date\"");
            dt.Rows.Add("C;X6;Y1;K\"Local Vendor Code\"");
            dt.Rows.Add("C;X7;Y1;K\"Currency Code\"");
            dt.Rows.Add("C;X8;Y1;K\"Seq\"");
            dt.Rows.Add("C;X9;Y1;K\"Part No\"");
            dt.Rows.Add("C;X10;Y1;K\"Part Name\"");
            dt.Rows.Add("C;X11;Y1;K\"Group Part No\"");
            dt.Rows.Add("C;X12;Y1;K\"Approve Date\"");
            dt.Rows.Add("C;X13;Y1;K\"Local Vendor Code\"");
            dt.Rows.Add("C;X14;Y1;K\"Currency Code\"");
            dt.Rows.Add("C;X15;Y1;K\"Seq\"");
            dt.Rows.Add("C;X16;Y1;K\"Part No\"");
            dt.Rows.Add("C;X17;Y1;K\"Part Name\"");
            dt.Rows.Add("C;X18;Y1;K\"Group Part No\"");
            dt.Rows.Add("C;X19;Y1;K\"Approve Date\"");
            dt.Rows.Add("C;X20;Y1;K\"Local Vendor Code\"");
            dt.Rows.Add("C;X21;Y1;K\"Currency Code\"");

            int countrow = 0;
            int itemno = 0;
            for (var i = 0; i < dModel.Count; i++)
            {
                countrow = i + 2;
                itemno = i + 1;
                dt.Rows.Add("C;X1;Y" + countrow + ";K" + '"' + dModel[i].SEQ + '"');
                dt.Rows.Add("C;X2;Y" + countrow + ";K" + '"' + dModel[i].PART_NO + '"');
                dt.Rows.Add("C;X3;Y" + countrow + ";K" + '"' + dModel[i].PART_NAME_EN + '"');
                dt.Rows.Add("C;X4;Y" + countrow + ";K" + '"' + dModel[i].GROUP_PART_NO + '"');
                dt.Rows.Add("C;X5;Y" + countrow + ";K" + '"' + dModel[i].CREATE_DATE + '"');
                dt.Rows.Add("C;X6;Y" + countrow + ";K" + '"' + dModel[i].VENDOR_CODE + '"');
                dt.Rows.Add("C;X7;Y" + countrow + ";K" + '"' + dModel[i].CURRENCY_CODE + '"');
                dt.Rows.Add("C;X8;Y" + countrow + ";K" + '"' + dModel[i].EXCHANGE_RATE + '"');
                dt.Rows.Add("C;X9;Y" + countrow + ";K" + '"' + dModel[i].OLD_BASE_PRICE + '"');
                dt.Rows.Add("C;X10;Y" + countrow + ";K" + '"' + dModel[i].NEW_BASE_PRICE + '"');
                dt.Rows.Add("C;X11;Y" + countrow + ";K" + '"' + dModel[i].NEW_BASE_PRICE_TH + '"');
                dt.Rows.Add("C;X12;Y" + countrow + ";K" + '"' + dModel[i].OLD_STD_COST + '"');
                dt.Rows.Add("C;X13;Y" + countrow + ";K" + '"' + dModel[i].NEW_STD_COST + '"');
                dt.Rows.Add("C;X14;Y" + countrow + ";K" + '"' + dModel[i].OLD_RTL_PRICE + '"');
                dt.Rows.Add("C;X15;Y" + countrow + ";K" + '"' + dModel[i].NEW_RTL_PRICE + '"');
                dt.Rows.Add("C;X16;Y" + countrow + ";K" + '"' + dModel[i].SUGGEST_RTL_PRICE + '"');
                dt.Rows.Add("C;X17;Y" + countrow + ";K" + '"' + dModel[i].CONFIRM_RTL_PRICE + '"');
                dt.Rows.Add("C;X18;Y" + countrow + ";K" + '"' + dModel[i].ATTRIBUTE1 + '"');
                dt.Rows.Add("C;X19;Y" + countrow + ";K" + '"' + dModel[i].ATTRIBUTE2 + '"');
                dt.Rows.Add("C;X20;Y" + countrow + ";K" + '"' + dModel[i].CREATE_PGM + '"');
                dt.Rows.Add("C;X21;Y" + countrow + ";K" + '"' + dModel[i].UPD_STATUS + '"');

            }

            dt.Rows.Add("E");

            x = DataService.WriteCSVNoColumn(dt, filename, floderLocation);
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }

        [HttpPost, Route("SNSE158_getData_Export")]
        [Authorize]
        public HttpResponseMessage SNSE158_getData_Export([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE158_GET_DATA_EXPORT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE;
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
            cmd.Parameters.Add("P_CREATE_PGM", OracleDbType.Varchar2).Value = pData.CREATE_PGM;
            cmd.Parameters.Add("P_UPD_STATUS", OracleDbType.Varchar2).Value = pData.UPD_STATUS;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = pData.FROM_DATE == null ? (object)DBNull.Value : Convert.ToDateTime(pData.FROM_DATE);
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = pData.TO_DATE == null ? (object)DBNull.Value : Convert.ToDateTime(pData.TO_DATE);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            string x = SNSE158_ExportData(ds.Tables[0], "SNSE158.csv", "SNSE158");
            SystemApiController sys = new SystemApiController();
            var respons = sys.downloadFile(x.Substring(1), "SNSE158.csv");
            return respons;
        }

        public static string SNSE158_ExportData(DataTable dt, string fileName, string FloderLocation)
        {

            bool Succes = false;

            string gLocation = "~/tempFile/" + FloderLocation + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, fileName);
            string gReturnLocation = Path.Combine(gLocation, fileName);
            SystemApiController sys = new SystemApiController();
            try
            {
                StringBuilder sb = new StringBuilder();

                string[] HeaderForExport = new string[]
                {
                    "Seq.",
                    "Part No",
                    "Part Name",
                    "Group Part No",
                    "Approve Date",
                    "Local Vendor Code",
                    "Currency Code",
                    "Exchange Rate",
                    "Old Base Price",
                    "New Base Price",
                    "New Base Price (THB)",
                    "Old Stanard Cost (THB)",
                    "New Stanard Cost (THB)",
                    "Old Retail Price (THB)",
                    "New Retail Price (THB)",
                    "Suggest Retail Price (THB)",
                    "Confirm Retail Price (THB)",
                    "System",
                    "Update Status",
                };
                IEnumerable<string> columnNames = HeaderForExport.Select(h => h.ToString());
                sb.AppendLine(string.Join(",", columnNames));

                foreach (DataRow row in dt.Rows)
                {
                    for (int i = 0; i < dt.Columns.Count; i++)
                    {
                        if (i == 7 || i == 8 || i == 9 || i == 10 || i == 11 || i == 12 || i == 13 || i == 14 || i == 15 || i == 16)
                        {
                            sb.Append("=\"" + CsvEscape(row[i].ToString()) + "\"");
                            sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
                        }
                        else
                        {
                            sb.Append(CsvEscape(row[i].ToString()));
                            sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
                        }
                    }
                }

                File.WriteAllText(gFileLocation, sb.ToString());

                Succes = true;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }

            if (Succes)
            {
                return gReturnLocation;
            }
            else
            {

                return "";
            }

        }
        [HttpPost, Route("SNSE158_Update_Status_Y")]
        [Authorize]
        public IHttpActionResult SNSE158_Update_Status_Y([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE158_UPDATE_STATUS_Y";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data.VENDOR_CODE;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PART_NO;
                cmd.Parameters.Add("P_UPD_STATUS", OracleDbType.Varchar2).Value = data.UPD_STATUS;
                cmd.Parameters.Add("P_CONFIRM_RTL_PRICE", OracleDbType.Varchar2).Value = data.CONFIRM_RTL_PRICE;
                cmd.Parameters.Add("P_DSP_CONFIRM_RTL_PRICE", OracleDbType.Varchar2).Value = data.DSP_CONFIRM_RTL_PRICE;
                cmd.Parameters.Add("P_ATTRIBUTE2", OracleDbType.Varchar2).Value = data.ATTRIBUTE2;
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE158";
                cmd.Parameters.Add("P_IP_ADD", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
            }
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNSE158_Update_Status_C")]
        [Authorize]
        public IHttpActionResult SNSE158_Update_Status_C([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE158_UPDATE_STATUS_C";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = data.VENDOR_CODE;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PART_NO;
                cmd.Parameters.Add("P_UPD_STATUS", OracleDbType.Varchar2).Value = data.UPD_STATUS;
                cmd.Parameters.Add("P_CREATE_DATE", OracleDbType.Date).Value = data.CREATE_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
            }
            return Json(DTFM.convertToList(ds));
        }
        #endregion
        #region SNPE048
        [HttpPost, Route("SNPE048_Upload_Suggest")]
        [Authorize]
        public async Task<IHttpActionResult> SNPE048_Upload_Suggest(HttpRequestMessage request)
        {

            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }

            var reqParts = await request.Content.ReadAsMultipartAsync();
            var name = reqParts.Contents[1].ReadAsByteArrayAsync();
            var type = Encoding.UTF8.GetString(name.Result, 0, name.Result.Length);
            List<string> ErrorList = new List<string>();
            try
            {
                string fileLocation = string.Empty;
                string gFileName = string.Empty;


                var file = reqParts.Contents[0];
                var buffer = await file.ReadAsByteArrayAsync();
                string fileName = Path.GetFileNameWithoutExtension(file.Headers.ContentDisposition.FileName.Trim('\"'));
                string ext = Path.GetExtension(file.Headers.ContentDisposition.FileName.Trim('\"'));
                string FullfileName = String.Concat(fileName, "-", DateTime.Now.ToString("yyyyMMddHHmm"), ext);
                string outputLocation = "~/tempFile/" + "SNPE048" + "/";
                string outputPath = System.Web.HttpContext.Current.Server.MapPath(outputLocation);
                fileLocation = String.Concat(outputPath, FullfileName);
                gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');

                DataService.SaveBytesToFileByLocation(buffer
                                                , fileLocation
                                                , fileLocation);

                ErrorList = SNPE048_InsertDataFromExcelFile(fileLocation, gFileName, FullfileName);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE048_Upload_Suggest");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            return Json(new { Error = ErrorList });
        }

        public List<string> SNPE048_InsertDataFromExcelFile(string fileLocation, string gFileName, string FullfileName)
        {
            string fileLocationN = fileLocation;
            string gFileNameN = gFileName;
            string FullfileNameN = FullfileName;
            DataTable dt = new DataTable();
            SystemApiController sys = new SystemApiController();
            dt = sys.ReadDataExcel(fileLocationN);
            List<string> ErrList = new List<string>();
            int countrow = 1;
            OracleCommand cmd = new OracleCommand();
            DataSet ds = new DataSet();

            try
            {
                cmd.CommandText = "SP_NP_SNPE048_CLEAR_TEMP_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE048_InsertDataFromExcelFile_Import");
                ErrList.Add("Error : SP_NP_SNPE048_CLEAR_TEMP please recheck");
                return ErrList;
            }

            foreach (DataRow row in dt.Rows)
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE048_UPLOAD_SUGGEST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = row["Vendor Code"].ToString().Trim();
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = row["Part No"].ToString().Trim();
                cmd.Parameters.Add("P_LOCK_PO", OracleDbType.Varchar2).Value = row["Lock PO"].ToString().Trim();
                cmd.Parameters.Add("P_CONFIRM_QTY", OracleDbType.Varchar2).Value = row["Confirm Suggest Qty"].ToString().Trim();
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_FILE_NAME", OracleDbType.Varchar2).Value = FullfileNameN;
                cmd.Parameters.Add("P_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string status = cmd.Parameters["P_STATUS"].Value.ToString();

                countrow++;
            }
            return ErrList;
        }

        [HttpPost, Route("SNPE048_GetTempData")]
        [Authorize]
        public IHttpActionResult SNPE048_GetTempData([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd.CommandText = "SP_NP_SNPE048_GET_TEMP_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SP_NP_SNPE048_GET_TEMP_DATA");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNPE048_ConfirmSuggest")]
        [Authorize]
        public IHttpActionResult SNPE048_ConfirmSuggest([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd.CommandText = "SP_NP_SNPE048_CONFIRM_SUGGEST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SP_NP_SNPE048_CONFIRM_SUGGEST");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }





        [HttpPost, Route("SNPE048_ClearTemp")]
        [Authorize]
        public IHttpActionResult SNPE048_ClearTemp([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd.CommandText = "SP_NP_SNPE048_CLEAR_TEMP_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SP_NP_SNPE048_CLEAR_TEMP_DATA");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion

        #region SNPE049


        [HttpPost, Route("SNPE049_Upload")]
        //[Authorize]
        public async Task<IHttpActionResult> SNPE049_Upload(HttpRequestMessage request)
        {

            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }

            var reqParts = request.Content.ReadAsMultipartAsync().Result;
            try
            {
                string fileLocation = string.Empty;

                foreach (var file in reqParts.Contents)
                {
                    var buffer = file.ReadAsByteArrayAsync().Result;
                    string fileName = Path.GetFileNameWithoutExtension(file.Headers.ContentDisposition.FileName.Trim('\"'));
                    string ext = Path.GetExtension(file.Headers.ContentDisposition.FileName.Trim('\"'));
                    string FullfileName = String.Concat(fileName, "-", DateTime.Now.ToString("yyyyMMddHHmm"), ext);
                    string outputLocation = "~/tempFile/SNPE049/";
                    string outputPath = System.Web.HttpContext.Current.Server.MapPath(outputLocation);
                    fileLocation = String.Concat(outputPath, FullfileName);

                    DataService.SaveBytesToFileByLocation(buffer
                                                    , fileLocation
                                                    , fileLocation);
                }

                SNPE049_InsertDataFromExcelFile(fileLocation);

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE049_TEMP_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(new
                {
                    status = "Done",
                    data = DTFM.convertToList(ds)
                });
            }
            catch (OracleException ex)
            {
                var ErrorMsg = oOracledb.GetErrorMessage(ex);
                oOracledb.WriteLog("ErrorHandle", ErrorMsg, "SNPE049_Upload");
                return Json(new
                {
                    status = "Fail",
                    message = ErrorMsg
                });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE049_Upload");
                //throw new HttpResponseException(HttpStatusCode.NotAcceptable);
                return Json(new
                {
                    status = "Fail",
                    message = ex
                });
            }

        }

        [HttpPost, Route("SNPE049_Save_Upload")]
        [Authorize]
        public async Task<IHttpActionResult> SNPE049_Save_Upload(HttpRequestMessage request)
        {

            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }

            var reqParts = request.Content.ReadAsMultipartAsync().Result;
            try
            {
                string fileLocation = string.Empty;

                foreach (var file in reqParts.Contents)
                {
                    var buffer = file.ReadAsByteArrayAsync().Result;
                    string fileName = Path.GetFileNameWithoutExtension(file.Headers.ContentDisposition.FileName.Trim('\"'));
                    string ext = Path.GetExtension(file.Headers.ContentDisposition.FileName.Trim('\"'));
                    string FullfileName = String.Concat(fileName, "-", DateTime.Now.ToString("yyyyMMddHHmm"), ext);
                    string outputLocation = "~/tempFile/SNPE049/";
                    string outputPath = System.Web.HttpContext.Current.Server.MapPath(outputLocation);
                    fileLocation = String.Concat(outputPath, FullfileName);

                    DataService.SaveBytesToFileByLocation(buffer
                                                    , fileLocation
                                                    , fileLocation);
                }

                SNPE049_InsertDataFromExcelFile(fileLocation);

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE049_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);

                return Json(new
                {
                    status = "Done"
                });
            }
            catch (OracleException ex)
            {
                var ErrorMsg = oOracledb.GetErrorMessage(ex);
                oOracledb.WriteLog("ErrorHandle", ErrorMsg, "SNPE049_Save_Upload");
                return Json(new
                {
                    status = "Fail",
                    message = ErrorMsg
                });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE049_Save_Upload");
                return Json(new
                {
                    status = "Fail",
                    message = ex
                });
            }

        }

        public void SNPE049_InsertDataFromExcelFile(string fileLocation)
        {
            SystemApiController sys = new SystemApiController();
            OracleCommand cmd;
            string fileLocationN = fileLocation;
            int countrow = 0;
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE049_TEMP_DEL";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlQueryReturnValue(cmd);

                DataTable fileDataTable = sys.ReadDataExcel(fileLocationN);

                foreach (DataRow row in fileDataTable.Rows)
                {
                    countrow++;

                    string PONo = row["PO No."].ToString().Trim();
                    string ItemNo = row["Item No."].ToString();
                    string PartNo = row["Part No."].ToString().Trim();
                    string AcceptQty = row["Accept QTY"].ToString();
                    string EtdDate = Convert.ToDateTime(row["ETD Date (dd-Mon-yy)"]).ToString("dd-MMM-yy") ?? "";

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE049_TEMP_UPLOAD";
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = PONo;
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = ItemNo;
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PartNo;
                    cmd.Parameters.Add("P_ACCEPT_QTY", OracleDbType.Varchar2).Value = AcceptQty;
                    cmd.Parameters.Add("P_ETD_DATE", OracleDbType.Varchar2).Value = EtdDate;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE049_InsertDataFromExcelFile");
                throw (ex);
            }
        }

        #endregion
        #region SNPE050
        [HttpPost, Route("SNPE050_Upload")]
        [Authorize]
        public async Task<IHttpActionResult> SNPE050_Upload(HttpRequestMessage request)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();
            var name = reqParts.Contents[1].ReadAsByteArrayAsync();
            var option = Encoding.UTF8.GetString(name.Result, 0, name.Result.Length);
            List<string> ErrorList = new List<string>();
            try
            {
                string fileLocation = string.Empty;
                var file = reqParts.Contents[0];
                var buffer = await file.ReadAsByteArrayAsync();
                string fileName = Path.GetFileNameWithoutExtension(file.Headers.ContentDisposition.FileName.Trim('\"'));
                string ext = Path.GetExtension(file.Headers.ContentDisposition.FileName.Trim('\"'));
                string FullfileName = String.Concat(fileName, "-", DateTime.Now.ToString("yyyyMMddHHmm"), ext);
                string outputLocation = "~/tempFile/" + "SNPE050" + "/";
                string outputPath = System.Web.HttpContext.Current.Server.MapPath(outputLocation);
                fileLocation = String.Concat(outputPath, FullfileName);
                DataService.SaveBytesToFileByLocation(buffer
                                                , fileLocation
                                                , fileLocation);
                ErrorList = SNPE050_InsertDataFromExcelFile(fileLocation, option);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE050_Upload");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
            return Json(new { Error = ErrorList });
        }
        public string SNPE050_ClearTemp()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE050_CLEAR_TEMP";
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return "DONE";
        }
        public List<string> SNPE050_InsertDataFromExcelFile(string fileLocation, string option)
        {
            string fileLocationN = fileLocation;
            string optionN = option;
            DataTable dt = new DataTable();
            SystemApiController sys = new SystemApiController();
            dt = sys.ReadDataExcel(fileLocationN);
            List<string> ErrList = new List<string>();
            SNPE050_ClearTemp();
            foreach (DataRow row in dt.Rows)
            {
                string p1 = null;
                string p2 = null;
                string p3 = null;
                string p4 = null;
                p1 = row["PART_NO"].ToString().Trim();
                p2 = row["MAIN_MODEL"].ToString().Trim();
                p3 = row["VENDOR_CODE"].ToString().Trim();
                p4 = row["ORDER_QTY"].ToString().Trim();
                if (p1 != null && p2 != null && p3 != null && p4 != null)
                {
                    OracleCommand cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE050_VALIDATE_UPL";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = p1;
                    cmd.Parameters.Add("P_MAIN_MODEL", OracleDbType.Varchar2).Value = p2;
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = p3;
                    cmd.Parameters.Add("P_ORDER_QTY", OracleDbType.Varchar2).Value = p4;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }
            }
            return ErrList;
        }
        [HttpGet, Route("SNPE050_GetTempData")]
        [Authorize]
        public IHttpActionResult SNPE050_GetTempData()
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE050_GET_TEMP_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE050_GetTempData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNPE050_BeginProcess")]
        [Authorize]
        public IHttpActionResult SNPE050_BeginProcess([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            string returnMessage;
            string status;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "PK_NP_SNPE050_CREATE_PO.MAIN_PROCESS";
            cmd.Parameters.Add("VPARAM_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("VPARAM_PGM", OracleDbType.Varchar2).Value = "SNPE050";
            cmd.Parameters.Add("VPARAM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("VPARAM_ORDER_TYPE", OracleDbType.Varchar2).Value = param.ORDER_TYPE;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_PO_RANGE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            DataTable dtProcessStatus = ds.Tables[0];
            returnMessage = dtProcessStatus.Rows[0]["MESSAGE"].ToString();
            status = dtProcessStatus.Rows[0]["STATUS"].ToString();
            if (status == "FAIL")
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, returnMessage));
            }
            else if (status == "DONE")
            {
                DataTable dtPORange = ds.Tables[1];
                return Ok(new { START_PO = dtPORange.Rows[0]["START_PO"], END_PO = dtPORange.Rows[0]["END_PO"] });
            }
            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, "Something wrong in process."));
        }
        #endregion
        [HttpPost, Route("SNM141P_UploadExcel")]
        [Authorize]
        public async Task<IHttpActionResult> SNM141P_UploadExcel(HttpRequestMessage request)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                oOracledb.WriteLog("ErrorHandle", "UnsupportedMediaType", "SNM141P_UploadExcel");
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                string USER_ID = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                var file = reqParts.Contents[0];
                var buffer = await file.ReadAsByteArrayAsync();
                string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                string name = Path.GetFileNameWithoutExtension(gFileName);
                string ext = Path.GetExtension(gFileName);
                string gFileNameExtend = String.Concat(name, '_', USER_ID, ext);
                string gRootPath = ConfigurationManager.AppSettings["RootSharedPath"].ToString();
                string gUploadLocation = System.IO.Path.Combine(gRootPath, "tempFile/SNM141P");
                string gFileLocation = System.IO.Path.Combine(gUploadLocation, gFileName);
                DataService.SaveBytesToFileByLocation(buffer
                                                , gUploadLocation
                                                , gFileLocation);
                SystemApiController sys = new SystemApiController();
                dt = SNM141P_Validate(gFileLocation);
                return Json(DTFM.convertToList(dt));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM141P_UploadExcel");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
            throw new Exception("Something wrong");
        }
        public DataTable SNM141P_Validate(string filelocation)
        {
            DataTable dt = new DataTable();
            SystemApiController sys = new SystemApiController();
            dt = sys.ReadDataExcel(filelocation);
            dt.Columns.Add("SEQ");
            dt.Columns.Add("PART_NAME_EN");
            dt.Columns.Add("LOCK_SALES_EN");
            dt.Columns.Add("LOCK_PO_EN");
            dt.Columns.Add("MSG");
            dt.Columns.Add("ERR_MSG_LS");
            dt.Columns.Add("ERR_MSG_LP");
            dt.Columns.Add("ERR_FLAG");
            dt.Columns.Add("ERR_FLAG_PART");
            dt.Columns.Add("ERR_FLAG_LS");
            dt.Columns.Add("ERR_FLAG_LP");
            dt.Columns.Add("OLD_LOCK_SALES");
            dt.Columns.Add("OLD_LOCK_PO");
            int iCount = 0;
            Hashtable hTable = new Hashtable();
            OracleCommand cmd = new OracleCommand();
            foreach (DataRow d in dt.Rows)
            {
                if (!string.IsNullOrEmpty(d["PART_NO"].ToString()))
                {
                    iCount++;
                    try
                    {
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNM141P_VALIDATE";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"];
                        cmd.Parameters.Add("P_LOCK_SALES", OracleDbType.Varchar2).Value = d["LOCK_SALES"];
                        cmd.Parameters.Add("P_LOCK_PO", OracleDbType.Varchar2).Value = d["LOCK_PO"];
                        cmd.Parameters.Add("P_JOB_TYPE_SALES", OracleDbType.Int16).Value = 0;
                        cmd.Parameters.Add("P_JOB_TYPE_PO", OracleDbType.Int16).Value = 2;
                        cmd.Parameters.Add("R_PART_NAME", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_LOCK_SALES", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_LOCK_PO", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;                        
                        cmd.Parameters.Add("R_ERROR_FLAG", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;                        
                        cmd.Parameters.Add("R_ERROR_FLAG_PART_NO", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;                        
                        cmd.Parameters.Add("R_ERROR_FLAG_LS", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;                       
                        cmd.Parameters.Add("R_ERROR_FLAG_LP", OracleDbType.Varchar2, 1).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERROR_MESSAGE", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERROR_MSG_LS", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERROR_MSG_LP", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_OLD_LOCK_SALES", OracleDbType.Varchar2, 3).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_OLD_LOCK_PO", OracleDbType.Varchar2, 3).Direction = ParameterDirection.Output;
                        cmd = oOracledb.SqlQueryReturnValue(cmd);
                        string PART_NAME_EN = cmd.Parameters["R_PART_NAME"].Value.ToString() == "null" ? "" : cmd.Parameters["R_PART_NAME"].Value.ToString();
                        string LOCK_SALES_EN = cmd.Parameters["R_LOCK_SALES"].Value.ToString() == "null" ? "" : cmd.Parameters["R_LOCK_SALES"].Value.ToString();
                        string LOCK_PO_EN = cmd.Parameters["R_LOCK_PO"].Value.ToString() == "null" ? "" : cmd.Parameters["R_LOCK_PO"].Value.ToString();                        
                        string ERROR_FLAG = cmd.Parameters["R_ERROR_FLAG"].Value.ToString();
                        string ERROR_FLAG_PART_NO = cmd.Parameters["R_ERROR_FLAG_PART_NO"].Value.ToString();
                        string ERROR_FLAG_LOCK_SALES = cmd.Parameters["R_ERROR_FLAG_LS"].Value.ToString();
                        string ERROR_FLAG_LOCK_PO = cmd.Parameters["R_ERROR_FLAG_LP"].Value.ToString();
                        string MSG = cmd.Parameters["R_ERROR_MESSAGE"].Value.ToString() == "null" ? (string)null : cmd.Parameters["R_ERROR_MESSAGE"].Value.ToString();
                        string ERROR_MSG_LS = cmd.Parameters["R_ERROR_MSG_LS"].Value.ToString() == "null" ? (string)null : cmd.Parameters["R_ERROR_MSG_LS"].Value.ToString();
                        string ERROR_MSG_LP = cmd.Parameters["R_ERROR_MSG_LP"].Value.ToString() == "null" ? (string)null : cmd.Parameters["R_ERROR_MSG_LP"].Value.ToString();
                        d["SEQ"] = iCount;
                        d["PART_NAME_EN"] = PART_NAME_EN;
                        d["LOCK_SALES_EN"] = LOCK_SALES_EN;
                        d["LOCK_PO_EN"] = LOCK_PO_EN;
                        d["ERR_FLAG"] = ERROR_FLAG;
                        d["ERR_FLAG_PART"] = ERROR_FLAG_PART_NO;
                        d["ERR_FLAG_LS"] = ERROR_FLAG_LOCK_SALES;
                        d["ERR_FLAG_LP"] = ERROR_FLAG_LOCK_PO;
                        d["MSG"] = MSG;
                        d["ERR_MSG_LS"] = ERROR_MSG_LS;
                        d["ERR_MSG_LP"] = ERROR_MSG_LP;
                        d["OLD_LOCK_SALES"] = cmd.Parameters["R_OLD_LOCK_SALES"].Value.ToString() == "null" ? "" : cmd.Parameters["R_OLD_LOCK_SALES"].Value.ToString(); ;
                        d["OLD_LOCK_PO"] = cmd.Parameters["R_OLD_LOCK_PO"].Value.ToString() == "null" ? "" : cmd.Parameters["R_OLD_LOCK_PO"].Value.ToString(); ;
                        if (hTable.Contains(d["PART_NO"].ToString().Trim()))
                        {
                            d["SEQ"] = iCount;
                            d["PART_NAME_EN"] = PART_NAME_EN;
                            d["LOCK_SALES_EN"] = LOCK_SALES_EN;
                            d["LOCK_PO_EN"] = LOCK_PO_EN;
                            d["MSG"] = "Duplicate Part No at Seq " + hTable[d["PART_NO"]];                            
                            d["ERR_FLAG"] = "Y";
                            d["ERR_FLAG_LS"] = "Y";
                            d["ERR_FLAG_LP"] = "Y";
                            d["ERR_MSG_LS"] = "Duplicate Part No at Seq " + hTable[d["PART_NO"]];
                            d["ERR_MSG_LP"] = "Duplicate Part No at Seq " + hTable[d["PART_NO"]];
                        }
                        else
                        {
                            hTable.Add(d["PART_NO"].ToString().Trim(), iCount);
                        }
                    }
                    catch (Exception ex)
                    {
                        oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM141P_Validate");
                        throw new HttpResponseException(HttpStatusCode.NotAcceptable);
                    }
                }
            }
            return dt;
        }
        [HttpPost, Route("SNM141P_UpdateData")]
        [Authorize]
        public IHttpActionResult SNM141P_UpdateData([FromBody] dynamic data)
        {                       
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                OracleCommand cmd = new OracleCommand();
                int iCount = 0;
                foreach (dynamic d in data.DETAIL)
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM141P_SAVE_TEMP";
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"];
                    cmd.Parameters.Add("P_LOCK_SALES", OracleDbType.Varchar2).Value = d["LOCK_SALES"];
                    cmd.Parameters.Add("P_LOCK_PO", OracleDbType.Varchar2).Value = d["LOCK_PO"];
                    cmd.Parameters.Add("P_ERR_FLAG_LS", OracleDbType.Varchar2).Value = d["ERR_FLAG_LS"];
                    cmd.Parameters.Add("P_ERR_FLAG_LP", OracleDbType.Varchar2).Value = d["ERR_FLAG_LP"];
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM141P_UPDATE_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_IS_LOCK_SALES", OracleDbType.Varchar2).Value = data.IS_LOCK_SALES;
                cmd.Parameters.Add("P_IS_LOCK_PO", OracleDbType.Varchar2).Value = data.IS_LOCK_PO;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM141P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDRESS", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();
                if (r_status != "DONE")
                {
                    oOracledb.WriteLog("ErrorHandle", r_msg, "SNM141P_UpdateData");
                }
                return Json(new { STATUS = r_status, MESSAGE = r_msg });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM141P_UpdateData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        #region SNM147

        [HttpGet, Route("SNM147_GetVendorCode/{vendorcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM147_GetVendorCode(string vendorcode, int noofshowrec)
        {
            try
            {
                vendorcode = ismoUtil.escapeCharacter(vendorcode);

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM147_GET_VENDOR";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode.ToUpper() == "NULL" ? (object)DBNull.Value : vendorcode;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM147_GetVendorCode");
                return Json(new { Status = "Error" });
            }
        }

        [HttpGet, Route("SNM147_GetData/{vendorcode}")]
        [Authorize]
        public IHttpActionResult SNM147_GetData(string vendorcode)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM147_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode.ToUpper() == "NULL" ? (object)DBNull.Value : vendorcode;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(new { result = "Done", message = "Done", set = DTFM.convertToList(ds) });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM147_GetData");
                return Json(new { result = "Error", message = ex.Message });
            }
        }

        [HttpPost, Route("SNM147_Insert")]
        [Authorize]
        public IHttpActionResult SNM147_Insert([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();

                OracleCommand cmd = new OracleCommand();
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM147_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_STATUS", OracleDbType.Varchar2).Value = pParam["STATUS"];
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Json(new { result = r_status, message = "Done" });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM147_Insert");
                return Json(new { result = "Fail", message = ex.Message });
            }
        }

        [HttpPost, Route("SNM147_Update")]
        [Authorize]
        public IHttpActionResult SNM147_Update([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();

                OracleCommand cmd = new OracleCommand();
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM147_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_STATUS", OracleDbType.Varchar2).Value = pParam["STATUS"];
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Json(new { result = r_status, message = "Done" });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM147_Update");
                return Json(new { result = "Fail", message = ex.Message });
            }
        }

        [HttpPost, Route("SNM147_Delete")]
        [Authorize]
        public IHttpActionResult SNM147_Delete([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();

                OracleCommand cmd = new OracleCommand();
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM147_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Json(new { result = r_status, message = "Done" });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM147_Delete");
                return Json(new { result = "Fail", message = ex.Message });
            }
        }

        #endregion



        #region SNM148

        [HttpGet, Route("SNM148_GetPartCategoryAll/{partcategory}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM148_GetPartCategoryAll(string partcategory, int noofshowrec)
        {
            try
            {
                partcategory = ismoUtil.escapeCharacter(partcategory);

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM148_GET_CATEGORY_ALL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = partcategory.ToUpper() == "NULL" ? (object)DBNull.Value : partcategory;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM148_GetPartCategoryAll");
                return Json(new { Status = "Error" });
            }
        }


        [HttpGet, Route("SNM148_GetPartCategory/{partcategory}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM148_GetPartCategory(string partcategory, int noofshowrec)
        {
            try
            {
                partcategory = ismoUtil.escapeCharacter(partcategory);

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM148_GET_CATEGORY";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = partcategory.ToUpper() == "NULL" ? (object)DBNull.Value : partcategory;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM148_GetPartCategory");
                return Json(new { Status = "Error" });
            }
        }
        [HttpGet, Route("SNM148_GetData/{partcategory}")]
        [Authorize]
        public IHttpActionResult SNM148_GetData(string partcategory)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM148_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = partcategory.ToUpper() == "NULL" ? (object)DBNull.Value : partcategory;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(new { result = "Done", message = "Done", set = DTFM.convertToList(ds) });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM148_GetData");
                return Json(new { result = "Error", message = ex.Message });
            }
        }

        [HttpPost, Route("SNM148_Insert")]
        [Authorize]
        public IHttpActionResult SNM148_Insert([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();

                OracleCommand cmd = new OracleCommand();
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM148_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pParam["PART_CATEGORY"];
                cmd.Parameters.Add("P_STATUS", OracleDbType.Varchar2).Value = pParam["STATUS"];
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Json(new { result = r_status, message = "Done" });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM148_Insert");
                return Json(new { result = "Fail", message = ex.Message });
            }
        }

        [HttpPost, Route("SNM148_Update")]
        [Authorize]
        public IHttpActionResult SNM148_Update([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();

                OracleCommand cmd = new OracleCommand();
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM148_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pParam["PART_CATEGORY"];
                cmd.Parameters.Add("P_STATUS", OracleDbType.Varchar2).Value = pParam["STATUS"];
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Json(new { result = r_status, message = "Done" });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM148_Update");
                return Json(new { result = "Fail", message = ex.Message });
            }
        }

        [HttpPost, Route("SNM148_Delete")]
        [Authorize]
        public IHttpActionResult SNM148_Delete([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();

                OracleCommand cmd = new OracleCommand();
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM148_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pParam["PART_CATEGORY"];
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Json(new { result = r_status, message = "Done" });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM148_Delete");
                return Json(new { result = "Fail", message = ex.Message });
            }
        }

        #endregion
    }
}
